-- Markets
-- by Hansi-TWZ
-- DE333-SERVER.EU
-- Credits to MewMew (Comfy)

local function shuffle(tbl)
	local size = #tbl
		for i = size, 1, -1 do
			local rand = math.random(size)
			tbl[i], tbl[rand] = tbl[rand], tbl[i]
		end
	return tbl
end

function markets(event)
	local math_random = math.random
	local surface = event.surface
	
	local market_items_1 = {			
		
		{price = {{"coin", math_random(1,4)}}, offer = {type = 'give-item', item = 'raw-fish', count = 5}},
		{price = {{"coin", math_random(4,8)}}, offer = {type = 'give-item', item = 'transport-belt'}},
		{price = {{"coin", math_random(20,40)}}, offer = {type = 'give-item', item = 'underground-belt', count = 2}},
		{price = {{"coin", math_random(45,70)}}, offer = {type = 'give-item', item = 'splitter'}},
		{price = {{"coin", math_random(20,40)}}, offer = {type = 'give-item', item = 'fast-transport-belt'}},
		{price = {{"coin", math_random(45,70)}}, offer = {type = 'give-item', item = 'fast-underground-belt', count = 2}},
		{price = {{"coin", math_random(75,100)}}, offer = {type = 'give-item', item = 'fast-splitter'}},
		{price = {{"coin", math_random(200,300)}}, offer = {type = 'give-item', item = 'express-transport-belt'}},
		{price = {{"coin", math_random(450,700)}}, offer = {type = 'give-item', item = 'express-underground-belt', count = 2}},
		{price = {{"coin", math_random(750,1000)}}, offer = {type = 'give-item', item = 'express-splitter'}},
		{price = {{"coin", math_random(100,200)}}, offer = {type = 'give-item', item = 'loader'}},
		{price = {{"coin", math_random(200,300)}}, offer = {type = 'give-item', item = 'fast-loader'}},
		{price = {{"coin", math_random(300,500)}}, offer = {type = 'give-item', item = 'express-loader'}},
		{price = {{"coin", math_random(4,8)}}, offer = {type = 'give-item', item = 'inserter'}},
		{price = {{"coin", math_random(12,20)}}, offer = {type = 'give-item', item = 'long-handed-inserter'}},
		{price = {{"coin", math_random(20,30)}}, offer = {type = 'give-item', item = 'fast-inserter'}},
		{price = {{"coin", math_random(32,40)}}, offer = {type = 'give-item', item = 'filter-inserter'}},
		{price = {{"coin", math_random(120,160)}}, offer = {type = 'give-item', item = 'stack-inserter'}},
		{price = {{"coin", math_random(180,200)}}, offer = {type = 'give-item', item = 'stack-filter-inserter'}}
		
	}
	
	local market_items_2 = {			
		
		{price = {{"coin", math_random(1,4)}}, offer = {type = 'give-item', item = 'raw-fish', count = 5}},
		{price = {{"coin", math_random(20,40)}}, offer = {type = 'give-item', item = 'stone-furnace'}},
		{price = {{"coin", math_random(100,200)}}, offer = {type = 'give-item', item = 'steel-furnace'}},
		{price = {{"coin", math_random(300,600)}}, offer = {type = 'give-item', item = 'electric-furnace'}},
		{price = {{"coin", math_random(200,400)}}, offer = {type = 'give-item', item = 'assembling-machine-1'}},
		{price = {{"coin", math_random(200,400)}}, offer = {type = 'give-item', item = 'assembling-machine-2'}},
		{price = {{"coin", math_random(800,1500)}}, offer = {type = 'give-item', item = 'assembling-machine-3'}},
		{price = {{"coin", math_random(4,8)}}, offer = {type = 'give-item', item = 'small-electric-pole'}},
		{price = {{"coin", math_random(20,30)}}, offer = {type = 'give-item', item = 'medium-electric-pole'}},
		{price = {{"coin", math_random(180,300)}}, offer = {type = 'give-item', item = 'substation'}},
		{price = {{"coin", math_random(4,8)}}, offer = {type = 'give-item', item = 'pipe'}},
		{price = {{"coin", math_random(20,30)}}, offer = {type = 'give-item', item = 'pipe-to-ground', count = 2}},
		{price = {{"coin", math_random(20,30)}}, offer = {type = 'give-item', item = 'pump'}},
		{price = {{"coin", math_random(4,8)}}, offer = {type = 'give-item', item = 'landfill'}},
		{price = {{"coin", math_random(4,8)}}, offer = {type = 'give-item', item = 'concrete'}},
		{price = {{"coin", math_random(4,8)}}, offer = {type = 'give-item', item = 'hazard-concrete'}},
		{price = {{"coin", math_random(30,40)}}, offer = {type = 'give-item', item = 'refined-concrete'}},
		{price = {{"coin", math_random(30,40)}}, offer = {type = 'give-item', item = 'refined-hazard-concrete'}},
		{price = {{"coin", math_random(240,360)}}, offer = {type = 'give-item', item = 'cliff-explosives'}}
	}
	
	local market_items_3 = {			
		
		{price = {{"coin", math_random(1,4)}}, offer = {type = 'give-item', item = 'raw-fish', count = 5}},
		{price = {{"coin", math_random(2400,5000)}}, offer = {type = 'give-item', item = 'roboport'}},
		{price = {{"coin", math_random(400,800)}}, offer = {type = 'give-item', item = 'logistic-chest-active-provider'}},
		{price = {{"coin", math_random(400,800)}}, offer = {type = 'give-item', item = 'logistic-chest-passive-provider'}},
		{price = {{"coin", math_random(400,800)}}, offer = {type = 'give-item', item = 'logistic-chest-storage'}},
		{price = {{"coin", math_random(400,800)}}, offer = {type = 'give-item', item = 'logistic-chest-buffer'}},
		{price = {{"coin", math_random(400,800)}}, offer = {type = 'give-item', item = 'logistic-chest-requester'}},
		{price = {{"coin", math_random(60,120)}}, offer = {type = 'give-item', item = 'construction-robot'}},
		{price = {{"coin", math_random(120,180)}}, offer = {type = 'give-item', item = 'logistic-robot'}},
		{price = {{"coin", math_random(1,4)}}, offer = {type = 'give-item', item = 'wooden-chest'}},
		{price = {{"coin", math_random(6,10)}}, offer = {type = 'give-item', item = 'iron-chest'}},
		{price = {{"coin", math_random(80,140)}}, offer = {type = 'give-item', item = 'steel-chest'}},
		{price = {{"coin", math_random(4,12)}}, offer = {type = 'give-item', item = 'small-lamp'}},
		{price = {{"coin", math_random(8,12)}}, offer = {type = 'give-item', item = 'red-wire'}},
		{price = {{"coin", math_random(8,12)}}, offer = {type = 'give-item', item = 'green-wire'}},
		{price = {{"coin", math_random(20,30)}}, offer = {type = 'give-item', item = 'arithmetic-combinator'}},
		{price = {{"coin", math_random(20,30)}}, offer = {type = 'give-item', item = 'decider-combinator'}},
		{price = {{"coin", math_random(12,20)}}, offer = {type = 'give-item', item = 'constant-combinator'}},
		{price = {{"coin", math_random(12,20)}}, offer = {type = 'give-item', item = 'power-switch'}},
		{price = {{"coin", math_random(12,20)}}, offer = {type = 'give-item', item = 'programmable-speaker'}}
	}
	
	local market_items_4 = {			
		
		{price = {{"coin", math_random(1,4)}}, offer = {type = 'give-item', item = 'raw-fish', count = 5}},
		{price = {{"coin", math_random(100,200)}}, offer = {type = 'give-item', item = 'locomotive'}},
		{price = {{"coin", math_random(75,150)}}, offer = {type = 'give-item', item = 'cargo-wagon'}},
		{price = {{"coin", math_random(150,250)}}, offer = {type = 'give-item', item = 'fluid-wagon'}},
		{price = {{"coin", math_random(2500,4500)}}, offer = {type = 'give-item', item = 'artillery-wagon'}},
		{price = {{"coin", math_random(2,3)}}, offer = {type = 'give-item', item = 'rail'}},
		{price = {{"coin", math_random(40,80)}}, offer = {type = 'give-item', item = 'rail-signal'}},
		{price = {{"coin", math_random(60,100)}}, offer = {type = 'give-item', item = 'rail-chain-signal'}},
		{price = {{"coin", math_random(200,400)}}, offer = {type = 'give-item', item = 'train-stop'}},
		{price = {{"coin", math_random(80,160)}}, offer = {type = 'give-item', item = 'car'}},
		{price = {{"coin", math_random(300,600)}}, offer = {type = 'give-item', item = 'tank'}},
		{price = {{"coin", math_random(40,100)}}, offer = {type = 'give-item', item = 'pumpjack'}},
		{price = {{"coin", math_random(300,600)}}, offer = {type = 'give-item', item = 'chemical-plant'}},
		{price = {{"coin", math_random(600,1200)}}, offer = {type = 'give-item', item = 'oil-refinery'}},
		{price = {{"coin", math_random(100,180)}}, offer = {type = 'give-item', item = 'storage-tank'}},
		{price = {{"coin", math_random(50,100)}}, offer = {type = 'give-item', item = 'crude-oil-barrel'}},
		{price = {{"coin", math_random(100,200)}}, offer = {type = 'give-item', item = 'petroleum-gas-barrel'}},
		{price = {{"coin", math_random(200,400)}}, offer = {type = 'give-item', item = 'sulfuric-acid-barrel'}},
		{price = {{"coin", math_random(50,100)}}, offer = {type = 'give-item', item = 'heavy-oil-barrel'}},
		{price = {{"coin", math_random(50,100)}}, offer = {type = 'give-item', item = 'light-oil-barrel'}},
		{price = {{"coin", math_random(50,100)}}, offer = {type = 'give-item', item = 'lubricant-barrel'}}
	}
	
	local market_items_5 = {			
		
		{price = {{"coin", math_random(1,4)}}, offer = {type = 'give-item', item = 'raw-fish', count = 5}},
		--{price = {{"coin", math_random(40000,50000)}}, offer = {type = 'give-item', item = 'rocket-silo'}},
		{price = {{"coin", math_random(1600,2400)}}, offer = {type = 'give-item', item = 'beacon'}},
		{price = {{"coin", math_random(80,160)}}, offer = {type = 'give-item', item = 'effectivity-module'}},
		{price = {{"coin", math_random(300,600)}}, offer = {type = 'give-item', item = 'effectivity-module-2'}},
		{price = {{"coin", math_random(800,1500)}}, offer = {type = 'give-item', item = 'effectivity-module-3'}},
		{price = {{"coin", math_random(80,160)}}, offer = {type = 'give-item', item = 'productivity-module'}},
		{price = {{"coin", math_random(300,600)}}, offer = {type = 'give-item', item = 'productivity-module-2'}},
		{price = {{"coin", math_random(800,1500)}}, offer = {type = 'give-item', item = 'productivity-module-3'}},
		{price = {{"coin", math_random(80,160)}}, offer = {type = 'give-item', item = 'speed-module'}},
		{price = {{"coin", math_random(300,600)}}, offer = {type = 'give-item', item = 'speed-module-2'}},
		{price = {{"coin", math_random(800,1500)}}, offer = {type = 'give-item', item = 'speed-module-3'}},
		{price = {{"coin", math_random(400,800)}}, offer = {type = 'give-item', item = 'gun-turret'}},
		{price = {{"coin", math_random(1000,2500)}}, offer = {type = 'give-item', item = 'laser-turret'}},
		{price = {{"coin", math_random(20000,40000)}}, offer = {type = 'give-item', item = 'artillery-turret'}},
		{price = {{"coin", math_random(200,400)}}, offer = {type = 'give-item', item = 'solar-panel'}},
		{price = {{"coin", math_random(300,500)}}, offer = {type = 'give-item', item = 'accumulator'}}		
	}
	
	local market_items_6 = {			
		
		{price = {{"coin", math_random(1,4)}}, offer = {type = 'give-item', item = 'raw-fish', count = 5}},
		{price = {{"coin", math_random(20,40)}}, offer = {type = 'give-item', item = 'pistol'}},
		{price = {{"coin", math_random(120,240)}}, offer = {type = 'give-item', item = 'submachine-gun'}},
		{price = {{"coin", math_random(120,240)}}, offer = {type = 'give-item', item = 'shotgun'}},
		{price = {{"coin", math_random(300,600)}}, offer = {type = 'give-item', item = 'combat-shotgun'}},
		{price = {{"coin", math_random(1000,1800)}}, offer = {type = 'give-item', item = 'rocket-launcher'}},
		{price = {{"coin", math_random(300,600)}}, offer = {type = 'give-item', item = 'flamethrower'}},
		{price = {{"coin", math_random(2000,4000)}}, offer = {type = 'give-item', item = 'railgun'}},
		{price = {{"coin", math_random(10,20)}}, offer = {type = 'give-item', item = 'firearm-magazine'}},
		{price = {{"coin", math_random(80,140)}}, offer = {type = 'give-item', item = 'piercing-rounds-magazine'}},
		{price = {{"coin", math_random(1000,2000)}}, offer = {type = 'give-item', item = 'uranium-rounds-magazine'}},
		{price = {{"coin", math_random(20,40)}}, offer = {type = 'give-item', item = 'shotgun-shell'}},
		{price = {{"coin", math_random(120,180)}}, offer = {type = 'give-item', item = 'piercing-shotgun-shell'}},
		{price = {{"coin", math_random(300,600)}}, offer = {type = 'give-item', item = 'rocket'}},
		{price = {{"coin", math_random(600,1000)}}, offer = {type = 'give-item', item = 'explosive-rocket'}},
		{price = {{"coin", math_random(20000,30000)}}, offer = {type = 'give-item', item = 'atomic-bomb'}},
		{price = {{"coin", math_random(120,180)}}, offer = {type = 'give-item', item = 'flamethrower-ammo'}},
		{price = {{"coin", math_random(120,180)}}, offer = {type = 'give-item', item = 'railgun-dart'}}		
	}
	
	local market_items_7 = {			
		
		{price = {{"coin", math_random(1,4)}}, offer = {type = 'give-item', item = 'raw-fish', count = 5}},
		{price = {{"coin", math_random(2,4)}}, offer = {type = 'give-item', item = 'iron-plate'}},
		{price = {{"coin", math_random(2,4)}}, offer = {type = 'give-item', item = 'copper-plate'}},
		{price = {{"coin", math_random(4,8)}}, offer = {type = 'give-item', item = 'solid-fuel'}},
		{price = {{"coin", math_random(4,8)}}, offer = {type = 'give-item', item = 'plastic-bar'}},
		{price = {{"coin", math_random(10,18)}}, offer = {type = 'give-item', item = 'explosives'}},
		{price = {{"coin", math_random(10,18)}}, offer = {type = 'give-item', item = 'steel-plate'}},
		{price = {{"coin", math_random(10,18)}}, offer = {type = 'give-item', item = 'engine-unit'}},
		{price = {{"coin", math_random(50,100)}}, offer = {type = 'give-item', item = 'electric-engine-unit'}},
		{price = {{"coin", math_random(15,30)}}, offer = {type = 'give-item', item = 'electronic-circuit'}},
		{price = {{"coin", math_random(30,60)}}, offer = {type = 'give-item', item = 'advanced-circuit'}},
		{price = {{"coin", math_random(100,180)}}, offer = {type = 'give-item', item = 'processing-unit'}},
		{price = {{"coin", math_random(400,800)}}, offer = {type = 'give-item', item = 'modular-armor'}},
		{price = {{"coin", math_random(5000,10000)}}, offer = {type = 'give-item', item = 'power-armor'}},
		{price = {{"coin", math_random(20000,30000)}}, offer = {type = 'give-item', item = 'power-armor-mk2'}},
		{price = {{"coin", math_random(800,1500)}}, offer = {type = 'give-item', item = 'energy-shield-equipment'}},
		{price = {{"coin", math_random(2500,4000)}}, offer = {type = 'give-item', item = 'energy-shield-mk2-equipment'}},
		{price = {{"coin", math_random(8000,12000)}}, offer = {type = 'give-item', item = 'personal-laser-defense-equipment'}},
		{price = {{"coin", math_random(4000,8000)}}, offer = {type = 'give-item', item = 'exoskeleton-equipment'}},
		{price = {{"coin", math_random(2000,4000)}}, offer = {type = 'give-item', item = 'personal-roboport-equipment'}},
		{price = {{"coin", math_random(4000,8000)}}, offer = {type = 'give-item', item = 'personal-roboport-mk2-equipment'}},
		{price = {{"coin", math_random(800,1200)}}, offer = {type = 'give-item', item = 'night-vision-equipment'}},
		{price = {{"coin", math_random(10000,15000)}}, offer = {type = 'give-item', item = 'fusion-reactor-equipment'}}		
	}
	
	local market_items_8 = {			
		
		{price = {{"coin", math_random(1,4)}}, offer = {type = 'give-item', item = 'raw-fish', count = 5}},
		{price = {{'wood', 100}}, offer = {type = 'give-item', item = "coin", count = math_random(2,4)}},
		{price = {{'iron-ore', 50}}, offer = {type = 'give-item', item = "coin", count = math_random(8,14)}},
		{price = {{'copper-ore', 50}}, offer = {type = 'give-item', item = "coin", count = math_random(8,14)}},
		{price = {{'stone', 50}}, offer = {type = 'give-item', item = "coin", count = math_random(8,14)}},
		{price = {{'coal', 50}}, offer = {type = 'give-item', item = "coin", count = math_random(8,14)}},
		{price = {{'uranium-ore', 50}}, offer = {type = 'give-item', item = "coin", count = math_random(40,80)}},
		{price = {{"burner-mining-drill", 1}}, offer = {type = 'give-item', item = 'iron-plate', count = 4}},
		{price = {{"burner-inserter", 1}}, offer = {type = 'give-item', item = 'iron-plate', count = 1}},
		{price = {{"iron-chest", 1}}, offer = {type = 'give-item', item = 'iron-plate', count = 1}},
		{price = {{"boiler", 1}}, offer = {type = 'give-item', item = 'iron-plate', count = 1}},
		{price = {{"steam-engine", 1}}, offer = {type = 'give-item', item = 'iron-plate', count = 10}},
		{price = {{"stone-furnace", 1}}, offer = {type = 'give-item', item = 'stone', count = 2}},
		{price = {{"steel-furnace", 1}}, offer = {type = 'give-item', item = 'steel-plate', count = 1}}		
	}
	
	for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"spitter-spawner"}})) do
		local pos = _x.position
		local market_items_1 = shuffle(market_items_1)
		if math_random(1,256) == 1 then
			local market_1 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
			market_1.destructible = false
			if COIN_BANK_ENABLE then 
				market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_1.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_1.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})	
				end
			end
			
			for i = 1, math.random(8, 14), 1 do
				market_1.add_market_item(market_items_1[i])
			end
		else
			local spitter_spawn = event.surface.create_entity({name = "spitter-spawner", position = _x.position})
		end
		_x.destroy()
	end
	for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"biter-spawner"}})) do
		local pos = _x.position
		local market_items_1 = shuffle(market_items_1)
		if math_random(1,256) == 1 then
			local market_1 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
			market_1.destructible = false
			if COIN_BANK_ENABLE then 
				market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end
			
			for i = 1, math.random(10, 16), 1 do
				market_1.add_market_item(market_items_1[i])
			end
		else
			local biter_spawn = event.surface.create_entity({name = "biter-spawner", position = _x.position})
		end
		_x.destroy()
	end
	for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"spitter-spawner"}})) do
		local pos = _x.position
		local market_items_2 = shuffle(market_items_2)
		if math_random(1,256) == 1 then
			local market_2 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
			market_2.destructible = false
			if COIN_BANK_ENABLE then 
				market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_2.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_2.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})					
				end
			end
			
			for i = 1, math.random(8, 14), 1 do
				market_2.add_market_item(market_items_2[i])
			end
		else
			local spitter_spawn = event.surface.create_entity({name = "spitter-spawner", position = _x.position})
		end
		_x.destroy()
	end
	for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"biter-spawner"}})) do
		local pos = _x.position
		local market_items_2 = shuffle(market_items_2)
		if math_random(1,256) == 1 then
			local market_2 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
			market_2.destructible = false
			if COIN_BANK_ENABLE then 
				market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end
			
			for i = 1, math.random(10, 16), 1 do
				market_2.add_market_item(market_items_2[i])
			end
		else
			local biter_spawn = event.surface.create_entity({name = "biter-spawner", position = _x.position})
		end
		_x.destroy()
	end
	for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"spitter-spawner"}})) do
		local pos = _x.position
		local market_items_3 = shuffle(market_items_3)
		if math_random(1,256) == 1 then
			local market_3 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
			market_3.destructible = false
			if COIN_BANK_ENABLE then 
				market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_3.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_3.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})					
				end
			end
			
			for i = 1, math.random(8, 14), 1 do
				market_3.add_market_item(market_items_3[i])
			end
		else
			local spitter_spawn = event.surface.create_entity({name = "spitter-spawner", position = _x.position})
		end
		_x.destroy()
	end
	for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"biter-spawner"}})) do
		local pos = _x.position
		local market_items_3 = shuffle(market_items_3)
		if math_random(1,256) == 1 then
			local market_3 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
			market_3.destructible = false
			if COIN_BANK_ENABLE then 
				market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end
			
			for i = 1, math.random(10, 16), 1 do
				market_3.add_market_item(market_items_3[i])
			end
		else
			local biter_spawn = event.surface.create_entity({name = "biter-spawner", position = _x.position})
		end
		_x.destroy()
	end
	for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"spitter-spawner"}})) do
		local pos = _x.position
		local market_items_4 = shuffle(market_items_4)
		if math_random(1,256) == 1 then
			local market_4 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
			market_4.destructible = false
			if COIN_BANK_ENABLE then 
				market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_4.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_4.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})					
				end
			end
			
			for i = 1, math.random(8, 14), 1 do
				market_4.add_market_item(market_items_4[i])
			end
		else
			local spitter_spawn = event.surface.create_entity({name = "spitter-spawner", position = _x.position})
		end
		_x.destroy()
	end
	for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"biter-spawner"}})) do
		local pos = _x.position
		local market_items_4 = shuffle(market_items_4)
		if math_random(1,256) == 1 then
			local market_4 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
			market_4.destructible = false
			if COIN_BANK_ENABLE then 
				market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end
			
			for i = 1, math.random(10, 16), 1 do
				market_4.add_market_item(market_items_4[i])
			end
		else
			local biter_spawn = event.surface.create_entity({name = "biter-spawner", position = _x.position})
		end
		_x.destroy()
	end
	for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"spitter-spawner"}})) do
		local pos = _x.position
		local market_items_5 = shuffle(market_items_5)
		if math_random(1,256) == 1 then
			local market_5 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
			market_5.destructible = false
			if COIN_BANK_ENABLE then 
				market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_5.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_5.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})					
				end
			end
			
			for i = 1, math.random(8, 14), 1 do
				market_5.add_market_item(market_items_5[i])
			end
		else
			local spitter_spawn = event.surface.create_entity({name = "spitter-spawner", position = _x.position})
		end
		_x.destroy()
	end
	for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"biter-spawner"}})) do
		local pos = _x.position
		local market_items_5 = shuffle(market_items_5)
		if math_random(1,256) == 1 then
			local market_5 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
			market_5.destructible = false
			if COIN_BANK_ENABLE then 
				market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end
			
			for i = 1, math.random(10, 16), 1 do
				market_5.add_market_item(market_items_5[i])
			end
		else
			local biter_spawn = event.surface.create_entity({name = "biter-spawner", position = _x.position})
		end
		_x.destroy()
	end
	for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"spitter-spawner"}})) do
		local pos = _x.position
		local market_items_6 = shuffle(market_items_6)
		if math_random(1,256) == 1 then
			local market_6 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
			market_6.destructible = false
			if COIN_BANK_ENABLE then 
				market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_6.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_6.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})					
				end
			end
			
			for i = 1, math.random(8, 14), 1 do
				market_6.add_market_item(market_items_6[i])
			end
		else
			local spitter_spawn = event.surface.create_entity({name = "spitter-spawner", position = _x.position})
		end
		_x.destroy()
	end
	for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"biter-spawner"}})) do
		local pos = _x.position
		local market_items_6 = shuffle(market_items_6)
		if math_random(1,256) == 1 then
			local market_6 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
			market_6.destructible = false
			if COIN_BANK_ENABLE then 
				market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end
			
			for i = 1, math.random(10, 16), 1 do
				market_6.add_market_item(market_items_6[i])
			end
		else
			local biter_spawn = event.surface.create_entity({name = "biter-spawner", position = _x.position})
		end
		_x.destroy()
	end
	
	if (not MAP_TOXIPLANET) or (not MAP_JUNKYARD) then
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"dead-grey-trunk"}})) do
			local pos = _x.position
			local market_items_1 = shuffle(market_items_1)
			if math_random(1,11520) == 1 then
				local market_1 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_1.destructible = false
			if COIN_BANK_ENABLE then 
					market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_1.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_1.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})					
				end
			end				
			
				for i = 1, math.random(8, 14), 1 do
					market_1.add_market_item(market_items_1[i])
				end
			else
				local tree_spawn = event.surface.create_entity({name = "dead-grey-trunk", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"tree-06-brown"}})) do
			local pos = _x.position
			local market_items_1 = shuffle(market_items_1)
			if math_random(1,11520) == 1 then
				local market_1 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_1.destructible = false
			if COIN_BANK_ENABLE then 
				market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end
			
				for i = 1, math.random(10, 16), 1 do
					market_1.add_market_item(market_items_1[i])
				end
			else
				local tree2_spawn = event.surface.create_entity({name = "tree-06-brown", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"dead-grey-trunk"}})) do
			local pos = _x.position
			local market_items_2 = shuffle(market_items_2)
			if math_random(1,11520) == 1 then
				local market_2 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_2.destructible = false
			if COIN_BANK_ENABLE then 
					market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_2.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_2.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})					
				end
			end				
			
				for i = 1, math.random(8, 14), 1 do
					market_2.add_market_item(market_items_2[i])
				end
			else
				local tree_spawn = event.surface.create_entity({name = "dead-grey-trunk", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"tree-06-brown"}})) do
			local pos = _x.position
			local market_items_2 = shuffle(market_items_2)
			if math_random(1,11520) == 1 then
				local market_2 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_2.destructible = false
			if COIN_BANK_ENABLE then 
				market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end
			
				for i = 1, math.random(10, 16), 1 do
					market_2.add_market_item(market_items_2[i])
				end
			else
				local tree2_spawn = event.surface.create_entity({name = "tree-06-brown", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"dead-grey-trunk"}})) do
			local pos = _x.position
			local market_items_3 = shuffle(market_items_3)
			if math_random(1,11520) == 1 then
				local market_3 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_3.destructible = false
			if COIN_BANK_ENABLE then 
					market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_3.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_3.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})					
				end
			end				
			
				for i = 1, math.random(8, 14), 1 do
					market_3.add_market_item(market_items_3[i])
				end
			else
				local tree_spawn = event.surface.create_entity({name = "dead-grey-trunk", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"tree-06-brown"}})) do
			local pos = _x.position
			local market_items_3 = shuffle(market_items_3)
			if math_random(1,11520) == 1 then
				local market_3 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_3.destructible = false
			if COIN_BANK_ENABLE then 
				market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end
			
				for i = 1, math.random(10, 16), 1 do
					market_3.add_market_item(market_items_3[i])
				end
			else
				local tree2_spawn = event.surface.create_entity({name = "tree-06-brown", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"dead-grey-trunk"}})) do
			local pos = _x.position
			local market_items_4 = shuffle(market_items_4)
			if math_random(1,11520) == 1 then
				local market_4 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_4.destructible = false
			if COIN_BANK_ENABLE then 
					market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_4.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_4.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})					
				end
			end				
			
				for i = 1, math.random(8, 14), 1 do
					market_4.add_market_item(market_items_4[i])
				end
			else
				local tree_spawn = event.surface.create_entity({name = "dead-grey-trunk", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"tree-06-brown"}})) do
			local pos = _x.position
			local market_items_4 = shuffle(market_items_4)
			if math_random(1,11520) == 1 then
				local market_4 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_4.destructible = false
			if COIN_BANK_ENABLE then 
				market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end
			
				for i = 1, math.random(10, 16), 1 do
					market_4.add_market_item(market_items_4[i])
				end
			else
				local tree2_spawn = event.surface.create_entity({name = "tree-06-brown", position = _x.position})
			end
			_x.destroy()
		end	
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"dead-grey-trunk"}})) do
			local pos = _x.position
			local market_items_5 = shuffle(market_items_5)
			if math_random(1,11520) == 1 then
				local market_5 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_5.destructible = false
			if COIN_BANK_ENABLE then 
					market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_5.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_5.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})					
				end
			end				
			
				for i = 1, math.random(8, 14), 1 do
					market_5.add_market_item(market_items_5[i])
				end
			else
				local tree_spawn = event.surface.create_entity({name = "dead-grey-trunk", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"tree-06-brown"}})) do
			local pos = _x.position
			local market_items_5 = shuffle(market_items_5)
			if math_random(1,11520) == 1 then
				local market_5 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_5.destructible = false
			if COIN_BANK_ENABLE then 
				market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end
			
				for i = 1, math.random(10, 16), 1 do
					market_5.add_market_item(market_items_5[i])
				end
			else
				local tree2_spawn = event.surface.create_entity({name = "tree-06-brown", position = _x.position})
			end
			_x.destroy()
		end	
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"dead-grey-trunk"}})) do
			local pos = _x.position
			local market_items_6 = shuffle(market_items_6)
			if math_random(1,11520) == 1 then
				local market_6 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_6.destructible = false
			if COIN_BANK_ENABLE then 
					market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_6.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_6.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})					
				end
			end				
			
				for i = 1, math.random(8, 14), 1 do
					market_6.add_market_item(market_items_6[i])
				end
			else
				local tree_spawn = event.surface.create_entity({name = "dead-grey-trunk", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"tree-06-brown"}})) do
			local pos = _x.position
			local market_items_6 = shuffle(market_items_6)
			if math_random(1,11520) == 1 then
				local market_6 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_6.destructible = false
			if COIN_BANK_ENABLE then 
				market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end
			
				for i = 1, math.random(10, 16), 1 do
					market_6.add_market_item(market_items_6[i])
				end
			else
				local tree2_spawn = event.surface.create_entity({name = "tree-06-brown", position = _x.position})
			end
			_x.destroy()
		end	
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"dead-grey-trunk"}})) do
			local pos = _x.position
			local market_items_7 = shuffle(market_items_7)
			if math_random(1,11520) == 1 then
				local market_7 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_7.destructible = false
			if COIN_BANK_ENABLE then 
					market_7.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_7.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_7.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_7.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_7.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})					
				end
			end				
			
				for i = 1, math.random(8, 14), 1 do
					market_7.add_market_item(market_items_7[i])
				end
			else
				local tree_spawn = event.surface.create_entity({name = "dead-grey-trunk", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"tree-06-brown"}})) do
			local pos = _x.position
			local market_items_7 = shuffle(market_items_7)
			if math_random(1,11520) == 1 then
				local market_7 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_7.destructible = false
			if COIN_BANK_ENABLE then 
				market_7.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_7.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_7.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end
			
				for i = 1, math.random(10, 16), 1 do
					market_7.add_market_item(market_items_7[i])
				end
			else
				local tree2_spawn = event.surface.create_entity({name = "tree-06-brown", position = _x.position})
			end
			_x.destroy()
		end	
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"dead-grey-trunk"}})) do
			local pos = _x.position
			local market_items_8 = shuffle(market_items_8)
			if math_random(1,11520) == 1 then
				local market_8 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_8.destructible = false
			if COIN_BANK_ENABLE then 
					market_8.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_8.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_8.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_8.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_8.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})					
				end
			end				
			
				for i = 1, math.random(8, 12), 1 do
					market_8.add_market_item(market_items_8[i])
				end
			else
				local tree_spawn = event.surface.create_entity({name = "dead-grey-trunk", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"tree-06-brown"}})) do
			local pos = _x.position
			local market_items_8 = shuffle(market_items_8)
			if math_random(1,11520) == 1 then
				local market_8 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_8.destructible = false
			if COIN_BANK_ENABLE then 
				market_8.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_8.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_8.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end
			
				for i = 1, math.random(10, 12), 1 do
					market_8.add_market_item(market_items_8[i])
				end
			else
				local tree2_spawn = event.surface.create_entity({name = "tree-06-brown", position = _x.position})
			end
			_x.destroy()
		end	
	else
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"dead-grey-trunk"}})) do
			local pos = _x.position
			local market_items_1 = shuffle(market_items_1)
			if math_random(1,22680) == 1 then
				local market_1 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_1.destructible = false
			if COIN_BANK_ENABLE then 
					market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_1.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_1.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})						
				end
			end				
			
				for i = 1, math.random(8, 14), 1 do
					market_1.add_market_item(market_items_1[i])
				end
			else
				local tree_spawn = event.surface.create_entity({name = "dead-grey-trunk", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"tree-06-brown"}})) do
			local pos = _x.position
			local market_items_1 = shuffle(market_items_1)
			if math_random(1,22680) == 1 then
				local market_1 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_1.destructible = false
			if COIN_BANK_ENABLE then 
				market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end				
			
				for i = 1, math.random(10, 16), 1 do
					market_1.add_market_item(market_items_1[i])
				end
			else
				local tree2_spawn = event.surface.create_entity({name = "tree-06-brown", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"rock-big"}})) do
			local pos = _x.position
			local market_items_1 = shuffle(market_items_1)
			if math_random(1,22680) == 1 then
				local market_1 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_1.destructible = false
			if COIN_BANK_ENABLE then 
				market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end				
			
				for i = 1, math.random(10, 16), 1 do
					market_1.add_market_item(market_items_1[i])
				end
			else
				local rock_spawn = event.surface.create_entity({name = "rock-big", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"sand-rock-big"}})) do
			local pos = _x.position
			local market_items_1 = shuffle(market_items_1)
			if math_random(1,22680) == 1 then
				local market_1 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_1.destructible = false
			if COIN_BANK_ENABLE then 
					market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_1.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_1.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_1.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})						
				end
			end				
			
				for i = 1, math.random(8, 14), 1 do
					market_1.add_market_item(market_items_1[i])
				end
			else
				local rock2_spawn = event.surface.create_entity({name = "sand-rock-big", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"dead-grey-trunk"}})) do
			local pos = _x.position
			local market_items_2 = shuffle(market_items_2)
			if math_random(1,22680) == 1 then
				local market_2 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_2.destructible = false
			if COIN_BANK_ENABLE then 
					market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_2.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_2.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})					
				end
			end				
			
				for i = 1, math.random(8, 14), 1 do
					market_2.add_market_item(market_items_2[i])
				end
			else
				local tree_spawn = event.surface.create_entity({name = "dead-grey-trunk", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"tree-06-brown"}})) do
			local pos = _x.position
			local market_items_2 = shuffle(market_items_2)
			if math_random(1,22680) == 1 then
				local market_2 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_2.destructible = false
			if COIN_BANK_ENABLE then 
				market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end				
			
				for i = 1, math.random(10, 16), 1 do
					market_2.add_market_item(market_items_2[i])
				end
			else
				local tree2_spawn = event.surface.create_entity({name = "tree-06-brown", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"rock-big"}})) do
			local pos = _x.position
			local market_items_2 = shuffle(market_items_2)
			if math_random(1,22680) == 1 then
				local market_2 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_2.destructible = false
			if COIN_BANK_ENABLE then 
				market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end				
			
				for i = 1, math.random(10, 16), 1 do
					market_2.add_market_item(market_items_2[i])
				end
			else
				local rock_spawn = event.surface.create_entity({name = "rock-big", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"sand-rock-big"}})) do
			local pos = _x.position
			local market_items_2 = shuffle(market_items_2)
			if math_random(1,22680) == 1 then
				local market_2 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_2.destructible = false
			if COIN_BANK_ENABLE then 
					market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_2.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_2.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_2.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})						
				end
			end				
			
				for i = 1, math.random(8, 14), 1 do
					market_2.add_market_item(market_items_2[i])
				end
			else
				local rock2_spawn = event.surface.create_entity({name = "sand-rock-big", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"dead-grey-trunk"}})) do
			local pos = _x.position
			local market_items_3 = shuffle(market_items_3)
			if math_random(1,22680) == 1 then
				local market_3 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_3.destructible = false
			if COIN_BANK_ENABLE then 
					market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_3.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_3.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})						
				end
			end				
			
				for i = 1, math.random(8, 14), 1 do
					market_3.add_market_item(market_items_3[i])
				end
			else
				local tree_spawn = event.surface.create_entity({name = "dead-grey-trunk", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"tree-06-brown"}})) do
			local pos = _x.position
			local market_items_3 = shuffle(market_items_3)
			if math_random(1,22680) == 1 then
				local market_3 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_3.destructible = false
			if COIN_BANK_ENABLE then 
				market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end				
			
				for i = 1, math.random(10, 16), 1 do
					market_3.add_market_item(market_items_3[i])
				end
			else
				local tree2_spawn = event.surface.create_entity({name = "tree-06-brown", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"rock-big"}})) do
			local pos = _x.position
			local market_items_3 = shuffle(market_items_3)
			if math_random(1,22680) == 1 then
				local market_3 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_3.destructible = false
			if COIN_BANK_ENABLE then 
				market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end				
			
				for i = 1, math.random(10, 16), 1 do
					market_3.add_market_item(market_items_3[i])
				end
			else
				local rock_spawn = event.surface.create_entity({name = "rock-big", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"sand-rock-big"}})) do
			local pos = _x.position
			local market_items_3 = shuffle(market_items_3)
			if math_random(1,22680) == 1 then
				local market_3 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_3.destructible = false
			if COIN_BANK_ENABLE then 
					market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_3.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_3.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_3.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})						
				end
			end				
			
				for i = 1, math.random(8, 14), 1 do
					market_3.add_market_item(market_items_3[i])
				end
			else
				local rock2_spawn = event.surface.create_entity({name = "sand-rock-big", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"dead-grey-trunk"}})) do
			local pos = _x.position
			local market_items_4 = shuffle(market_items_4)
			if math_random(1,22680) == 1 then
				local market_4 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_4.destructible = false
			if COIN_BANK_ENABLE then 
					market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_4.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_4.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})						
				end
			end				
			
				for i = 1, math.random(8, 14), 1 do
					market_4.add_market_item(market_items_4[i])
				end
			else
				local tree_spawn = event.surface.create_entity({name = "dead-grey-trunk", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"tree-06-brown"}})) do
			local pos = _x.position
			local market_items_4 = shuffle(market_items_4)
			if math_random(1,22680) == 1 then
				local market_4 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_4.destructible = false
			if COIN_BANK_ENABLE then 
				market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end				
			
				for i = 1, math.random(10, 16), 1 do
					market_4.add_market_item(market_items_4[i])
				end
			else
				local tree2_spawn = event.surface.create_entity({name = "tree-06-brown", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"rock-big"}})) do
			local pos = _x.position
			local market_items_4 = shuffle(market_items_4)
			if math_random(1,22680) == 1 then
				local market_4 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_4.destructible = false
			if COIN_BANK_ENABLE then 
				market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end				
			
				for i = 1, math.random(10, 16), 1 do
					market_4.add_market_item(market_items_4[i])
				end
			else
				local rock_spawn = event.surface.create_entity({name = "rock-big", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"sand-rock-big"}})) do
			local pos = _x.position
			local market_items_4 = shuffle(market_items_4)
			if math_random(1,22680) == 1 then
				local market_4 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_4.destructible = false
			if COIN_BANK_ENABLE then 
					market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_4.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_4.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_4.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})						
				end
			end				
			
				for i = 1, math.random(8, 14), 1 do
					market_4.add_market_item(market_items_4[i])
				end
			else
				local rock2_spawn = event.surface.create_entity({name = "sand-rock-big", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"dead-grey-trunk"}})) do
			local pos = _x.position
			local market_items_5 = shuffle(market_items_5)
			if math_random(1,22680) == 1 then
				local market_5 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_5.destructible = false
			if COIN_BANK_ENABLE then 
					market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_5.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_5.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})						
				end
			end				
			
				for i = 1, math.random(8, 14), 1 do
					market_5.add_market_item(market_items_5[i])
				end
			else
				local tree_spawn = event.surface.create_entity({name = "dead-grey-trunk", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"tree-06-brown"}})) do
			local pos = _x.position
			local market_items_5 = shuffle(market_items_5)
			if math_random(1,22680) == 1 then
				local market_5 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_5.destructible = false
			if COIN_BANK_ENABLE then 
				market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end				
			
				for i = 1, math.random(10, 16), 1 do
					market_5.add_market_item(market_items_5[i])
				end
			else
				local tree2_spawn = event.surface.create_entity({name = "tree-06-brown", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"rock-big"}})) do
			local pos = _x.position
			local market_items_5 = shuffle(market_items_5)
			if math_random(1,22680) == 1 then
				local market_5 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_5.destructible = false
			if COIN_BANK_ENABLE then 
				market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end				
			
				for i = 1, math.random(10, 16), 1 do
					market_5.add_market_item(market_items_5[i])
				end
			else
				local rock_spawn = event.surface.create_entity({name = "rock-big", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"sand-rock-big"}})) do
			local pos = _x.position
			local market_items_5 = shuffle(market_items_5)
			if math_random(1,22680) == 1 then
				local market_5 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_5.destructible = false
			if COIN_BANK_ENABLE then 
					market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_5.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_5.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_5.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})						
				end
			end				
			
				for i = 1, math.random(8, 14), 1 do
					market_5.add_market_item(market_items_5[i])
				end
			else
				local rock2_spawn = event.surface.create_entity({name = "sand-rock-big", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"dead-grey-trunk"}})) do
			local pos = _x.position
			local market_items_6 = shuffle(market_items_6)
			if math_random(1,22680) == 1 then
				local market_6 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_6.destructible = false
			if COIN_BANK_ENABLE then 
					market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_6.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_6.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})						
				end
			end				
			
				for i = 1, math.random(8, 14), 1 do
					market_6.add_market_item(market_items_6[i])
				end
			else
				local tree_spawn = event.surface.create_entity({name = "dead-grey-trunk", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"tree-06-brown"}})) do
			local pos = _x.position
			local market_items_6 = shuffle(market_items_6)
			if math_random(1,22680) == 1 then
				local market_6 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_6.destructible = false
			if COIN_BANK_ENABLE then 
				market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end				
			
				for i = 1, math.random(10, 16), 1 do
					market_6.add_market_item(market_items_6[i])
				end
			else
				local tree2_spawn = event.surface.create_entity({name = "tree-06-brown", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"rock-big"}})) do
			local pos = _x.position
			local market_items_6 = shuffle(market_items_6)
			if math_random(1,22680) == 1 then
				local market_6 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_6.destructible = false
			if COIN_BANK_ENABLE then 
				market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end				
			
				for i = 1, math.random(10, 16), 1 do
					market_6.add_market_item(market_items_6[i])
				end
			else
				local rock_spawn = event.surface.create_entity({name = "rock-big", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"sand-rock-big"}})) do
			local pos = _x.position
			local market_items_6 = shuffle(market_items_6)
			if math_random(1,22680) == 1 then
				local market_6 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_6.destructible = false
			if COIN_BANK_ENABLE then 
					market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_6.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_6.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_6.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})						
				end
			end				
			
				for i = 1, math.random(8, 14), 1 do
					market_6.add_market_item(market_items_6[i])
				end
			else
				local rock2_spawn = event.surface.create_entity({name = "sand-rock-big", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"dead-grey-trunk"}})) do
			local pos = _x.position
			local market_items_7 = shuffle(market_items_7)
			if math_random(1,22680) == 1 then
				local market_7 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_7.destructible = false
			if COIN_BANK_ENABLE then 
					market_7.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_7.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_7.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_7.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_7.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})						
				end
			end				
			
				for i = 1, math.random(8, 14), 1 do
					market_7.add_market_item(market_items_7[i])
				end
			else
				local tree_spawn = event.surface.create_entity({name = "dead-grey-trunk", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"tree-06-brown"}})) do
			local pos = _x.position
			local market_items_7 = shuffle(market_items_7)
			if math_random(1,22680) == 1 then
				local market_7 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_7.destructible = false
			if COIN_BANK_ENABLE then 
				market_7.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_7.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_7.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end				
			
				for i = 1, math.random(10, 16), 1 do
					market_7.add_market_item(market_items_7[i])
				end
			else
				local tree2_spawn = event.surface.create_entity({name = "tree-06-brown", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"rock-big"}})) do
			local pos = _x.position
			local market_items_7 = shuffle(market_items_7)
			if math_random(1,22680) == 1 then
				local market_7 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_7.destructible = false
			if COIN_BANK_ENABLE then 
				market_7.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_7.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_7.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end				
			
				for i = 1, math.random(10, 16), 1 do
					market_7.add_market_item(market_items_7[i])
				end
			else
				local rock_spawn = event.surface.create_entity({name = "rock-big", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"sand-rock-big"}})) do
			local pos = _x.position
			local market_items_7 = shuffle(market_items_7)
			if math_random(1,22680) == 1 then
				local market_7 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_7.destructible = false
			if COIN_BANK_ENABLE then 
					market_7.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_7.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_7.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_7.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_7.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})						
				end
			end				
			
				for i = 1, math.random(8, 14), 1 do
					market_7.add_market_item(market_items_7[i])
				end
			else
				local rock2_spawn = event.surface.create_entity({name = "sand-rock-big", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"dead-grey-trunk"}})) do
			local pos = _x.position
			local market_items_8 = shuffle(market_items_8)
			if math_random(1,22680) == 1 then
				local market_8 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_8.destructible = false
			if COIN_BANK_ENABLE then 
					market_8.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_8.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_8.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_8.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_8.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})						
				end
			end				
			
				for i = 1, math.random(8, 12), 1 do
					market_8.add_market_item(market_items_8[i])
				end
			else
				local tree_spawn = event.surface.create_entity({name = "dead-grey-trunk", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"tree-06-brown"}})) do
			local pos = _x.position
			local market_items_8 = shuffle(market_items_8)
			if math_random(1,22680) == 1 then
				local market_8 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_8.destructible = false
			if COIN_BANK_ENABLE then 
				market_8.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_8.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_8.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end				
			
				for i = 1, math.random(10, 12), 1 do
					market_8.add_market_item(market_items_8[i])
				end
			else
				local tree2_spawn = event.surface.create_entity({name = "tree-06-brown", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"rock-big"}})) do
			local pos = _x.position
			local market_items_8 = shuffle(market_items_8)
			if math_random(1,22680) == 1 then
				local market_8 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_8.destructible = false
			if COIN_BANK_ENABLE then 
				market_8.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
				market_8.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
				market_8.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
			end				
			
				for i = 1, math.random(10, 12), 1 do
					market_8.add_market_item(market_items_8[i])
				end
			else
				local rock_spawn = event.surface.create_entity({name = "rock-big", position = _x.position})
			end
			_x.destroy()
		end
		for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"sand-rock-big"}})) do
			local pos = _x.position
			local market_items_8 = shuffle(market_items_8)
			if math_random(1,22680) == 1 then
				local market_8 = event.surface.create_entity({name = "market", position = _x.position, force = "neutral"})
				market_8.destructible = false
			if COIN_BANK_ENABLE then 
					market_8.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Deposit Coins'}})
					market_8.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Withdraw Coins - 1% Bank Fee'}})
					market_8.add_market_item({price = {}, offer = {type = 'nothing', effect_description = 'Show Account Balance'}})
				if COIN_BOOST_ENABLE then 
					market_8.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Inventory bonus +5'}})
					market_8.add_market_item({price = {{"coin", math_random(10000,20000)}}, offer = {type = 'nothing', effect_description = 'Crafting bonus +5%'}})						
				end
			end				
			
				for i = 1, math.random(8, 12), 1 do
					market_8.add_market_item(market_items_8[i])
				end
			else
				local rock2_spawn = event.surface.create_entity({name = "sand-rock-big", position = _x.position})
			end
			_x.destroy()
		end
		
		
	end
end