-- DE333 utils
-- by Hansi-TWZ
-- DE333-SERVER.EU
-- Credits to MewMew (Comfy)

local simplex_noise = require 'DE333.simplex_noise'
simplex_noise = simplex_noise.d2

require("DE333/server_config/DE333_server_config")
require("DE333/server_config/server_1")
require("DE333/server_config/server_2")
require("DE333/server_config/server_3")
require("DE333/server_config/server_4")
require("DE333/server_config/server_5")
require("DE333/server_config/server_6")
require("DE333/server_config/server_7")

require("DE333/maps/Normal")
require("DE333/maps/ToxiPlanet")
require("DE333/maps/Junkyard")
require("DE333/maps/JunkyardV2")
require("DE333/maps/RedDesert")
require("DE333/maps/Woody")
require("DE333/maps/SaltLake")

require("DE333/DE333_markets")

require "DE333/on_tick_schedule"

local unearthing_worm = require "DE333/unearthing_worm"
local unearthing_worm_small = require "DE333/unearthing_worm_small"
local unearthing_biters = require "DE333/unearthing_biters"
local unearthing_biters_small = require "DE333/unearthing_biters_small"
local tick_tack_trap = require "DE333.tick_tack_trap"
local tick_tack_trap_small = require "DE333.tick_tack_trap_small"
	
function RemoveRockBigInArea(surface, area)
    for _, entity in pairs(surface.find_entities_filtered{area = area, name = "rock-big"}) do
        entity.destroy()
    end
end

function RemoveRockSandInArea(surface, area)
    for _, entity in pairs(surface.find_entities_filtered{area = area, name = "sand-rock-big"}) do
        entity.destroy()
    end
end

function RemoveRockHugeInArea(surface, area)
    for _, entity in pairs(surface.find_entities_filtered{area = area, name = "rock-huge"}) do
        entity.destroy()
    end
end

function RemoveWreckageInArea(surface, area)
    for _, entity in pairs(surface.find_entities_filtered{area = area, name = "mineable-wreckage"}) do
        entity.destroy()
    end
end

function RemoveMarketInArea(surface, area)
    for _, entity in pairs(surface.find_entities_filtered{area = area, name = "market"}) do
        entity.destroy()
    end
end

function BOOST_Inventory_5(player)
	--if player.character.character_inventory_slots_bonus == 50 then return end
    if player ~= nil then
        player.character.character_inventory_slots_bonus = player.character.character_inventory_slots_bonus +5
    end
end

function BOOST_Crafting_5(player)
	--if player.force.manual_crafting_speed_modifier == 0.50 then return end
    if player ~= nil then
        player.force.manual_crafting_speed_modifier = player.force.manual_crafting_speed_modifier +0.05
    end
end
	
function DisabledDeconstruction(event)	
	if disabled_for_deconstruction[event.entity.name] then
		event.entity.cancel_deconstruction(game.players[event.player_index].force.name)
	end
end

function floaty_chat(event)
	if not event.message then return end	
	if not event.player_index then return end	
	local player = game.players[event.player_index]
	if not player.character then return end
	
	local y_offset = -4
	if package.loaded['modules.rpg'] then y_offset = -4.5 end
	
	if global.player_floaty_chat[player.index] then
		rendering.destroy(global.player_floaty_chat[player.index])
		global.player_floaty_chat[player.index] = nil
	end
	
	local players = {}
	for _, p in pairs(game.connected_players) do
		if player.force.index == p.force.index then
			players[#players + 1] = p
		end
	end
	if #players == 0 then return end
	
	global.player_floaty_chat[player.index] = rendering.draw_text{
		text = event.message,
		surface = player.surface,
		target = player.character,
		target_offset = {-0.05, y_offset},
		color = {
			r = player.color.r * 0.6 + 0.25,
			g = player.color.g * 0.6 + 0.25,
			b = player.color.b * 0.6 + 0.25,
			a = 1
		},
		players = players,
		time_to_live = 600,
		scale = 1.50,
		font = "default-game",
		alignment = "center",
		scale_with_zoom = false
	}
end

function init_floaty_chat(event)
	global.player_floaty_chat = {}
end

function print_silent_command(event)        
    if event.command ~= "silent-command" then return end
    if not event.player_index then return end
    local player = game.players[event.player_index] 
    for _, p in pairs(game.connected_players) do
        if p.admin == true and p.name ~= player.name then
            p.print(player.name .. " did a silent-command: " .. event.parameters, {r=0.22, g=0.99, b=0.99})
        end
    end     
end

local function heal_rocks()
	for key, rock in pairs(global.damaged_rocks) do
		if rock.last_damage + 60 < game.tick then
			if rock.entity then
				if rock.entity.valid then
					rock.entity.health = rock.entity.health + healing_amount[rock.entity.name]
					if rock.entity.prototype.max_health == rock.entity.health then
						global.damaged_rocks[key] = nil
					end
				else
					global.damaged_rocks[key] = nil
				end
			else
				global.damaged_rocks[key] = nil
			end
		end
	end
end

function rock_wreckage_damaged(event)
	if not event.entity.valid then return end
	if not healing_amount[event.entity.name] then return end
	global.damaged_rocks[tostring(event.entity.position.x) .. tostring(event.entity.position.y)] = {last_damage = game.tick, entity = event.entity}		
end

function rock_wreckage_damaged_player_joined(event)
	if not global.damaged_rocks then global.damaged_rocks = {} end	
end

function rock_wreckage_damaged_tick(event)
	--if game.tick % 3600 ~= 1 then return end
	heal_rocks()
end

function piranha_bite(event)
	local math_random = math.random
	if event.entity.name == "fish" then
		if math_random(1,5) == 1 then
			local player = game.players[event.player_index]	
			local health = player.character.health
			player.character.damage(math_random(50,150),"enemy")			
			if not player.character then
				game.print(player.name .. " should have kept their hands out of the foggy lake waters.",{ r=0.75, g=0.0, b=0.0} )
			else
				if health > 200 then
					player.print("You got bitten by an angry piranha.",{ r=0.75, g=0.0, b=0.0})
				else
					local messages = {"Ouch.. That hurt! Better be careful now.", "Just a fleshwound.", "Better keep those hands to yourself or you might loose them."}
					player.print(messages[math_random(1,#messages)],{ r=0.75, g=0.0, b=0.0})
				end
			end
		end
	end	
end
				
local player_hunger_stages = {}
for x = 1, 200, 1 do
	if x <= 200 then player_hunger_stages[x] = "Obese" end						
	if x <= 179 then player_hunger_stages[x] = "Stuffed" end
	if x <= 150 then player_hunger_stages[x] = "Bloated" end
	if x <= 130 then player_hunger_stages[x] = "Sated" end
	if x <= 110 then player_hunger_stages[x] = "Well Fed" end
	if x <= 89 then player_hunger_stages[x] = "Nourished" end			
	if x <= 70 then player_hunger_stages[x] = "Hungry" end
	if x <= 35 then player_hunger_stages[x] = "Starving" end			
end	

local player_hunger_color_list = {}
for x = 1, 50, 1 do
	player_hunger_color_list[x] = 		{r = 0.5 + x*0.01, g = x*0.01, b = x*0.005}
	player_hunger_color_list[50+x] = {r = 1 - x*0.02, g = 0.5 + x*0.01, b = 0.25}
	player_hunger_color_list[100+x] = {r = 0 + x*0.02, g = 1 - x*0.01, b = 0.25}
	player_hunger_color_list[150+x] = {r = 1 - x*0.01, g = 0.5 - x*0.01, b = 0.25 - x*0.005}
end

local player_hunger_buff = {}
local buff_top_value = 0.70		
for x = 1, 200, 1 do
	player_hunger_buff[x] = buff_top_value
end
local y = 1
for x = 89, 1, -1 do			
	player_hunger_buff[x] = buff_top_value - y * 0.015
	y = y + 1
end
local y = 1		
for x = 111, 200, 1 do			
	player_hunger_buff[x] = buff_top_value - y * 0.015
	y = y + 1
end

function create_hunger_gui(player)
	if player.gui.top["hunger_frame"] then player.gui.top["hunger_frame"].destroy() end
	
	local frame = player.gui.top.add { type = "frame", name = "hunger_frame"}
	
	local str = tostring(global.player_hunger[player.name])
	str = str .. "% "
	str = str .. player_hunger_stages[global.player_hunger[player.name]]
	
	local caption_hunger = frame.add { 
		type = "label",
		caption = str,
		tooltip = 	"[color=1.0,0.8,0.2]Hunger[/color]\n"..
					"Eat some fish [img=item.raw-fish]\n"..
					"but don´t eat too much..."
	}
	caption_hunger.style.font = "default-bold"
	caption_hunger.style.font_color = player_hunger_color_list[global.player_hunger[player.name]]
	caption_hunger.style.top_padding = 2	
end

function hunger_update(player, food_value)
	if not player.character then return end

	player.character.character_running_speed_modifier = player_hunger_buff[global.player_hunger[player.name]] * 0.5
	player.character.character_mining_speed_modifier  = player_hunger_buff[global.player_hunger[player.name]] / 1.5
	--player.character.character_crafting_speed_modifier = player_hunger_buff[global.player_hunger[player.name]]
	
	if food_value == -1 and player.character.driving == true then return end
	
	local past_hunger = global.player_hunger[player.name]	
	global.player_hunger[player.name] = global.player_hunger[player.name] + food_value
	if global.player_hunger[player.name] > 200 then global.player_hunger[player.name] = 200 end
			
	if past_hunger == 200 and global.player_hunger[player.name] + food_value > 200 then
		global.player_hunger[player.name] = player_hunger_spawn_value
		player.surface.create_entity({name = "big-artillery-explosion", position = player.character.position})
		player.character.die("player")
		local t = {" ate too much and exploded.", " needs to work on their bad eating habbits.", " should have skipped dinner today."}
		game.print(player.name .. t[math.random(1,#t)], { r=0.75, g=0.0, b=0.0})				
	end	
	
	if global.player_hunger[player.name] < 1 then
		global.player_hunger[player.name] = player_hunger_spawn_value		
		player.character.die("player")
		local t = {" ran out of foodstamps.", " starved.", " should not have skipped breakfast today."}
		game.print(player.name .. t[math.random(1,#t)], { r=0.75, g=0.0, b=0.0})	
	end
	
	if player.character then
		if player_hunger_stages[global.player_hunger[player.name]] ~= player_hunger_stages[past_hunger] then
			local print_message = "You are " .. player_hunger_stages[global.player_hunger[player.name]] .. "."
			if player_hunger_stages[global.player_hunger[player.name]] == "Obese" then
				print_message = "You have become " .. player_hunger_stages[global.player_hunger[player.name]]  .. "."					
			end
			if player_hunger_stages[global.player_hunger[player.name]] == "Starving" then
				print_message = "You are starving!"
				game.print(player.name .. " is starving!", player_hunger_color_list[global.player_hunger[player.name]])
			end
			player.print(print_message, player_hunger_color_list[global.player_hunger[player.name]])
		end
	end
	
	create_hunger_gui(player)
end

function create_hunger(event)
	local player = game.players[event.player_index]
	if not global.player_hunger then global.player_hunger = {} end
	if player.online_time < 2 then		
		global.player_hunger[player.name] = player_hunger_spawn_value
		hunger_update(player, 0)
	end
	create_hunger_gui(player)
end

function eat_fish(event)
	if event.item.name == "raw-fish" then		
		local player = game.players[event.player_index]
		if player.character.health < 250 then return end		
		hunger_update(player, player_hunger_fish_food_value)		
		player.play_sound{path="utility/armor_insert", volume_modifier=0.65}				
	end
end

function respawn_hunger(event)
	local player = game.players[event.player_index]
	if not global.player_hunger then global.player_hunger = {} end
	global.player_hunger[player.name] = player_hunger_spawn_value
	create_hunger_gui(player)
end

function update_hunger(event)
	if game.tick % 3600 == 0 then
		for _, player in pairs(game.connected_players) do
			if player.afk_time < 18000 then	hunger_update(player, -1) end		
		end			
	end		
end

local function shuffle_fish(tbl)
	local math_random = math.random
	local size = #tbl
		for i = size, 1, -1 do
			local rand = math_random(size)
			tbl[i], tbl[rand] = tbl[rand], tbl[i]
		end
	return tbl
end

local function get_surfaces()
	local surfaces = {}
	for _, player in pairs(game.connected_players) do
		if not surfaces[player.surface.index] then
			surfaces[player.surface.index] = player.surface
		end		
	end
	return surfaces
end

local function create_new_fish_spawn_schedule()
	global.fish_respawn_chunk_schedule = {}

	local surfaces = get_surfaces()
	if #surfaces == 0 then return end
		
	for _, surface in pairs(surfaces) do		
		for chunk in surface.get_chunks() do
			global.fish_respawn_chunk_schedule[#global.fish_respawn_chunk_schedule + 1] = {chunk = {x = chunk.x, y = chunk.y}, surface_index = surface.index}
		end
	end
	
	global.fish_respawn_chunk_schedule = shuffle_fish(global.fish_respawn_chunk_schedule)
	
	return global.fish_respawn_chunk_schedule
end

local function respawn_fishes_in_chunk(schedule)
	local surface = game.surfaces[schedule.surface_index]
	local chunk = schedule.chunk
	local chunk_area = {{chunk.x * 32, chunk.y * 32}, {chunk.x * 32 + 32, chunk.y * 32 + 32}}
	
	local water_tiles = surface.find_tiles_filtered({area = chunk_area, name = valid_water_tiles})
	if #water_tiles < global.fish_respawner_water_tiles_per_fish then return end
	
	local chunk_fish_count = surface.count_entities_filtered({area = chunk_area, type = "fish"})
		
	local fish_to_spawn = math.floor((#water_tiles - (global.fish_respawner_water_tiles_per_fish * chunk_fish_count)) / global.fish_respawner_water_tiles_per_fish)
	if fish_to_spawn <= 0 then return end
	
	if fish_to_spawn > global.fish_respawner_max_respawnrate_per_chunk then fish_to_spawn = global.fish_respawner_max_respawnrate_per_chunk end
	
	water_tiles = shuffle_fish(water_tiles)
	for _, tile in pairs(water_tiles) do
		if surface.can_place_entity({name = "fish", position = tile.position}) then
			surface.create_entity({name = "water-splash", position = tile.position})
			surface.create_entity({name = "fish", position = tile.position})
			fish_to_spawn = fish_to_spawn - 1
			if fish_to_spawn <= 0 then return end
		end
	end				
end

function fish_respawner(event)
	local i = game.tick % fish_respawn_interval
	if i == 0 then create_new_fish_spawn_schedule() return end
	if not global.fish_respawn_chunk_schedule[i] then return end
	respawn_fishes_in_chunk(global.fish_respawn_chunk_schedule[i])
	global.fish_respawn_chunk_schedule[i] = nil
end

function crashsite(event)
	local math_random = math.random
	local insert = table.insert

	local ship_raffle_SMALL = {}
	local ship_loot_SMALL = {			
		{{name = "submachine-gun", count = math_random(1,3)}, weight = 3, evolution_min = 0.0, evolution_max = 0.1},		
		{{name = "slowdown-capsule", count = math_random(32,50)}, weight = 1, evolution_min = 0.3, evolution_max = 0.7},
		{{name = "poison-capsule", count = math_random(32,50)}, weight = 3, evolution_min = 0.3, evolution_max = 1},		
		--{{name = "uranium-cannon-shell", count = math_random(16,32)}, weight = 5, evolution_min = 0.6, evolution_max = 1},
		--{{name = "cannon-shell", count = math_random(16,32)}, weight = 5, evolution_min = 0.4, evolution_max = 0.7},
		--{{name = "explosive-uranium-cannon-shell", count = math_random(16,32)}, weight = 5, evolution_min = 0.6, evolution_max = 1},
		--{{name = "explosive-cannon-shell", count = math_random(16,32)}, weight = 5, evolution_min = 0.4, evolution_max = 0.8},
		{{name = "shotgun", count = 1}, weight = 2, evolution_min = 0.0, evolution_max = 0.2},
		{{name = "shotgun-shell", count = math_random(16,32)}, weight = 5, evolution_min = 0.0, evolution_max = 0.2},
		{{name = "combat-shotgun", count = 1}, weight = 3, evolution_min = 0.3, evolution_max = 0.8},
		{{name = "piercing-shotgun-shell", count = math_random(16,32)}, weight = 10, evolution_min = 0.2, evolution_max = 1},
		{{name = "flamethrower", count = 1}, weight = 3, evolution_min = 0.3, evolution_max = 0.6},
		{{name = "flamethrower-ammo", count = math_random(16,32)}, weight = 5, evolution_min = 0.3, evolution_max = 1},
		{{name = "rocket-launcher", count = 1}, weight = 3, evolution_min = 0.2, evolution_max = 0.6},
		{{name = "rocket", count = math_random(16,32)}, weight = 5, evolution_min = 0.2, evolution_max = 0.7},		
		{{name = "explosive-rocket", count = math_random(16,32)}, weight = 5, evolution_min = 0.3, evolution_max = 1},
		--{{name = "land-mine", count = math_random(16,32)}, weight = 5, evolution_min = 0.2, evolution_max = 0.7},
		--{{name = "grenade", count = math_random(16,32)}, weight = 5, evolution_min = 0.0, evolution_max = 0.5},
		{{name = "cluster-grenade", count = math_random(32,50)}, weight = 5, evolution_min = 0.4, evolution_max = 1},
		--{{name = "firearm-magazine", count = math_random(32,128)}, weight = 5, evolution_min = 0, evolution_max = 0.3},
		--{{name = "piercing-rounds-magazine", count = math_random(32,128)}, weight = 5, evolution_min = 0.1, evolution_max = 0.8},
		{{name = "uranium-rounds-magazine", count = math_random(180,200)}, weight = 5, evolution_min = 0.5, evolution_max = 1},
		{{name = "railgun", count = 1}, weight = 1, evolution_min = 0.2, evolution_max = 1},
		{{name = "railgun-dart", count = math_random(180,200)}, weight = 3, evolution_min = 0.2, evolution_max = 0.7},
		{{name = "defender-capsule", count = math_random(32,50)}, weight = 2, evolution_min = 0.0, evolution_max = 0.7},
		{{name = "distractor-capsule", count = math_random(32,50)}, weight = 2, evolution_min = 0.2, evolution_max = 1},
		{{name = "destroyer-capsule", count = math_random(32,50)}, weight = 2, evolution_min = 0.3, evolution_max = 1},
		--{{name = "atomic-bomb", count = math_random(8,16)}, weight = 1, evolution_min = 0.3, evolution_max = 1},		
		--{{name = "light-armor", count = 1}, weight = 3, evolution_min = 0, evolution_max = 0.1},		
		--{{name = "heavy-armor", count = 1}, weight = 3, evolution_min = 0.1, evolution_max = 0.3},
		{{name = "modular-armor", count = 1}, weight = 2, evolution_min = 0.2, evolution_max = 0.6},
		{{name = "power-armor", count = 1}, weight = 2, evolution_min = 0.4, evolution_max = 1},
		{{name = "power-armor-mk2", count = 1}, weight = 1, evolution_min = 0.9, evolution_max = 1},
		--{{name = "battery-equipment", count = 1}, weight = 2, evolution_min = 0.3, evolution_max = 0.7},
		{{name = "battery-mk2-equipment", count = 1}, weight = 2, evolution_min = 0.6, evolution_max = 1},
		{{name = "belt-immunity-equipment", count = 1}, weight = 1, evolution_min = 0.3, evolution_max = 1},
		--{{name = "solar-panel-equipment", count = math_random(1,4)}, weight = 5, evolution_min = 0.3, evolution_max = 0.8},
		{{name = "discharge-defense-equipment", count = 1}, weight = 1, evolution_min = 0.5, evolution_max = 0.8},
		--{{name = "energy-shield-equipment", count = math_random(1,2)}, weight = 2, evolution_min = 0.3, evolution_max = 0.8},
		{{name = "energy-shield-mk2-equipment", count = 1}, weight = 2, evolution_min = 0.7, evolution_max = 1},
		{{name = "exoskeleton-equipment", count = 1}, weight = 1, evolution_min = 0.3, evolution_max = 1},
		{{name = "fusion-reactor-equipment", count = 1}, weight = 1, evolution_min = 0.5, evolution_max = 1},
		{{name = "night-vision-equipment", count = 1}, weight = 1, evolution_min = 0.3, evolution_max = 0.8},
		{{name = "personal-laser-defense-equipment", count = 1}, weight = 2, evolution_min = 0.5, evolution_max = 1},
		{{name = "exoskeleton-equipment", count = 1}, weight = 1, evolution_min = 0.3, evolution_max = 1},
						
		
		--{{name = "iron-gear-wheel", count = math_random(80,100)}, weight = 3, evolution_min = 0.0, evolution_max = 0.3},
		--{{name = "copper-cable", count = math_random(100,200)}, weight = 3, evolution_min = 0.0, evolution_max = 0.3},
		--{{name = "engine-unit", count = math_random(16,32)}, weight = 2, evolution_min = 0.1, evolution_max = 0.5},
		--{{name = "electric-engine-unit", count = math_random(16,32)}, weight = 2, evolution_min = 0.4, evolution_max = 0.8},
		--{{name = "battery", count = math_random(50,150)}, weight = 2, evolution_min = 0.3, evolution_max = 0.8},
		--{{name = "advanced-circuit", count = math_random(50,150)}, weight = 3, evolution_min = 0.4, evolution_max = 1},
		--{{name = "electronic-circuit", count = math_random(50,150)}, weight = 3, evolution_min = 0.0, evolution_max = 0.4},
		--{{name = "processing-unit", count = math_random(50,150)}, weight = 3, evolution_min = 0.7, evolution_max = 1},
		--{{name = "explosives", count = math_random(40,50)}, weight = 10, evolution_min = 0.0, evolution_max = 1},
		--{{name = "lubricant-barrel", count = math_random(4,10)}, weight = 1, evolution_min = 0.3, evolution_max = 0.5},
		{{name = "rocket-fuel", count = math_random(8,10)}, weight = 2, evolution_min = 0.3, evolution_max = 0.7},
		--{{name = "computer", count = 1}, weight = 2, evolution_min = 0, evolution_max = 1},
		--{{name = "steel-plate", count = math_random(25,75)}, weight = 2, evolution_min = 0.1, evolution_max = 0.3},
		{{name = "nuclear-fuel", count = 1}, weight = 5, evolution_min = 0.7, evolution_max = 1},
				
		--{{name = "burner-inserter", count = math_random(8,16)}, weight = 3, evolution_min = 0.0, evolution_max = 0.1},
		--{{name = "inserter", count = math_random(8,16)}, weight = 3, evolution_min = 0.0, evolution_max = 0.4},
		{{name = "long-handed-inserter", count = math_random(8,16)}, weight = 3, evolution_min = 0.0, evolution_max = 0.4},		
		{{name = "fast-inserter", count = math_random(8,16)}, weight = 3, evolution_min = 0.1, evolution_max = 1},
		{{name = "filter-inserter", count = math_random(8,16)}, weight = 1, evolution_min = 0.2, evolution_max = 1},		
		{{name = "stack-filter-inserter", count = math_random(15,50)}, weight = 1, evolution_min = 0.4, evolution_max = 1},
		{{name = "stack-inserter", count = math_random(15,50)}, weight = 3, evolution_min = 0.3, evolution_max = 1},				
		--{{name = "small-electric-pole", count = math_random(16,24)}, weight = 3, evolution_min = 0.0, evolution_max = 0.3},
		{{name = "medium-electric-pole", count = math_random(15,50)}, weight = 3, evolution_min = 0.2, evolution_max = 1},
		{{name = "big-electric-pole", count = math_random(15,50)}, weight = 3, evolution_min = 0.3, evolution_max = 1},
		{{name = "substation", count = math_random(15,50)}, weight = 3, evolution_min = 0.5, evolution_max = 1},
		--{{name = "wooden-chest", count = math_random(16,24)}, weight = 3, evolution_min = 0.0, evolution_max = 0.2},
		--{{name = "iron-chest", count = math_random(4,8)}, weight = 3, evolution_min = 0.1, evolution_max = 0.4},
		{{name = "steel-chest", count = math_random(15,50)}, weight = 3, evolution_min = 0.3, evolution_max = 1},		
		--{{name = "small-lamp", count = math_random(16,32)}, weight = 3, evolution_min = 0.1, evolution_max = 0.3},
		--{{name = "rail", count = math_random(25,75)}, weight = 3, evolution_min = 0.1, evolution_max = 0.6},
		--{{name = "assembling-machine-1", count = math_random(2,4)}, weight = 3, evolution_min = 0.0, evolution_max = 0.3},
		{{name = "assembling-machine-2", count = math_random(2,4)}, weight = 3, evolution_min = 0.2, evolution_max = 0.8},
		{{name = "assembling-machine-3", count = math_random(15,30)}, weight = 3, evolution_min = 0.5, evolution_max = 1},
		{{name = "accumulator", count = math_random(4,8)}, weight = 3, evolution_min = 0.4, evolution_max = 1},
		--{{name = "offshore-pump", count = math_random(1,3)}, weight = 2, evolution_min = 0.0, evolution_max = 0.1},
		{{name = "beacon", count = math_random(5,15)}, weight = 3, evolution_min = 0.7, evolution_max = 1},
		--{{name = "boiler", count = math_random(4,8)}, weight = 3, evolution_min = 0.0, evolution_max = 0.3},
		--{{name = "steam-engine", count = math_random(2,4)}, weight = 3, evolution_min = 0.0, evolution_max = 0.5},
		--{{name = "steam-turbine", count = math_random(1,2)}, weight = 2, evolution_min = 0.6, evolution_max = 1},
		--{{name = "nuclear-reactor", count = 1}, weight = 1, evolution_min = 0.6, evolution_max = 1},
		{{name = "centrifuge", count = math_random(5,10)}, weight = 1, evolution_min = 0.6, evolution_max = 1},
		{{name = "heat-pipe", count = math_random(5,10)}, weight = 2, evolution_min = 0.5, evolution_max = 1},
		{{name = "heat-exchanger", count = math_random(5,10)}, weight = 2, evolution_min = 0.5, evolution_max = 1},
		--{{name = "arithmetic-combinator", count = math_random(8,16)}, weight = 1, evolution_min = 0.1, evolution_max = 1},
		--{{name = "constant-combinator", count = math_random(8,16)}, weight = 1, evolution_min = 0.1, evolution_max = 1},
		--{{name = "decider-combinator", count = math_random(8,16)}, weight = 1, evolution_min = 0.1, evolution_max = 1},
		--{{name = "power-switch", count = math_random(1,2)}, weight = 1, evolution_min = 0.1, evolution_max = 1},		
		--{{name = "programmable-speaker", count = math_random(4,8)}, weight = 1, evolution_min = 0.1, evolution_max = 1},
		--{{name = "green-wire", count = math_random(50,99)}, weight = 1, evolution_min = 0.1, evolution_max = 1},
		--{{name = "red-wire", count = math_random(50,99)}, weight = 1, evolution_min = 0.1, evolution_max = 1},
		{{name = "chemical-plant", count = math_random(3,10)}, weight = 3, evolution_min = 0.3, evolution_max = 1},
		--{{name = "burner-mining-drill", count = math_random(2,4)}, weight = 3, evolution_min = 0.0, evolution_max = 0.2},
		--{{name = "electric-mining-drill", count = math_random(2,4)}, weight = 3, evolution_min = 0.2, evolution_max = 0.6},		
		{{name = "express-transport-belt", count = math_random(80,100)}, weight = 3, evolution_min = 0.5, evolution_max = 1},
		{{name = "express-underground-belt", count = math_random(30,50)}, weight = 3, evolution_min = 0.5, evolution_max = 1},		
		{{name = "express-splitter", count = math_random(30,50)}, weight = 3, evolution_min = 0.5, evolution_max = 1},
		--{{name = "fast-transport-belt", count = math_random(25,75)}, weight = 3, evolution_min = 0.2, evolution_max = 0.7},
		--{{name = "fast-underground-belt", count = math_random(4,8)}, weight = 3, evolution_min = 0.2, evolution_max = 0.7},
		--{{name = "fast-splitter", count = math_random(2,4)}, weight = 3, evolution_min = 0.2, evolution_max = 0.3},
		--{{name = "transport-belt", count = math_random(25,75)}, weight = 3, evolution_min = 0, evolution_max = 0.3},
		--{{name = "underground-belt", count = math_random(4,8)}, weight = 3, evolution_min = 0, evolution_max = 0.3},
		--{{name = "splitter", count = math_random(2,4)}, weight = 3, evolution_min = 0, evolution_max = 0.3},		
		--{{name = "oil-refinery", count = math_random(2,4)}, weight = 2, evolution_min = 0.3, evolution_max = 1},
		--{{name = "pipe", count = math_random(30,50)}, weight = 3, evolution_min = 0.0, evolution_max = 0.3},
		--{{name = "pipe-to-ground", count = math_random(4,8)}, weight = 1, evolution_min = 0.2, evolution_max = 0.5},
		--{{name = "pumpjack", count = math_random(1,3)}, weight = 1, evolution_min = 0.3, evolution_max = 0.8},
		--{{name = "pump", count = math_random(1,2)}, weight = 1, evolution_min = 0.3, evolution_max = 0.8},
		--{{name = "solar-panel", count = math_random(8,16)}, weight = 3, evolution_min = 0.4, evolution_max = 0.9},
		{{name = "electric-furnace", count = math_random(15,50)}, weight = 3, evolution_min = 0.5, evolution_max = 1},
		--{{name = "steel-furnace", count = math_random(4,8)}, weight = 3, evolution_min = 0.2, evolution_max = 0.7},
		--{{name = "stone-furnace", count = math_random(8,16)}, weight = 3, evolution_min = 0.0, evolution_max = 0.1},		
		{{name = "radar", count = math_random(3,10)}, weight = 1, evolution_min = 0.1, evolution_max = 0.3},
		--{{name = "rail-signal", count = math_random(8,16)}, weight = 2, evolution_min = 0.2, evolution_max = 0.8},
		--{{name = "rail-chain-signal", count = math_random(8,16)}, weight = 2, evolution_min = 0.2, evolution_max = 0.8},		
		--{{name = "stone-wall", count = math_random(25,75)}, weight = 1, evolution_min = 0.1, evolution_max = 0.5},
		--{{name = "gate", count = math_random(4,8)}, weight = 1, evolution_min = 0.1, evolution_max = 0.5},
		{{name = "storage-tank", count = math_random(3,10)}, weight = 3, evolution_min = 0.3, evolution_max = 0.6},
		{{name = "train-stop", count = math_random(3,10)}, weight = 1, evolution_min = 0.2, evolution_max = 0.7},
		{{name = "express-loader", count = math_random(3,10)}, weight = 1, evolution_min = 0.5, evolution_max = 1},
		{{name = "fast-loader", count = math_random(3,10)}, weight = 1, evolution_min = 0.2, evolution_max = 0.7},
		{{name = "loader", count = math_random(3,10)}, weight = 1, evolution_min = 0.0, evolution_max = 0.5},
		{{name = "lab", count = math_random(1,2)}, weight = 2, evolution_min = 0.0, evolution_max = 0.1},	
		{{name = "roboport", count = math_random(2,4)}, weight = 2, evolution_min = 0.6, evolution_max = 1},
		{{name = "flamethrower-turret", count = math_random(1,3)}, weight = 3, evolution_min = 0.5, evolution_max = 1},		
		{{name = "laser-turret", count = math_random(10,25)}, weight = 3, evolution_min = 0.5, evolution_max = 1},	
		{{name = "gun-turret", count = math_random(10,25)}, weight = 3, evolution_min = 0.2, evolution_max = 0.9},
		
		{{name = "coin", count = math_random(5000,10000)}, weight = 1, evolution_min = 0.8, evolution_max = 1}	
	}
	
	for _, z in pairs (ship_loot_SMALL) do
		for x = 1, z.weight, 1 do
			table.insert(ship_raffle_SMALL, z[1])
		end			
	end
	
	for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"sand-rock-big"}})) do
		local pos = _x.position
		if math_random(1,256) == 1 then
			local shipSMALL = event.surface.create_entity({name = ships[math_random(1,#ships)], position = _x.position, force = "neutral"})
			shipSMALL.destructible = false
			shipSMALL.minable = false
			local wreckage1 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x-4, _x.position.y+4}, force = "neutral"})
			local wreckage2 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x+5, _x.position.y-5}, force = "neutral"})
			local wreckage3 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x-6, _x.position.y+6}, force = "neutral"})
			local wreckage4 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x+6, _x.position.y-6}, force = "neutral"})
			local wreckage5 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x+11, _x.position.y-6}, force = "neutral"})
			local wreckage6 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x-12, _x.position.y+7}, force = "neutral"})
			local wreckage7 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x-2, _x.position.y+5}, force = "neutral"})
			local wreckage8 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x-6, _x.position.y+2}, force = "neutral"})
			local wreckage9 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x+0, _x.position.y+4}, force = "neutral"})
			local wreckage10 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x+1, _x.position.y+6}, force = "neutral"})
			local wreckage11 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x+3, _x.position.y+9}, force = "neutral"})
			local wreckage12 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x+5, _x.position.y+-9}, force = "neutral"})
			local i = shipSMALL.get_inventory(defines.inventory.chest)
			for x = 1, math_random(3,5), 1 do
				local loot = ship_raffle_SMALL[math_random(1,#ship_raffle_SMALL)]
				i.insert(loot)
			end	
		else
			local rock = event.surface.create_entity({name = "sand-rock-big", position = _x.position, force = "neutral"})
		end
		_x.destroy()
	end
	for _, _x1 in pairs(event.surface.find_entities_filtered({area = event.area, name = {"biter-spawner"}})) do
		local pos = _x1.position
		if math_random(1,96) == 1 then
			local shipSMALL = event.surface.create_entity({name = ships[math_random(1,#ships)], position = _x1.position, force = "neutral"})
			shipSMALL.destructible = false
			shipSMALL.minable = false
			local wreckage1 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x-4, _x1.position.y+4}, force = "neutral"})
			local wreckage2 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x+5, _x1.position.y-5}, force = "neutral"})
			local wreckage3 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x-6, _x1.position.y+6}, force = "neutral"})
			local wreckage4 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x+6, _x1.position.y-6}, force = "neutral"})
			local wreckage5 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x+11, _x1.position.y-6}, force = "neutral"})
			local wreckage6 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x-12, _x1.position.y+7}, force = "neutral"})
			local wreckage7 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x-2, _x1.position.y+5}, force = "neutral"})
			local wreckage8 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x-6, _x1.position.y+2}, force = "neutral"})
			local wreckage9 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x+0, _x1.position.y+4}, force = "neutral"})
			local wreckage10 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x+1, _x1.position.y+6}, force = "neutral"})
			local wreckage11 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x+3, _x1.position.y+9}, force = "neutral"})
			local wreckage12 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x+5, _x1.position.y+-9}, force = "neutral"})
			local i = shipSMALL.get_inventory(defines.inventory.chest)
			for x = 1, math_random(3,5), 1 do
				local loot = ship_raffle_SMALL[math_random(1,#ship_raffle_SMALL)]
				i.insert(loot)
			end	
		else
			local biter_spawner = event.surface.create_entity({name = "biter-spawner", position = _x1.position})
		end
		_x1.destroy()
	end
	for _, _x2 in pairs(event.surface.find_entities_filtered({area = event.area, name = {"spitter-spawner"}})) do
		local pos = _x2.position
		if math_random(1,64) == 1 then
			local shipSMALL = event.surface.create_entity({name = ships[math_random(1,#ships)], position = _x2.position, force = "neutral"})
			shipSMALL.destructible = false
			shipSMALL.minable = false
			local wreckage1 = event.surface.create_entity({name = "mineable-wreckage", position = {_x2.position.x-4, _x2.position.y+4}, force = "neutral"})
			local wreckage2 = event.surface.create_entity({name = "mineable-wreckage", position = {_x2.position.x+5, _x2.position.y-5}, force = "neutral"})
			local wreckage3 = event.surface.create_entity({name = "mineable-wreckage", position = {_x2.position.x-6, _x2.position.y+6}, force = "neutral"})
			local wreckage4 = event.surface.create_entity({name = "mineable-wreckage", position = {_x2.position.x+6, _x2.position.y-6}, force = "neutral"})
			local wreckage5 = event.surface.create_entity({name = "mineable-wreckage", position = {_x2.position.x+11, _x2.position.y-6}, force = "neutral"})
			local wreckage6 = event.surface.create_entity({name = "mineable-wreckage", position = {_x2.position.x-12, _x2.position.y+7}, force = "neutral"})
			local wreckage7 = event.surface.create_entity({name = "mineable-wreckage", position = {_x2.position.x-2, _x2.position.y+5}, force = "neutral"})
			local wreckage8 = event.surface.create_entity({name = "mineable-wreckage", position = {_x2.position.x-6, _x2.position.y+2}, force = "neutral"})
			local wreckage9 = event.surface.create_entity({name = "mineable-wreckage", position = {_x2.position.x+0, _x2.position.y+4}, force = "neutral"})
			local wreckage10 = event.surface.create_entity({name = "mineable-wreckage", position = {_x2.position.x+1, _x2.position.y+6}, force = "neutral"})
			local wreckage11 = event.surface.create_entity({name = "mineable-wreckage", position = {_x2.position.x+3, _x2.position.y+9}, force = "neutral"})
			local wreckage12 = event.surface.create_entity({name = "mineable-wreckage", position = {_x2.position.x+5, _x2.position.y+-9}, force = "neutral"})
			local i = shipSMALL.get_inventory(defines.inventory.chest)
			for x = 1, math_random(3,5), 1 do
				local loot = ship_raffle_SMALL[math_random(1,#ship_raffle_SMALL)]
				i.insert(loot)
			end	
		else
			local biter_spawner = event.surface.create_entity({name = "spitter-spawner", position = _x2.position})
		end
		_x2.destroy()
	end		
end

function wreckage_spawner(event)
	local math_random = math.random
	
	for _, _x in pairs(event.surface.find_entities_filtered({area = event.area, name = {"rock-big"}})) do
		local pos = _x.position
		if math_random(1,32) == 1 then
			local wreckage = event.surface.create_entity({name = "mineable-wreckage", position = _x.position, force = "neutral"})
			local wreckage1 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x-4, _x.position.y+4}, force = "neutral"})
			local wreckage2 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x+5, _x.position.y-5}, force = "neutral"})
			local wreckage3 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x-6, _x.position.y+6}, force = "neutral"})
			local wreckage4 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x+6, _x.position.y-6}, force = "neutral"})
			local wreckage5 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x+11, _x.position.y-6}, force = "neutral"})
			local wreckage6 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x-12, _x.position.y+7}, force = "neutral"})
			local wreckage7 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x-2, _x.position.y+5}, force = "neutral"})
			local wreckage8 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x-6, _x.position.y+2}, force = "neutral"})
			local wreckage9 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x+0, _x.position.y+4}, force = "neutral"})
			local wreckage10 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x+1, _x.position.y+6}, force = "neutral"})
			local wreckage11 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x+3, _x.position.y+9}, force = "neutral"})
			local wreckage12 = event.surface.create_entity({name = "mineable-wreckage", position = {_x.position.x+5, _x.position.y+-9}, force = "neutral"})
		else
			local rock = event.surface.create_entity({name = "rock-big", position = _x.position, force = "neutral"})
		end
		_x.destroy()
	end
	for _, _x1 in pairs(event.surface.find_entities_filtered({area = event.area, name = {"sand-rock-big"}})) do
		local pos = _x1.position
		if math_random(1,32) == 1 then
			local wreckage = event.surface.create_entity({name = "mineable-wreckage", position = _x1.position, force = "neutral"})
			local wreckage1 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x-4, _x1.position.y+4}, force = "neutral"})
			local wreckage2 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x+5, _x1.position.y-5}, force = "neutral"})
			local wreckage3 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x-6, _x1.position.y+6}, force = "neutral"})
			local wreckage4 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x+6, _x1.position.y-6}, force = "neutral"})
			local wreckage5 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x+11, _x1.position.y-6}, force = "neutral"})
			local wreckage6 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x-12, _x1.position.y+7}, force = "neutral"})
			local wreckage7 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x-2, _x1.position.y+5}, force = "neutral"})
			local wreckage8 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x-6, _x1.position.y+2}, force = "neutral"})
			local wreckage9 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x+0, _x1.position.y+4}, force = "neutral"})
			local wreckage10 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x+1, _x1.position.y+6}, force = "neutral"})
			local wreckage11 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x+3, _x1.position.y+9}, force = "neutral"})
			local wreckage12 = event.surface.create_entity({name = "mineable-wreckage", position = {_x1.position.x+5, _x1.position.y+-9}, force = "neutral"})
		else
			local rock2 = event.surface.create_entity({name = "sand-rock-big", position = _x1.position, force = "neutral"})
		end
		_x1.destroy()
	end		
	for _, _x2 in pairs(event.surface.find_entities_filtered({area = event.area, name = {"spitter-spawner"}})) do
		local pos = _x2.position
		if math_random(1,8) == 1 then
			local wreckage = event.surface.create_entity({name = "mineable-wreckage", position = _x2.position, force = "neutral"})
			local wreckage2 = event.surface.create_entity({name = "mineable-wreckage", position = {_x2.position.x-2, _x2.position.y+2}, force = "neutral"})
			local wreckage3 = event.surface.create_entity({name = "mineable-wreckage", position = {_x2.position.x-1, _x2.position.y+2}, force = "neutral"})
			local wreckage4 = event.surface.create_entity({name = "mineable-wreckage", position = {_x2.position.x-3, _x2.position.y+1}, force = "neutral"})
			local wreckage5 = event.surface.create_entity({name = "mineable-wreckage", position = {_x2.position.x-4, _x2.position.y+3}, force = "neutral"})
			local wreckage6 = event.surface.create_entity({name = "mineable-wreckage", position = {_x2.position.x+3, _x2.position.y-1}, force = "neutral"})
			local wreckage7 = event.surface.create_entity({name = "mineable-wreckage", position = {_x2.position.x+2, _x2.position.y-1}, force = "neutral"})
		else
			local biter_spawner = event.surface.create_entity({name = "spitter-spawner", position = _x2.position})
		end
		_x2.destroy()
	end	
	for _, _x3 in pairs(event.surface.find_entities_filtered({area = event.area, name = {"biter-spawner"}})) do
		local pos = _x3.position
		if math_random(1,16) == 1 then
			local wreckage = event.surface.create_entity({name = "mineable-wreckage", position = _x3.position, force = "neutral"})
			local wreckage2 = event.surface.create_entity({name = "mineable-wreckage", position = {_x3.position.x-2, _x3.position.y+2}, force = "neutral"})
			local wreckage3 = event.surface.create_entity({name = "mineable-wreckage", position = {_x3.position.x-1, _x3.position.y+2}, force = "neutral"})
			local wreckage4 = event.surface.create_entity({name = "mineable-wreckage", position = {_x3.position.x-3, _x3.position.y+1}, force = "neutral"})
			local wreckage5 = event.surface.create_entity({name = "mineable-wreckage", position = {_x3.position.x-4, _x3.position.y+3}, force = "neutral"})
			local wreckage6 = event.surface.create_entity({name = "mineable-wreckage", position = {_x3.position.x+3, _x3.position.y-1}, force = "neutral"})
			local wreckage7 = event.surface.create_entity({name = "mineable-wreckage", position = {_x3.position.x+2, _x3.position.y-1}, force = "neutral"})
		else
			local spitter_spawner = event.surface.create_entity({name = "biter-spawner", position = _x3.position})
		end
		_x3.destroy()
	end
	for _, _x4 in pairs(event.surface.find_entities_filtered({area = event.area, name = {"small-worm-turret"}})) do
		local pos = _x4.position
		if math_random(1,4) == 1 then
			local wreckage = event.surface.create_entity({name = "mineable-wreckage", position = _x4.position, force = "neutral"})
		else
			local small_worm = event.surface.create_entity({name = "small-worm-turret", position = _x4.position})
		end
		_x4.destroy()
	end
	for _, _x5 in pairs(event.surface.find_entities_filtered({area = event.area, name = {"medium-worm-turret"}})) do
		local pos = _x5.position
		if math_random(1,6) == 1 then
			local wreckage = event.surface.create_entity({name = "mineable-wreckage", position = _x5.position, force = "neutral"})
		else
			local medium_worm = event.surface.create_entity({name = "medium-worm-turret", position = _x5.position})
		end
		_x5.destroy()
	end
	for _, _x6 in pairs(event.surface.find_entities_filtered({area = event.area, name = {"big-worm-turret"}})) do
		local pos = _x6.position
		if math_random(1,8) == 1 then
			local wreckage = event.surface.create_entity({name = "mineable-wreckage", position = _x6.position, force = "neutral"})
		else
			local medium_worm = event.surface.create_entity({name = "big-worm-turret", position = _x6.position})
		end
		_x6.destroy()
	end		
end

function biters_yield_coins(event)	
	local insert = table.insert

	
	if event.entity.force.name ~= "enemy" then return end	
	if not biter_coin_yield[event.entity.name] then return end
		
	local players_to_reward = {}
	local reward_has_been_given = false
	
	if event.cause then
		if event.cause.valid then
			if event.cause.name == "character" then
				insert(players_to_reward, event.cause)
				reward_has_been_given = true
			end			
			if event.cause.type == "car" then
				player = event.cause.get_driver()
				passenger = event.cause.get_passenger()
				if player then insert(players_to_reward, player.player)	end
				if passenger then insert(players_to_reward, passenger.player) end
				reward_has_been_given = true
			end
			if event.cause.type == "locomotive" then
				train_passengers = event.cause.train.passengers			
				if train_passengers then
					for _, passenger in pairs(train_passengers) do
						insert(players_to_reward, passenger)
					end
					reward_has_been_given = true
				end
			end
			for _, player in pairs(players_to_reward) do
				player.insert({name = "coin", count = biter_coin_yield[event.entity.name]})
			end
		end
		if entities_that_earn_coins[event.cause.name] then
			event.entity.surface.spill_item_stack(event.cause.position,{name = "coin", count = biter_coin_yield[event.entity.name]}, true)
			reward_has_been_given = true
		end
	end	
																	
	if reward_has_been_given == false then
		event.entity.surface.spill_item_stack(event.entity.position,{name = "coin", count = biter_coin_yield[event.entity.name]}, true) 
	end
end

function wreckage_yield_coins(event)	
	if wreckage_coin_yield[event.entity.name] then
		event.entity.surface.spill_item_stack(event.entity.position,{name = "coin", count = math.random(math.ceil(wreckage_coin_yield[event.entity.name] * 0.5), math.ceil(wreckage_coin_yield[event.entity.name] * 1))}, true)
	end
end

function teleporting_worm(event)	
	if not event.cause then return end
	local cause = event.cause
	if cause.type ~= "turret" then return end
	if cause.health <= 0 then return end
	local new_position = {
		x = (cause.position.x + event.entity.position.x) * 0.5,
		y = (cause.position.y + event.entity.position.y) * 0.5
		}
	new_position = {
		x = (cause.position.x + new_position.x) * 0.5,
		y = (cause.position.y + new_position.y) * 0.5
		}
	local new_turret = cause.surface.create_entity({name = cause.name, force = cause.force, position = new_position})
	cause.surface.create_entity({name = "blood-explosion-big", position = new_position})
	cause.surface.create_entity({name = "blood-explosion-big", position = cause.position})
	new_turret.health = cause.health
	cause.destroy()
end

function biters_double_damage(event)
	game.forces.enemy.set_ammo_damage_modifier("melee", 1)
	game.forces.enemy.set_ammo_damage_modifier("biological", 1)
	game.forces.enemy.set_ammo_damage_modifier("artillery-shell", 0.5)
	game.forces.enemy.set_ammo_damage_modifier("flamethrower", 0.5)
	game.forces.enemy.set_ammo_damage_modifier("laser-turret", 0.5)
end

function biters_double_hp(event)
	if not event.entity.valid then return end
	if math.random(1,2) == 1 then return end
	if event.entity.type ~= "unit" then return end	
	event.entity.health = event.entity.health + event.final_damage_amount			
end

function wreckage_double_hp(event)
	if not event.entity.valid then return end
	if math.random(1,4) == 1 then return end
	if event.entity.name ~= "mineable-wreckage" then return end	
	event.entity.health = event.entity.health + event.final_damage_amount * 16			
end

local spiral_coords = {}

for r = 1, 96, 1 do
	for x = r * -1, r - 1, 1 do
		table.insert(spiral_coords, {x = x, y = r * -1})
	end
	for y = r * -1, r - 1, 1 do
		table.insert(spiral_coords, {x = r, y = y})
	end	
	for x = r, r * -1 + 1, -1 do
		table.insert(spiral_coords, {x = x, y = r})
	end	
	for y = r, r * -1 + 1, -1 do
		table.insert(spiral_coords, {x = r * -1, y = y})
	end	
end

local function get_chunk_position(position)
	local chunk_position = {}
	position.x = math.floor(position.x, 0)
	position.y = math.floor(position.y, 0)
	for x = 0, 31, 1 do
		if (position.x - x) % 32 == 0 then chunk_position.x = (position.x - x)  / 32 end
	end
	for y = 0, 31, 1 do
		if (position.y - y) % 32 == 0 then chunk_position.y = (position.y - y)  / 32 end
	end	
	return chunk_position
end

local function is_this_a_valid_source_tile(pos, tiles)
	for _, tile in pairs(tiles) do
		if tile.position.x == pos.x and tile.position.y == pos.y then
			return false
		end
	end
	return true
end

local function place_fitting_tile(position, surface, tiles_placed)		
	for _, coord in pairs(spiral_coords) do
		local tile = surface.get_tile({position.x + coord.x, position.y + coord.y})
		if not tile.collides_with("player-layer") then
			local valid_source_tile = is_this_a_valid_source_tile(tile.position, tiles_placed)			
			if tile.name == "out-of-map" then valid_source_tile = false end
			
			if valid_source_tile then
				if tile.hidden_tile then
					surface.set_tiles({{name = tile.hidden_tile, position = position}}, true)			
				else
					surface.set_tiles({{name = tile.name, position = position}}, true)				
				end
				return
			end	
		end				
	end		
end	
	
function DynamicLandfillPlayer(event)
	local math_random = math.random
	local water_tile_whitelist = {["water"] = true,["deepwater"] = true,["water-green"] = true,["deepwater-green"] = true}

	if event.item.name ~= "landfill" then return end
	local surface = game.surfaces[event.surface_index]
	
	for _, placed_tile in pairs(event.tiles) do
		if water_tile_whitelist[placed_tile.old_tile.name] then
			place_fitting_tile(placed_tile.position, surface, event.tiles)
			if regenerate_decoratives then
				if math_random(1, 5) == 1 then
					regenerate_decoratives(surface, placed_tile.position)
				end
			end
		end
	end		
end

function DynamicLandfillRobot(event)
	local math_random = math.random
	local water_tile_whitelist = {["water"] = true,["deepwater"] = true,["water-green"] = true,["deepwater-green"] = true}

	if event.item.name ~= "landfill" then return end
	local surface = event.robot.surface
	
	for _, placed_tile in pairs(event.tiles) do
		if water_tile_whitelist[placed_tile.old_tile.name] then
			place_fitting_tile(placed_tile.position, surface, event.tiles)
			if regenerate_decoratives then
				if math_random(1, 4) == 1 then
					regenerate_decoratives(surface, placed_tile.position)
				end
			end
		end
	end
end

local junk_ore_raffle = {}				
for _, t in pairs (junk_mining_chance_weights) do
	for x = 1, t[2], 1 do
		table.insert(junk_ore_raffle, t[1])
	end			
end

function JunkYieldOreVeins(event)
	local math_random = math.random
	local scrap_entities = {["mineable-wreckage"] = true,}
	local ore_prints = {["coal"] = {"dark", "Coal"},["iron-ore"] = {"shiny", "Iron"},["copper-ore"] = {"glimmering", "Copper"},["uranium-ore"] = {"glowing", "Uranium"},["stone"] = {"solid", "Stone"}}

	local entity = event.entity
	if not entity.valid then return end
	if scrap_entities[entity.name] then
		if MAP_JUNKYARD_V2 then
			if math_random(1,512) == 1 then
				local player = game.players[event.player_index]
				local p = {x = entity.position.x, y = entity.position.y}
				local tile_distance_to_center = p.x^2 + p.y^2			
				local radius = 2
				if entity.surface.count_entities_filtered{area={{p.x - radius,p.y - radius},{p.x + radius,p.y + radius}}, type="resource", limit=1} == 0 then				
					local size = junk_size_raffle[math_random(1, #junk_size_raffle)]
					local ore = junk_ore_raffle[math_random(1, #junk_ore_raffle)]								
					player.print("You notice something " .. ore_prints[ore][1] .. " underneath the junk covered floor. It's a " .. size[1] .. " vein of " ..  ore_prints[ore][2] .. "!!", { r=0.98, g=0.66, b=0.22})
					tile_distance_to_center = math.sqrt(tile_distance_to_center)
					local ore_entities_placed = 0
					local modifier_raffle = {{0,-1},{-1,0},{1,0},{0,1}}
					while ore_entities_placed < math_random(size[2],size[3]) do						
						local a = math.ceil((math_random(tile_distance_to_center*18, tile_distance_to_center*26)) / 1 + ore_entities_placed * 1.4, 0)						
						for x = 1, 150, 1 do
							local m = modifier_raffle[math_random(1,#modifier_raffle)]
							local pos = {x = p.x + m[1], y = p.y + m[2]}
							if entity.surface.can_place_entity({name=ore, position=pos, amount=a}) then
								entity.surface.create_entity {name=ore, position=pos, amount=a}
								p = pos
								break
							end
						end
						ore_entities_placed = ore_entities_placed + 1
					end
				end			
			end	
		else
			if math_random(1,12) == 1 then
				local player = game.players[event.player_index]
				local p = {x = entity.position.x, y = entity.position.y}
				local tile_distance_to_center = p.x^2 + p.y^2			
				local radius = 2
				if entity.surface.count_entities_filtered{area={{p.x - radius,p.y - radius},{p.x + radius,p.y + radius}}, type="resource", limit=1} == 0 then				
					local size = junk_size_raffle[math_random(1, #junk_size_raffle)]
					local ore = junk_ore_raffle[math_random(1, #junk_ore_raffle)]								
					player.print("You notice something " .. ore_prints[ore][1] .. " underneath the junk covered floor. It's a " .. size[1] .. " vein of " ..  ore_prints[ore][2] .. "!!", { r=0.98, g=0.66, b=0.22})
					tile_distance_to_center = math.sqrt(tile_distance_to_center)
					local ore_entities_placed = 0
					local modifier_raffle = {{0,-1},{-1,0},{1,0},{0,1}}
					while ore_entities_placed < math_random(size[2],size[3]) do						
						local a = math.ceil((math_random(tile_distance_to_center*12, tile_distance_to_center*16)) / 1 + ore_entities_placed * 1.4, 0)						
						for x = 1, 150, 1 do
							local m = modifier_raffle[math_random(1,#modifier_raffle)]
							local pos = {x = p.x + m[1], y = p.y + m[2]}
							if entity.surface.can_place_entity({name=ore, position=pos, amount=a}) then
								entity.surface.create_entity {name=ore, position=pos, amount=a}
								p = pos
								break
							end
						end
						ore_entities_placed = ore_entities_placed + 1
					end
				end			
			end	
		end
	end
end

local scrap_raffle = {}				
for _, t in pairs (mining_chance_weights) do
	for x = 1, t.chance, 1 do
		table.insert(scrap_raffle, t.name)
	end			
end

function mineable_wreckage_yields_scrap(event)
	local insert = table.insert


	local entity = event.entity
	if not entity.valid then return end
	if entity.name ~= "mineable-wreckage" then return end
			
	event.buffer.clear()
	
	local scrap = scrap_raffle[math.random(1, #scrap_raffle)]
	
	local amount_bonus = (game.forces.player.mining_drill_productivity_bonus * 4)
	local r1 = math.ceil(scrap_yield_amounts[scrap] * (0.3 + (amount_bonus * 0.3)))
	local r2 = math.ceil(scrap_yield_amounts[scrap] * (1.7 + (amount_bonus * 1.7)))	
	local amount = math.random(r1, r2)
	
	local player = game.players[event.player_index]	
	local inserted_count = player.insert({name = scrap, count = amount})
	
	if inserted_count ~= amount then
		local amount_to_spill = amount - inserted_count			
		entity.surface.spill_item_stack(entity.position,{name = scrap, count = amount_to_spill}, true)
	end
	
	entity.surface.create_entity({
		name = "flying-text",
		position = entity.position,
		text = "+" .. amount .. " [img=item/" .. scrap .. "]",
		color = {r=0.98, g=0.66, b=0.22}
	})	
end

local damage_min = 400
local damage_max = 800
local additional_visual_effects = true
local do_splash_damage = true

local biological_target_types = {
	["unit"] = true,
	["player"] = true,
	["turret"] = true,
	["unit-spawner"] = true	
}

local function create_visuals(source_entity, target_entity)
	local math_random = math.random
	if not additional_visual_effects then return end
	local surface = target_entity.surface		
	surface.create_entity({name = "water-splash", position = target_entity.position})
	if biological_target_types[target_entity.type] then
		surface.create_entity({name = "blood-explosion-big", position = target_entity.position})
		for x = -8, 8, 1 do
			for y = -8, 8, 1 do
				if math_random(1, 16) == 1 then
					surface.create_entity({name = "blood-fountain", position = {target_entity.position.x + (x * 0.1), target_entity.position.y + (y * 0.1)}})
					surface.create_entity({name = "blood-fountain-big", position = {target_entity.position.x + (x * 0.1), target_entity.position.y + (y * 0.1)}})
				end
			end
		end
	else
		if math_random(1, 3) ~= 1 then
			surface.create_entity({name = "fire-flame", position = target_entity.position})
		end
		for x = -3, 3, 1 do
			for y = -3, 3, 1 do													
				if math_random(1, 3) == 1 then
					surface.create_trivial_smoke({name="smoke-fast", position={target_entity.position.x + (x * 0.35), target_entity.position.y + (y * 0.35)}})						
				end
				if math_random(1, 5) == 1 then
					surface.create_trivial_smoke({name="train-smoke", position={target_entity.position.x + (x * 0.35), target_entity.position.y + (y * 0.35)}})						
				end
			end
		end
	end			
end

function rocks_yield_coins(event)	
	if coin_yield[event.entity.name] then
		event.entity.surface.spill_item_stack(event.entity.position,{name = "coin", count = math.random(math.ceil(coin_yield[event.entity.name] * 0.5), math.ceil(coin_yield[event.entity.name] * 2))}, true)
	end
end

local function do_splash_damage_around_entity(source_entity, player)
	local math_random = math.random
	if not do_splash_damage then return end
	local research_damage_bonus = player.force.get_ammo_damage_modifier("laser-turret") + 1
	local research_splash_radius_bonus = player.force.get_ammo_damage_modifier("laser-turret") * 0.5
	local splash_area = {
			{source_entity.position.x - (2.5 + research_splash_radius_bonus), source_entity.position.y - (2.5 + research_splash_radius_bonus)},
			{source_entity.position.x + (2.5 + research_splash_radius_bonus), source_entity.position.y + (2.5 + research_splash_radius_bonus)}
		}
	local entities = source_entity.surface.find_entities_filtered({area = splash_area})
	for _, entity in pairs(entities) do
		if entity.health and entity ~= source_entity and entity ~= player then
			if additional_visual_effects then
				local surface = entity.surface
				surface.create_entity({name = "railgun-beam", position = source_entity.position, source = source_entity.position, target = entity.position})
				surface.create_entity({name = "water-splash", position = entity.position})
				if biological_target_types[entity.type] then								
					surface.create_entity({name = "blood-fountain", position = entity.position})				
				end
			end
			local damage = math_random(math.ceil((damage_min * research_damage_bonus) / 16), math.ceil((damage_max * research_damage_bonus) / 16))			
			entity.damage(damage, player.force, "physical")	
		end
	end
end

function railgun_enhancer(event)
	local math_random = math.random
	if not event.cause then return end
	if event.cause.name ~= "character" then return end
	if event.damage_type.name ~= "physical" then return end
	if event.original_damage_amount ~= 100 then return end
	
	local player = event.cause
	if player.shooting_state.state == defines.shooting.not_shooting then return end
	local selected_weapon = player.get_inventory(defines.inventory.character_guns)[player.selected_gun_index]
	if selected_weapon.name ~= "railgun" then return end
	
	create_visuals(event.cause, event.entity)
	
	do_splash_damage_around_entity(event.entity, player)
	
	event.entity.health = event.entity.health + event.final_damage_amount
	
	local research_damage_bonus = player.force.get_ammo_damage_modifier("laser-turret") + 1	
	local damage = math_random(math.ceil(damage_min * research_damage_bonus), math.ceil(damage_max * research_damage_bonus))
	event.entity.damage(damage, player.force, "physical")	
end

function shotgun_buff(event)
	local research = event.research
	if string.sub(research.name, 0, 26) ~= "physical-projectile-damage" then return end
	local multiplier = 4
	if global.shotgun_shell_damage_research_multiplier then multiplier = global.shotgun_shell_damage_research_multiplier end
	
	local modifier = game.forces[research.force.name].get_ammo_damage_modifier("shotgun-shell")
	
	modifier = modifier - research.effects[3].modifier
	modifier = modifier + research.effects[3].modifier * multiplier
	
	game.forces[research.force.name].set_ammo_damage_modifier("shotgun-shell", modifier)
end

function rocks_yield_coins(event)	
	if rock_coin_yield[event.entity.name] then
		event.entity.surface.spill_item_stack(event.entity.position,{name = "coin", count = math.random(math.ceil(rock_coin_yield[event.entity.name] * 0.5), math.ceil(rock_coin_yield[event.entity.name] * 2))}, true)
	end
end

local texts = {
	["iron-ore"] = {"Iron ore", {r = 200, g = 200, b = 180}},
	["copper-ore"] = {"Copper ore", {r = 221, g = 133, b = 6}},
	["uranium-ore"] = {"Uranium ore", {r= 50, g= 250, b= 50}},
	["coal"] = {"Coal", {r = 0, g = 0, b = 0}},
	["stone"] = {"Stone", {r = 200, g = 160, b = 30}},
}
		
local ore_raffle = {}				
for _, t in pairs (rock_mining_chance_weights) do
	for x = 1, t[2], 1 do
		table.insert(ore_raffle, t[1])
	end			
end

local function get_amount(entity)
	local distance_to_center = math.sqrt(entity.position.x^2 + entity.position.y^2)
	local amount = 2 + (distance_to_center * 0.02)
	if amount > 150 then amount = 150 end
	amount = rock_yield[entity.name] * amount
	amount = math.random(math.ceil(amount * 0.3), math.ceil(amount * 0.5))	
	return amount
end

local coords = {{x = 0, y = 0},{x = -1, y = -1},{x = 1, y = -1},{x = 0, y = -1},{x = -1, y = 0},{x = -1, y = 1},{x = 0, y = 1},{x = 1, y = 1},{x = 1, y = 0}}

function rocks_yield_ore_on_player(event)
	local entity = event.entity
	if not entity.valid then return end
	if rock_yield[entity.name] then
		event.buffer.clear()
		local amount = get_amount(entity)
		local ore = ore_raffle[math.random(1, #ore_raffle)]
		entity.surface.spill_item_stack(entity.position,{name = ore, count = amount}, true)
		entity.surface.create_entity({name = "flying-text", position = entity.position, text = amount .. " " .. texts[ore][1], color = texts[ore][2]})	
	end
end

function rocks_yield_ore_on_entity_died(event)	
	local entity = event.entity
	if not entity.valid then return end
	if rock_yield[entity.name] then
		local surface = entity.surface
		local amount = get_amount(entity)
		amount = math.ceil(amount * 0.2)
		local ore = ore_raffle[math.random(1, #ore_raffle)]
		local pos = {entity.position.x, entity.position.y}
		entity.destroy()
		surface.spill_item_stack(pos,{name = ore, count = amount}, true)
	end
end

function CoinBank(event)
	local math_random = math.random
	local insert = table.insert

	if not COIN_BANK_ENABLE then return end
	local player = game.players[event.player_index]	
	local market = event.market
	local offer_index = event.offer_index
	local count = event.count
	local offers = market.get_market_items()	
	local bought_offer = offers[offer_index].offer	
	if bought_offer.type ~= "nothing" then return end
	if not global.coin_bank then global.coin_bank = {} end
	if not global.coin_bank[player.name] then global.coin_bank[player.name] = 0 end
	
	if offer_index == 1 then
		local coin_removed = player.remove_item({name = "coin", count = 999999})
		if coin_removed == 0 then return end
		global.coin_bank[player.name] = global.coin_bank[player.name] + coin_removed				
		player.print(coin_removed .. " Coin´s deposited into your account. Your balance is " .. global.coin_bank[player.name] .. ".", {r=0.10, g=0.75, b=0.5})
		player.print(bank_messages[math_random(1,#bank_messages)], { r=0.77, g=0.77, b=0.77})
		player.surface.create_entity({name = "flying-text", position = player.position, text = tostring(coin_removed .. " Coin´s deposited"), color = {r=0.10, g=0.75, b=0.5}})
	end
	
	if offer_index == 2 then
		if global.coin_bank[player.name] == 0 then
			player.print("No coin´s in your Bank account :(", { r=0.10, g=0.75, b=0.5})
			return
		end
		
		local requested_withdraw_amount = 500
		local fee = 10		
		if global.coin_bank[player.name] < requested_withdraw_amount + fee then		
			fee = math.ceil(global.coin_bank[player.name] * 0.01, 0)
			if global.coin_bank[player.name] < 10 then fee = 0 end
			requested_withdraw_amount = global.coin_bank[player.name] - fee
		end			
		local coin_withdrawn = player.insert({name = "coin", count = requested_withdraw_amount})
		if coin_withdrawn ~= requested_withdraw_amount then
			player.remove_item({name = "coin", count = coin_withdrawn})
			return
		end								
		global.coin_bank[player.name] = global.coin_bank[player.name] - (coin_withdrawn + fee)
		player.print(coin_withdrawn .. " Coin´s withdrawn from your account. Your balance is " .. global.coin_bank[player.name] .. ".", { r=0.10, g=0.75, b=0.5})
		player.print(bank_messages[math_random(1,#bank_messages)], { r=0.77, g=0.77, b=0.77})
		player.surface.create_entity({name = "flying-text", position = player.position, text = tostring(coin_withdrawn .. " Coin´s withdrawn"), color = {r=0.10, g=0.75, b=0.5}})
	end	
	
	if offer_index == 3 then						
		player.print("Your balance is " .. global.coin_bank[player.name] .. " Coin´s.", { r=0.10, g=0.75, b=0.5})
	end
end

function CoinBoost(event)
	local math_random = math.random
	if not COIN_BOOST_ENABLE then return end
	if not COIN_BANK_ENABLE then return end
	local player = game.players[event.player_index]	
	local market = event.market
	local offer_index = event.offer_index
	local count = event.count
	local offers = market.get_market_items()	
	local bought_offer = offers[offer_index].offer

	if bought_offer.type ~= "nothing" then return end
	
	if offer_index == 4 then
		if player.character.character_inventory_slots_bonus == 50 then return end	
		player.print("Inventory bonus +5", { r=0.10, g=0.75, b=0.5})
		BOOST_Inventory_5(player)
	end
	
	if offer_index == 5 then
		if player.force.manual_crafting_speed_modifier == 0.50 then return end
		player.print("Crafting speed +5%", { r=0.10, g=0.75, b=0.5})
		BOOST_Crafting_5(player)
	end
end

function spawners_contain_biters(event)	
	local math_random = math.random
	if event.entity.type ~= "unit-spawner" then return end
	local e = math.ceil(game.forces.enemy.evolution_factor*10, 0)		
	
	for _, t in pairs (biter_building_inhabitants[e]) do		
	for x = 1, math_random(t[2],t[3]), 1 do
		local p = event.entity.surface.find_non_colliding_position(t[1] , event.entity.position, 6, 1)			
			if p then event.entity.surface.create_entity {name=t[1], position=p} end
		end
	end
end

function spawners_double_hp(event)
	if not event.entity.valid then return end
	if math.random(1,2) == 1 then return end
	if event.entity.type ~= "unit-spawner" then return end	
	event.entity.health = event.entity.health + event.final_damage_amount			
end

function splice(event)	
	if not event.entity.valid then return end
	if biter_fragmentation[event.entity.name] then
		local entity = event.entity
		local amount = 1
		if global.splice_modifier then amount = math.ceil(global.splice_modifier * biter_fragmentation[entity.name][2]) end
		if amount < 1 then return end
		
		for x = 1, amount, 1 do
			local p = entity.surface.find_non_colliding_position(biter_fragmentation[entity.name][1] , entity.position, 3, 0.5)
			if p then entity.surface.create_entity({name = biter_fragmentation[entity.name][1], position = p}) end
		end
		
	end
end

function UnearthingBiters_night(event)
	local math_random = math.random
	local player = game.players[event.player_index]
	local playtime = player.online_time
	if not player.character then return end
	if player.character.driving == true then return end
	if player.surface.daytime < 0.33 then return end
	if player.surface.daytime > 0.66 then return end
	if math_random(1,256) ~= 1 then return end	
	if playtime < TICKS_PER_MINUTE * 30 then return end
	
	for _, lamp in pairs(player.surface.find_entities_filtered({area={{player.position.x - 18, player.position.y - 18},{player.position.x + 18, player.position.y + 18}}, name="small-lamp"})) do
		local circuit = lamp.get_or_create_control_behavior()
		if circuit then
			if lamp.energy > 25 and circuit.disabled == false then								
				return
			end
		else
			if lamp.energy > 25 then								
				return
			end
		end
	end
	
	local positions = {}
	local r = 8
	for x = r * -1, r, 1 do
		for y = r * -1, r, 1 do
			local distance_to_center = math.sqrt(x^2 + x^2)
			if distance_to_center > 2 and distance_to_center < 7 then
				if player.surface.can_place_entity({name = "stone-furnace", position = {x = player.position.x + x, y = player.position.y + y}}) then
					positions[#positions + 1] = {x = player.position.x + x, y = player.position.y + y}
				end
			end
		end
	end
	
	if #positions == 0 then return end
	if playtime > TICKS_PER_MINUTE * 30 and playtime < TICKS_PER_MINUTE * 60 then
		if math_random(1,2) == 1 then
			unearthing_biters_small(player.surface, positions[math_random(1, #positions)], math_random(1,2))
		else
			unearthing_worm_small(player.surface, positions[math_random(1, #positions)])
		end
	end
	if playtime > TICKS_PER_MINUTE * 60 then
		if math_random(1,2) == 1 then
			unearthing_biters(player.surface, positions[math_random(1, #positions)], math_random(2,4))
		else
			unearthing_worm(player.surface, positions[math_random(1, #positions)])
		end
	end
end

function UnearthingBiters_wreckage(event)
	local math_random = math.random
	local player = game.players[event.player_index]
	local playtime = player.online_time
	local entity = event.entity
	if not player.character then return end
	if not entity.valid then return end
	if playtime < TICKS_PER_MINUTE * 15 then return end
	
	if entity.name == "mineable-wreckage" then
		if playtime > TICKS_PER_MINUTE * 15 and playtime < TICKS_PER_MINUTE * 60 then
			if math_random(1,40) == 1 then unearthing_biters_small(entity.surface, entity.position, math_random(1,2)) end	
		end
		if playtime > TICKS_PER_MINUTE * 60 and playtime < TICKS_PER_MINUTE * 180 then
			if math_random(1,40) == 1 then unearthing_biters_small(entity.surface, entity.position, math_random(1,4)) end			
			if math_random(1,60) == 1 then unearthing_worm_small(entity.surface, entity.position) end
		end
		if playtime > TICKS_PER_MINUTE * 180 then
			if math_random(1,40) == 1 then unearthing_biters(entity.surface, entity.position, math_random(3,8)) end			
			if math_random(1,60) == 1 then unearthing_worm(entity.surface, entity.position) end
		end
	end
	
	if entity.force.name ~= "scrap" then return end
	local positions = {}
	local r = math.ceil(entity.prototype.max_health / 32)
	for x = r * -1, r, 1 do
		for y = r * -1, r, 1 do
			positions[#positions + 1] = {x = entity.position.x + x, y = entity.position.y + y}
		end
	end
	positions = shuffle(positions)
	for i = 1, math.ceil(entity.prototype.max_health / 32), 1 do
		if not positions[i] then return end
		if math_random(1,3) ~= 1 then
			unearthing_biters(entity.surface, positions[i], math_random(5,10))
		else
			unearthing_worm(entity.surface, positions[i])
		end			
	end
end

function Scrap_defense(event)
	local math_random = math.random
	local player = game.players[event.player_index]
	local playtime = player.online_time
	local entity = event.entity
	if not entity.valid then return end
	if playtime < TICKS_PER_MINUTE * 30 then return end
	
	if entity.name == "mineable-wreckage" then
		if playtime > TICKS_PER_MINUTE * 30 and playtime < TICKS_PER_MINUTE * 90 then
			if math_random(1,60) == 1 then tick_tack_trap_small(entity.surface, entity.position) end	
		end
		if playtime > TICKS_PER_MINUTE * 90 then
			if math_random(1,60) == 1 then tick_tack_trap(entity.surface, entity.position, math_random(1,2)) end			
		end

	end
	
	if entity.force.name ~= "scrap" then return end
	local positions = {}
	local r = math.ceil(entity.prototype.max_health / 32)
	for x = r * -1, r, 1 do
		for y = r * -1, r, 1 do
			positions[#positions + 1] = {x = entity.position.x + x, y = entity.position.y + y}
		end
	end
end

local function draw_map_tag(surface, force, position)
	force.add_chart_tag(surface, {icon = {type = 'item', name = 'heavy-armor'}, position = position, text = "CORPSE"})
end

local function is_tag_valid(tag)
	if not tag.icon then return end
	if tag.icon.type ~= "item" then return end
	if tag.icon.name ~= "heavy-armor" then return end
	if tag.text ~= "   " then return end
	return true
end

local function get_corpse_force(corpse)
	if corpse.character_corpse_player_index then 
		if game.players[corpse.character_corpse_player_index] then
			return game.players[corpse.character_corpse_player_index].force
		end
	end
	return game.forces.neutral
end

local function destroy_all_tags()
	for _, force in pairs(game.forces) do
		for _, surface in pairs(game.surfaces) do
			for _, tag in pairs(force.find_chart_tags(surface)) do
				if is_tag_valid(tag) then tag.destroy() end
			end
		end
	end
end

local function redraw_all_tags()
	for _, surface in pairs(game.surfaces) do
		for _, corpse in pairs(surface.find_entities_filtered({name = "character-corpse"})) do
			draw_map_tag(corpse.surface, get_corpse_force(corpse), corpse.position)
		end
	end
end

local function find_and_destroy_tag(corpse)
	local force = get_corpse_force(corpse)
	for _, tag in pairs(force.find_chart_tags(corpse.surface, {{corpse.position.x - 0.1, corpse.position.y - 0.1}, {corpse.position.x + 0.1, corpse.position.y + 0.1}})) do		
		if is_tag_valid(tag) then
			tag.destroy()
			return true
		end		
	end
	return false
end

function draw_player_corpse(event)
	local player = game.players[event.player_index]
	draw_map_tag(player.surface, player.force, player.position)
end

function remove_expired_corpse_marker(event)
	if find_and_destroy_tag(event.corpse) then return end
	destroy_all_tags()
	redraw_all_tags()
end

function remove_mined_corpse_marker(event)
	if event.entity.name ~= "character-corpse" then return end	
	if find_and_destroy_tag(event.entity) then return end
	destroy_all_tags()
	redraw_all_tags()
end

local spawner_acid_radius = 48
local spawner_targets = {}

local small_spitter_acid_radius = 16
local small_spitter_targets = {}

local medium_spitter_acid_radius = 32
local medium_spitter_targets = {}

local big_spitter_acid_radius = 64
local big_spitter_targets = {}

local behemoth_spitter_acid_radius = 96
local behemoth_spitter_targets = {}

for x = spawner_acid_radius * -1, spawner_acid_radius, 1 do
	for y = spawner_acid_radius * -1, spawner_acid_radius, 1 do
		if math.sqrt(x^2 + y^2) <= spawner_acid_radius then
			spawner_targets[#spawner_targets + 1] = {x = x, y = y}
		end
	end
end

function spawners_contain_acid(event)	
	if not event.entity.valid then return end
	if event.entity.type ~= "unit-spawner" then return end		
	for _ = 1, math.random(16, 32) do
		local i = math.random(1, #spawner_targets)		
		event.entity.surface.create_entity({	
			name = "acid-stream-worm-medium",
			position = event.entity.position,
			force = event.entity.force.name,
			source = event.entity.position,
			target = {x = event.entity.position.x + spawner_targets[i].x, y = event.entity.position.y + spawner_targets[i].y},
			max_range = spawner_acid_radius, 
			speed = 0.001
		})
	end	
end

for x = small_spitter_acid_radius * -1, small_spitter_acid_radius, 1 do
	for y = small_spitter_acid_radius * -1, small_spitter_acid_radius, 1 do
		if math.sqrt(x^2 + y^2) <= small_spitter_acid_radius then
			small_spitter_targets[#small_spitter_targets + 1] = {x = x, y = y}
		end
	end
end

function small_spitter_contain_acid(event)	
	if not event.entity.valid then return end
	if event.entity.name ~= "small-spitter" then return end		
	for _ = 1, math.random(2, 4) do
		local i = math.random(1, #small_spitter_targets)		
		event.entity.surface.create_entity({	
			name = "acid-stream-worm-medium",
			position = event.entity.position,
			force = event.entity.force.name,
			source = event.entity.position,
			target = {x = event.entity.position.x + small_spitter_targets[i].x, y = event.entity.position.y + small_spitter_targets[i].y},
			max_range = small_spitter_acid_radius, 
			speed = 0.001
		})
	end	
end

for x = medium_spitter_acid_radius * -1, medium_spitter_acid_radius, 1 do
	for y = medium_spitter_acid_radius * -1, medium_spitter_acid_radius, 1 do
		if math.sqrt(x^2 + y^2) <= medium_spitter_acid_radius then
			medium_spitter_targets[#medium_spitter_targets + 1] = {x = x, y = y}
		end
	end
end

function medium_spitter_contain_acid(event)	
	if not event.entity.valid then return end
	if event.entity.name ~= "medium-spitter" then return end		
	for _ = 1, math.random(4, 8) do
		local i = math.random(1, #medium_spitter_targets)		
		event.entity.surface.create_entity({	
			name = "acid-stream-worm-big",
			position = event.entity.position,
			force = event.entity.force.name,
			source = event.entity.position,
			target = {x = event.entity.position.x + medium_spitter_targets[i].x, y = event.entity.position.y + medium_spitter_targets[i].y},
			max_range = medium_spitter_acid_radius, 
			speed = 0.001
		})
	end	
end

for x = big_spitter_acid_radius * -1, big_spitter_acid_radius, 1 do
	for y = big_spitter_acid_radius * -1, big_spitter_acid_radius, 1 do
		if math.sqrt(x^2 + y^2) <= big_spitter_acid_radius then
			big_spitter_targets[#big_spitter_targets + 1] = {x = x, y = y}
		end
	end
end

function big_spitter_contain_acid(event)	
	if not event.entity.valid then return end
	if event.entity.name ~= "big-spitter" then return end		
	for _ = 1, math.random(12, 16) do
		local i = math.random(1, #big_spitter_targets)		
		event.entity.surface.create_entity({	
			name = "acid-stream-worm-behemoth",
			position = event.entity.position,
			force = event.entity.force.name,
			source = event.entity.position,
			target = {x = event.entity.position.x + big_spitter_targets[i].x, y = event.entity.position.y + big_spitter_targets[i].y},
			max_range = big_spitter_acid_radius, 
			speed = 0.001
		})
	end	
end

for x = behemoth_spitter_acid_radius * -1, behemoth_spitter_acid_radius, 1 do
	for y = behemoth_spitter_acid_radius * -1, behemoth_spitter_acid_radius, 1 do
		if math.sqrt(x^2 + y^2) <= behemoth_spitter_acid_radius then
			behemoth_spitter_targets[#behemoth_spitter_targets + 1] = {x = x, y = y}
		end
	end
end

function behemoth_spitter_contain_acid(event)	
	if not event.entity.valid then return end
	if event.entity.name ~= "behemoth-spitter" then return end		
	for _ = 1, math.random(16, 20) do
		local i = math.random(1, #behemoth_spitter_targets)		
		event.entity.surface.create_entity({	
			name = "acid-stream-worm-behemoth",
			position = event.entity.position,
			force = event.entity.force.name,
			source = event.entity.position,
			target = {x = event.entity.position.x + behemoth_spitter_targets[i].x, y = event.entity.position.y + behemoth_spitter_targets[i].y},
			max_range = behemoth_spitter_acid_radius, 
			speed = 0.001
		})
	end	
end

local damage_per_explosive = 100
local empty_tile_damage_decay = 100
local out_of_map_tile_health = 1500

local circle_coordinates = {
	[1] = {{x = 0, y = 0}},
	[2] = {{x = -1, y = -1},{x = 1, y = -1},{x = 0, y = -1},{x = -1, y = 0},{x = -1, y = 1},{x = 0, y = 1},{x = 1, y = 1},{x = 1, y = 0}},
	[3] = {{x = -2, y = -1},{x = -1, y = -2},{x = 1, y = -2},{x = 0, y = -2},{x = 2, y = -1},{x = -2, y = 1},{x = -2, y = 0},{x = 2, y = 1},{x = 2, y = 0},{x = -1, y = 2},{x = 1, y = 2},{x = 0, y = 2}},
	[4] = {{x = -1, y = -3},{x = 1, y = -3},{x = 0, y = -3},{x = -3, y = -1},{x = -2, y = -2},{x = 3, y = -1},{x = 2, y = -2},{x = -3, y = 0},{x = -3, y = 1},{x = 3, y = 1},{x = 3, y = 0},{x = -2, y = 2},{x = -1, y = 3},{x = 0, y = 3},{x = 1, y = 3},{x = 2, y = 2}},
	[5] = {{x = -3, y = -3},{x = -2, y = -3},{x = -1, y = -4},{x = -2, y = -4},{x = 1, y = -4},{x = 0, y = -4},{x = 2, y = -3},{x = 3, y = -3},{x = 2, y = -4},{x = -3, y = -2},{x = -4, y = -1},{x = -4, y = -2},{x = 3, y = -2},{x = 4, y = -1},{x = 4, y = -2},{x = -4, y = 1},{x = -4, y = 0},{x = 4, y = 1},{x = 4, y = 0},{x = -3, y = 3},{x = -3, y = 2},{x = -4, y = 2},{x = -2, y = 3},{x = 2, y = 3},{x = 3, y = 3},{x = 3, y = 2},{x = 4, y = 2},{x = -2, y = 4},{x = -1, y = 4},{x = 0, y = 4},{x = 1, y = 4},{x = 2, y = 4}},
	[6] = {{x = -1, y = -5},{x = -2, y = -5},{x = 1, y = -5},{x = 0, y = -5},{x = 2, y = -5},{x = -3, y = -4},{x = -4, y = -3},{x = 3, y = -4},{x = 4, y = -3},{x = -5, y = -1},{x = -5, y = -2},{x = 5, y = -1},{x = 5, y = -2},{x = -5, y = 1},{x = -5, y = 0},{x = 5, y = 1},{x = 5, y = 0},{x = -5, y = 2},{x = -4, y = 3},{x = 4, y = 3},{x = 5, y = 2},{x = -3, y = 4},{x = -2, y = 5},{x = -1, y = 5},{x = 0, y = 5},{x = 1, y = 5},{x = 3, y = 4},{x = 2, y = 5}},
	[7] = {{x = -4, y = -5},{x = -3, y = -5},{x = -2, y = -6},{x = -1, y = -6},{x = 0, y = -6},{x = 1, y = -6},{x = 3, y = -5},{x = 2, y = -6},{x = 4, y = -5},{x = -5, y = -4},{x = -5, y = -3},{x = -4, y = -4},{x = 4, y = -4},{x = 5, y = -4},{x = 5, y = -3},{x = -6, y = -1},{x = -6, y = -2},{x = 6, y = -1},{x = 6, y = -2},{x = -6, y = 1},{x = -6, y = 0},{x = 6, y = 1},{x = 6, y = 0},{x = -5, y = 3},{x = -6, y = 2},{x = 5, y = 3},{x = 6, y = 2},{x = -5, y = 4},{x = -4, y = 4},{x = -4, y = 5},{x = -3, y = 5},{x = 3, y = 5},{x = 4, y = 4},{x = 5, y = 4},{x = 4, y = 5},{x = -1, y = 6},{x = -2, y = 6},{x = 1, y = 6},{x = 0, y = 6},{x = 2, y = 6}},
	[8] = {{x = -1, y = -7},{x = -2, y = -7},{x = 1, y = -7},{x = 0, y = -7},{x = 2, y = -7},{x = -5, y = -5},{x = -4, y = -6},{x = -3, y = -6},{x = 3, y = -6},{x = 4, y = -6},{x = 5, y = -5},{x = -6, y = -3},{x = -6, y = -4},{x = 6, y = -4},{x = 6, y = -3},{x = -7, y = -1},{x = -7, y = -2},{x = 7, y = -1},{x = 7, y = -2},{x = -7, y = 1},{x = -7, y = 0},{x = 7, y = 1},{x = 7, y = 0},{x = -7, y = 2},{x = -6, y = 3},{x = 6, y = 3},{x = 7, y = 2},{x = -5, y = 5},{x = -6, y = 4},{x = 5, y = 5},{x = 6, y = 4},{x = -3, y = 6},{x = -4, y = 6},{x = -2, y = 7},{x = -1, y = 7},{x = 0, y = 7},{x = 1, y = 7},{x = 3, y = 6},{x = 2, y = 7},{x = 4, y = 6}},
	[9] = {{x = -4, y = -7},{x = -3, y = -7},{x = -2, y = -8},{x = -1, y = -8},{x = 0, y = -8},{x = 1, y = -8},{x = 3, y = -7},{x = 2, y = -8},{x = 4, y = -7},{x = -5, y = -6},{x = -6, y = -6},{x = -6, y = -5},{x = 5, y = -6},{x = 6, y = -5},{x = 6, y = -6},{x = -7, y = -4},{x = -7, y = -3},{x = 7, y = -4},{x = 7, y = -3},{x = -8, y = -2},{x = -8, y = -1},{x = 8, y = -1},{x = 8, y = -2},{x = -8, y = 0},{x = -8, y = 1},{x = 8, y = 1},{x = 8, y = 0},{x = -7, y = 3},{x = -8, y = 2},{x = 7, y = 3},{x = 8, y = 2},{x = -7, y = 4},{x = -6, y = 5},{x = 6, y = 5},{x = 7, y = 4},{x = -5, y = 6},{x = -6, y = 6},{x = -4, y = 7},{x = -3, y = 7},{x = 3, y = 7},{x = 5, y = 6},{x = 4, y = 7},{x = 6, y = 6},{x = -2, y = 8},{x = -1, y = 8},{x = 0, y = 8},{x = 1, y = 8},{x = 2, y = 8}},
	[10] = {{x = -3, y = -9},{x = -1, y = -9},{x = -2, y = -9},{x = 1, y = -9},{x = 0, y = -9},{x = 3, y = -9},{x = 2, y = -9},{x = -5, y = -7},{x = -6, y = -7},{x = -5, y = -8},{x = -4, y = -8},{x = -3, y = -8},{x = 3, y = -8},{x = 5, y = -7},{x = 5, y = -8},{x = 4, y = -8},{x = 6, y = -7},{x = -7, y = -5},{x = -7, y = -6},{x = -8, y = -5},{x = 7, y = -5},{x = 7, y = -6},{x = 8, y = -5},{x = -9, y = -3},{x = -8, y = -4},{x = -8, y = -3},{x = 8, y = -4},{x = 8, y = -3},{x = 9, y = -3},{x = -9, y = -1},{x = -9, y = -2},{x = 9, y = -1},{x = 9, y = -2},{x = -9, y = 1},{x = -9, y = 0},{x = 9, y = 1},{x = 9, y = 0},{x = -9, y = 3},{x = -9, y = 2},{x = -8, y = 3},{x = 8, y = 3},{x = 9, y = 3},{x = 9, y = 2},{x = -7, y = 5},{x = -8, y = 5},{x = -8, y = 4},{x = 7, y = 5},{x = 8, y = 5},{x = 8, y = 4},{x = -7, y = 6},{x = -6, y = 7},{x = -5, y = 7},{x = 5, y = 7},{x = 7, y = 6},{x = 6, y = 7},{x = -5, y = 8},{x = -4, y = 8},{x = -3, y = 8},{x = -3, y = 9},{x = -2, y = 9},{x = -1, y = 9},{x = 0, y = 9},{x = 1, y = 9},{x = 3, y = 8},{x = 2, y = 9},{x = 3, y = 9},{x = 5, y = 8},{x = 4, y = 8}},
	[11] = {{x = -5, y = -9},{x = -4, y = -9},{x = -3, y = -10},{x = -1, y = -10},{x = -2, y = -10},{x = 1, y = -10},{x = 0, y = -10},{x = 3, y = -10},{x = 2, y = -10},{x = 5, y = -9},{x = 4, y = -9},{x = -7, y = -7},{x = -6, y = -8},{x = 7, y = -7},{x = 6, y = -8},{x = -9, y = -5},{x = -8, y = -6},{x = 9, y = -5},{x = 8, y = -6},{x = -9, y = -4},{x = -10, y = -3},{x = 9, y = -4},{x = 10, y = -3},{x = -10, y = -2},{x = -10, y = -1},{x = 10, y = -1},{x = 10, y = -2},{x = -10, y = 0},{x = -10, y = 1},{x = 10, y = 1},{x = 10, y = 0},{x = -10, y = 2},{x = -10, y = 3},{x = 10, y = 3},{x = 10, y = 2},{x = -9, y = 4},{x = -9, y = 5},{x = 9, y = 5},{x = 9, y = 4},{x = -8, y = 6},{x = -7, y = 7},{x = 7, y = 7},{x = 8, y = 6},{x = -6, y = 8},{x = -5, y = 9},{x = -4, y = 9},{x = 4, y = 9},{x = 5, y = 9},{x = 6, y = 8},{x = -3, y = 10},{x = -2, y = 10},{x = -1, y = 10},{x = 0, y = 10},{x = 1, y = 10},{x = 2, y = 10},{x = 3, y = 10}},
	[12] = {{x = -3, y = -11},{x = -2, y = -11},{x = -1, y = -11},{x = 0, y = -11},{x = 1, y = -11},{x = 2, y = -11},{x = 3, y = -11},{x = -7, y = -9},{x = -6, y = -9},{x = -5, y = -10},{x = -4, y = -10},{x = 5, y = -10},{x = 4, y = -10},{x = 7, y = -9},{x = 6, y = -9},{x = -9, y = -7},{x = -7, y = -8},{x = -8, y = -8},{x = -8, y = -7},{x = 7, y = -8},{x = 8, y = -7},{x = 8, y = -8},{x = 9, y = -7},{x = -9, y = -6},{x = -10, y = -5},{x = 9, y = -6},{x = 10, y = -5},{x = -11, y = -3},{x = -10, y = -4},{x = 10, y = -4},{x = 11, y = -3},{x = -11, y = -2},{x = -11, y = -1},{x = 11, y = -1},{x = 11, y = -2},{x = -11, y = 0},{x = -11, y = 1},{x = 11, y = 1},{x = 11, y = 0},{x = -11, y = 2},{x = -11, y = 3},{x = 11, y = 3},{x = 11, y = 2},{x = -10, y = 5},{x = -10, y = 4},{x = 10, y = 5},{x = 10, y = 4},{x = -9, y = 7},{x = -9, y = 6},{x = -8, y = 7},{x = 8, y = 7},{x = 9, y = 7},{x = 9, y = 6},{x = -8, y = 8},{x = -7, y = 8},{x = -7, y = 9},{x = -6, y = 9},{x = 7, y = 8},{x = 7, y = 9},{x = 6, y = 9},{x = 8, y = 8},{x = -5, y = 10},{x = -4, y = 10},{x = -3, y = 11},{x = -2, y = 11},{x = -1, y = 11},{x = 0, y = 11},{x = 1, y = 11},{x = 2, y = 11},{x = 3, y = 11},{x = 4, y = 10},{x = 5, y = 10}},
	[13] = {{x = -5, y = -11},{x = -4, y = -11},{x = -3, y = -12},{x = -1, y = -12},{x = -2, y = -12},{x = 1, y = -12},{x = 0, y = -12},{x = 3, y = -12},{x = 2, y = -12},{x = 4, y = -11},{x = 5, y = -11},{x = -8, y = -9},{x = -7, y = -10},{x = -6, y = -10},{x = 6, y = -10},{x = 7, y = -10},{x = 8, y = -9},{x = -10, y = -7},{x = -9, y = -8},{x = 9, y = -8},{x = 10, y = -7},{x = -11, y = -5},{x = -10, y = -6},{x = 10, y = -6},{x = 11, y = -5},{x = -11, y = -4},{x = -12, y = -3},{x = 11, y = -4},{x = 12, y = -3},{x = -12, y = -1},{x = -12, y = -2},{x = 12, y = -1},{x = 12, y = -2},{x = -12, y = 1},{x = -12, y = 0},{x = 12, y = 1},{x = 12, y = 0},{x = -12, y = 3},{x = -12, y = 2},{x = 12, y = 3},{x = 12, y = 2},{x = -11, y = 5},{x = -11, y = 4},{x = 11, y = 4},{x = 11, y = 5},{x = -10, y = 7},{x = -10, y = 6},{x = 10, y = 6},{x = 10, y = 7},{x = -9, y = 8},{x = -8, y = 9},{x = 9, y = 8},{x = 8, y = 9},{x = -7, y = 10},{x = -5, y = 11},{x = -6, y = 10},{x = -4, y = 11},{x = 5, y = 11},{x = 4, y = 11},{x = 7, y = 10},{x = 6, y = 10},{x = -3, y = 12},{x = -2, y = 12},{x = -1, y = 12},{x = 0, y = 12},{x = 1, y = 12},{x = 2, y = 12},{x = 3, y = 12}},
	[14] = {{x = -3, y = -13},{x = -1, y = -13},{x = -2, y = -13},{x = 1, y = -13},{x = 0, y = -13},{x = 3, y = -13},{x = 2, y = -13},{x = -7, y = -11},{x = -6, y = -11},{x = -5, y = -12},{x = -6, y = -12},{x = -4, y = -12},{x = 5, y = -12},{x = 4, y = -12},{x = 7, y = -11},{x = 6, y = -11},{x = 6, y = -12},{x = -10, y = -9},{x = -9, y = -9},{x = -9, y = -10},{x = -8, y = -10},{x = 9, y = -9},{x = 9, y = -10},{x = 8, y = -10},{x = 10, y = -9},{x = -11, y = -7},{x = -10, y = -8},{x = 11, y = -7},{x = 10, y = -8},{x = -11, y = -6},{x = -12, y = -6},{x = -12, y = -5},{x = 11, y = -6},{x = 12, y = -6},{x = 12, y = -5},{x = -13, y = -3},{x = -12, y = -4},{x = 12, y = -4},{x = 13, y = -3},{x = -13, y = -2},{x = -13, y = -1},{x = 13, y = -1},{x = 13, y = -2},{x = -13, y = 0},{x = -13, y = 1},{x = 13, y = 1},{x = 13, y = 0},{x = -13, y = 2},{x = -13, y = 3},{x = 13, y = 3},{x = 13, y = 2},{x = -12, y = 5},{x = -12, y = 4},{x = 12, y = 5},{x = 12, y = 4},{x = -11, y = 6},{x = -11, y = 7},{x = -12, y = 6},{x = 11, y = 7},{x = 11, y = 6},{x = 12, y = 6},{x = -10, y = 8},{x = -10, y = 9},{x = -9, y = 9},{x = 9, y = 9},{x = 10, y = 9},{x = 10, y = 8},{x = -9, y = 10},{x = -8, y = 10},{x = -7, y = 11},{x = -6, y = 11},{x = 7, y = 11},{x = 6, y = 11},{x = 8, y = 10},{x = 9, y = 10},{x = -6, y = 12},{x = -5, y = 12},{x = -4, y = 12},{x = -3, y = 13},{x = -2, y = 13},{x = -1, y = 13},{x = 0, y = 13},{x = 1, y = 13},{x = 2, y = 13},{x = 3, y = 13},{x = 5, y = 12},{x = 4, y = 12},{x = 6, y = 12}},
	[15] = {{x = -5, y = -13},{x = -6, y = -13},{x = -4, y = -13},{x = -3, y = -14},{x = -1, y = -14},{x = -2, y = -14},{x = 1, y = -14},{x = 0, y = -14},{x = 3, y = -14},{x = 2, y = -14},{x = 5, y = -13},{x = 4, y = -13},{x = 6, y = -13},{x = -9, y = -11},{x = -8, y = -11},{x = -8, y = -12},{x = -7, y = -12},{x = 7, y = -12},{x = 8, y = -12},{x = 8, y = -11},{x = 9, y = -11},{x = -11, y = -9},{x = -10, y = -10},{x = 10, y = -10},{x = 11, y = -9},{x = -12, y = -7},{x = -11, y = -8},{x = -12, y = -8},{x = 11, y = -8},{x = 12, y = -8},{x = 12, y = -7},{x = -13, y = -5},{x = -13, y = -6},{x = 13, y = -5},{x = 13, y = -6},{x = -13, y = -4},{x = -14, y = -3},{x = 13, y = -4},{x = 14, y = -3},{x = -14, y = -2},{x = -14, y = -1},{x = 14, y = -1},{x = 14, y = -2},{x = -14, y = 0},{x = -14, y = 1},{x = 14, y = 1},{x = 14, y = 0},{x = -14, y = 2},{x = -14, y = 3},{x = 14, y = 3},{x = 14, y = 2},{x = -13, y = 4},{x = -13, y = 5},{x = 13, y = 5},{x = 13, y = 4},{x = -13, y = 6},{x = -12, y = 7},{x = 12, y = 7},{x = 13, y = 6},{x = -11, y = 9},{x = -11, y = 8},{x = -12, y = 8},{x = 11, y = 8},{x = 11, y = 9},{x = 12, y = 8},{x = -9, y = 11},{x = -10, y = 10},{x = -8, y = 11},{x = 9, y = 11},{x = 8, y = 11},{x = 10, y = 10},{x = -7, y = 12},{x = -8, y = 12},{x = -6, y = 13},{x = -5, y = 13},{x = -4, y = 13},{x = 5, y = 13},{x = 4, y = 13},{x = 7, y = 12},{x = 6, y = 13},{x = 8, y = 12},{x = -3, y = 14},{x = -2, y = 14},{x = -1, y = 14},{x = 0, y = 14},{x = 1, y = 14},{x = 2, y = 14},{x = 3, y = 14}},
	[16] = {{x = -3, y = -15},{x = -1, y = -15},{x = -2, y = -15},{x = 1, y = -15},{x = 0, y = -15},{x = 3, y = -15},{x = 2, y = -15},{x = -7, y = -13},{x = -8, y = -13},{x = -5, y = -14},{x = -6, y = -14},{x = -4, y = -14},{x = 5, y = -14},{x = 4, y = -14},{x = 7, y = -13},{x = 6, y = -14},{x = 8, y = -13},{x = -9, y = -12},{x = -10, y = -11},{x = 9, y = -12},{x = 10, y = -11},{x = -11, y = -10},{x = -12, y = -9},{x = 11, y = -10},{x = 12, y = -9},{x = -13, y = -7},{x = -13, y = -8},{x = 13, y = -7},{x = 13, y = -8},{x = -14, y = -6},{x = -14, y = -5},{x = 14, y = -5},{x = 14, y = -6},{x = -15, y = -3},{x = -14, y = -4},{x = 15, y = -3},{x = 14, y = -4},{x = -15, y = -2},{x = -15, y = -1},{x = 15, y = -1},{x = 15, y = -2},{x = -15, y = 0},{x = -15, y = 1},{x = 15, y = 1},{x = 15, y = 0},{x = -15, y = 2},{x = -15, y = 3},{x = 15, y = 3},{x = 15, y = 2},{x = -14, y = 5},{x = -14, y = 4},{x = 14, y = 5},{x = 14, y = 4},{x = -13, y = 7},{x = -14, y = 6},{x = 13, y = 7},{x = 14, y = 6},{x = -13, y = 8},{x = -12, y = 9},{x = 12, y = 9},{x = 13, y = 8},{x = -11, y = 10},{x = -10, y = 11},{x = 10, y = 11},{x = 11, y = 10},{x = -9, y = 12},{x = -8, y = 13},{x = -7, y = 13},{x = 7, y = 13},{x = 8, y = 13},{x = 9, y = 12},{x = -6, y = 14},{x = -5, y = 14},{x = -4, y = 14},{x = -3, y = 15},{x = -2, y = 15},{x = -1, y = 15},{x = 0, y = 15},{x = 1, y = 15},{x = 2, y = 15},{x = 3, y = 15},{x = 4, y = 14},{x = 5, y = 14},{x = 6, y = 14}},
	[17] = {{x = -5, y = -15},{x = -6, y = -15},{x = -3, y = -16},{x = -4, y = -16},{x = -4, y = -15},{x = -1, y = -16},{x = -2, y = -16},{x = 1, y = -16},{x = 0, y = -16},{x = 3, y = -16},{x = 2, y = -16},{x = 5, y = -15},{x = 4, y = -15},{x = 4, y = -16},{x = 6, y = -15},{x = -9, y = -13},{x = -10, y = -13},{x = -8, y = -14},{x = -7, y = -14},{x = 7, y = -14},{x = 9, y = -13},{x = 8, y = -14},{x = 10, y = -13},{x = -11, y = -12},{x = -11, y = -11},{x = -12, y = -11},{x = -10, y = -12},{x = 11, y = -11},{x = 11, y = -12},{x = 10, y = -12},{x = 12, y = -11},{x = -13, y = -10},{x = -13, y = -9},{x = -12, y = -10},{x = 13, y = -9},{x = 13, y = -10},{x = 12, y = -10},{x = -14, y = -7},{x = -14, y = -8},{x = 14, y = -7},{x = 14, y = -8},{x = -15, y = -6},{x = -15, y = -5},{x = 15, y = -5},{x = 15, y = -6},{x = -15, y = -4},{x = -16, y = -4},{x = -16, y = -3},{x = 15, y = -4},{x = 16, y = -3},{x = 16, y = -4},{x = -16, y = -2},{x = -16, y = -1},{x = 16, y = -1},{x = 16, y = -2},{x = -16, y = 0},{x = -16, y = 1},{x = 16, y = 1},{x = 16, y = 0},{x = -16, y = 2},{x = -16, y = 3},{x = 16, y = 3},{x = 16, y = 2},{x = -16, y = 4},{x = -15, y = 4},{x = -15, y = 5},{x = 15, y = 5},{x = 15, y = 4},{x = 16, y = 4},{x = -15, y = 6},{x = -14, y = 7},{x = 14, y = 7},{x = 15, y = 6},{x = -13, y = 9},{x = -14, y = 8},{x = 13, y = 9},{x = 14, y = 8},{x = -13, y = 10},{x = -12, y = 10},{x = -12, y = 11},{x = -11, y = 11},{x = 11, y = 11},{x = 12, y = 11},{x = 12, y = 10},{x = 13, y = 10},{x = -11, y = 12},{x = -10, y = 12},{x = -10, y = 13},{x = -9, y = 13},{x = 9, y = 13},{x = 10, y = 13},{x = 10, y = 12},{x = 11, y = 12},{x = -8, y = 14},{x = -7, y = 14},{x = -6, y = 15},{x = -5, y = 15},{x = -4, y = 15},{x = 4, y = 15},{x = 5, y = 15},{x = 7, y = 14},{x = 6, y = 15},{x = 8, y = 14},{x = -4, y = 16},{x = -3, y = 16},{x = -2, y = 16},{x = -1, y = 16},{x = 0, y = 16},{x = 1, y = 16},{x = 2, y = 16},{x = 3, y = 16},{x = 4, y = 16}},
	[18] = {{x = -3, y = -17},{x = -4, y = -17},{x = -1, y = -17},{x = -2, y = -17},{x = 1, y = -17},{x = 0, y = -17},{x = 3, y = -17},{x = 2, y = -17},{x = 4, y = -17},{x = -9, y = -15},{x = -8, y = -15},{x = -7, y = -15},{x = -7, y = -16},{x = -6, y = -16},{x = -5, y = -16},{x = 5, y = -16},{x = 7, y = -15},{x = 7, y = -16},{x = 6, y = -16},{x = 9, y = -15},{x = 8, y = -15},{x = -11, y = -13},{x = -10, y = -14},{x = -9, y = -14},{x = 9, y = -14},{x = 11, y = -13},{x = 10, y = -14},{x = -13, y = -11},{x = -12, y = -12},{x = 13, y = -11},{x = 12, y = -12},{x = -15, y = -9},{x = -14, y = -10},{x = -14, y = -9},{x = 14, y = -10},{x = 14, y = -9},{x = 15, y = -9},{x = -15, y = -8},{x = -15, y = -7},{x = -16, y = -7},{x = 15, y = -8},{x = 15, y = -7},{x = 16, y = -7},{x = -16, y = -6},{x = -16, y = -5},{x = 16, y = -5},{x = 16, y = -6},{x = -17, y = -3},{x = -17, y = -4},{x = 17, y = -3},{x = 17, y = -4},{x = -17, y = -1},{x = -17, y = -2},{x = 17, y = -1},{x = 17, y = -2},{x = -17, y = 1},{x = -17, y = 0},{x = 17, y = 1},{x = 17, y = 0},{x = -17, y = 3},{x = -17, y = 2},{x = 17, y = 3},{x = 17, y = 2},{x = -17, y = 4},{x = -16, y = 5},{x = 16, y = 5},{x = 17, y = 4},{x = -15, y = 7},{x = -16, y = 7},{x = -16, y = 6},{x = 15, y = 7},{x = 16, y = 7},{x = 16, y = 6},{x = -15, y = 9},{x = -15, y = 8},{x = -14, y = 9},{x = 14, y = 9},{x = 15, y = 9},{x = 15, y = 8},{x = -14, y = 10},{x = -13, y = 11},{x = 13, y = 11},{x = 14, y = 10},{x = -12, y = 12},{x = -11, y = 13},{x = 11, y = 13},{x = 12, y = 12},{x = -10, y = 14},{x = -9, y = 14},{x = -9, y = 15},{x = -8, y = 15},{x = -7, y = 15},{x = 7, y = 15},{x = 9, y = 14},{x = 9, y = 15},{x = 8, y = 15},{x = 10, y = 14},{x = -7, y = 16},{x = -6, y = 16},{x = -5, y = 16},{x = -4, y = 17},{x = -3, y = 17},{x = -2, y = 17},{x = -1, y = 17},{x = 0, y = 17},{x = 1, y = 17},{x = 2, y = 17},{x = 3, y = 17},{x = 4, y = 17},{x = 5, y = 16},{x = 6, y = 16},{x = 7, y = 16}},
	[19] = {{x = -7, y = -17},{x = -6, y = -17},{x = -5, y = -17},{x = -3, y = -18},{x = -4, y = -18},{x = -1, y = -18},{x = -2, y = -18},{x = 1, y = -18},{x = 0, y = -18},{x = 3, y = -18},{x = 2, y = -18},{x = 5, y = -17},{x = 4, y = -18},{x = 7, y = -17},{x = 6, y = -17},{x = -10, y = -15},{x = -9, y = -16},{x = -8, y = -16},{x = 9, y = -16},{x = 8, y = -16},{x = 10, y = -15},{x = -13, y = -13},{x = -11, y = -14},{x = -12, y = -14},{x = -12, y = -13},{x = 11, y = -14},{x = 13, y = -13},{x = 12, y = -13},{x = 12, y = -14},{x = -13, y = -12},{x = -14, y = -12},{x = -14, y = -11},{x = 13, y = -12},{x = 14, y = -11},{x = 14, y = -12},{x = -15, y = -10},{x = -16, y = -9},{x = 15, y = -10},{x = 16, y = -9},{x = -17, y = -7},{x = -16, y = -8},{x = 16, y = -8},{x = 17, y = -7},{x = -17, y = -5},{x = -17, y = -6},{x = 17, y = -6},{x = 17, y = -5},{x = -18, y = -3},{x = -18, y = -4},{x = 18, y = -4},{x = 18, y = -3},{x = -18, y = -1},{x = -18, y = -2},{x = 18, y = -2},{x = 18, y = -1},{x = -18, y = 1},{x = -18, y = 0},{x = 18, y = 0},{x = 18, y = 1},{x = -18, y = 3},{x = -18, y = 2},{x = 18, y = 2},{x = 18, y = 3},{x = -17, y = 5},{x = -18, y = 4},{x = 17, y = 5},{x = 18, y = 4},{x = -17, y = 7},{x = -17, y = 6},{x = 17, y = 7},{x = 17, y = 6},{x = -16, y = 9},{x = -16, y = 8},{x = 16, y = 9},{x = 16, y = 8},{x = -15, y = 10},{x = -14, y = 11},{x = 14, y = 11},{x = 15, y = 10},{x = -14, y = 12},{x = -13, y = 12},{x = -13, y = 13},{x = -12, y = 13},{x = 12, y = 13},{x = 13, y = 13},{x = 13, y = 12},{x = 14, y = 12},{x = -12, y = 14},{x = -11, y = 14},{x = -10, y = 15},{x = 10, y = 15},{x = 11, y = 14},{x = 12, y = 14},{x = -9, y = 16},{x = -7, y = 17},{x = -8, y = 16},{x = -5, y = 17},{x = -6, y = 17},{x = 5, y = 17},{x = 7, y = 17},{x = 6, y = 17},{x = 8, y = 16},{x = 9, y = 16},{x = -3, y = 18},{x = -4, y = 18},{x = -1, y = 18},{x = -2, y = 18},{x = 1, y = 18},{x = 0, y = 18},{x = 3, y = 18},{x = 2, y = 18},{x = 4, y = 18}},
	[20] = {{x = -3, y = -19},{x = -4, y = -19},{x = -1, y = -19},{x = -2, y = -19},{x = 1, y = -19},{x = 0, y = -19},{x = 3, y = -19},{x = 2, y = -19},{x = 4, y = -19},{x = -9, y = -17},{x = -7, y = -18},{x = -8, y = -17},{x = -5, y = -18},{x = -6, y = -18},{x = 5, y = -18},{x = 7, y = -18},{x = 6, y = -18},{x = 9, y = -17},{x = 8, y = -17},{x = -11, y = -16},{x = -11, y = -15},{x = -12, y = -15},{x = -10, y = -16},{x = 11, y = -15},{x = 11, y = -16},{x = 10, y = -16},{x = 12, y = -15},{x = -13, y = -14},{x = -14, y = -13},{x = 13, y = -14},{x = 14, y = -13},{x = -15, y = -12},{x = -15, y = -11},{x = -16, y = -11},{x = 15, y = -11},{x = 15, y = -12},{x = 16, y = -11},{x = -17, y = -9},{x = -16, y = -10},{x = 16, y = -10},{x = 17, y = -9},{x = -17, y = -8},{x = -18, y = -7},{x = 17, y = -8},{x = 18, y = -7},{x = -18, y = -6},{x = -18, y = -5},{x = 18, y = -5},{x = 18, y = -6},{x = -19, y = -4},{x = -19, y = -3},{x = 19, y = -3},{x = 19, y = -4},{x = -19, y = -2},{x = -19, y = -1},{x = 19, y = -1},{x = 19, y = -2},{x = -19, y = 0},{x = -19, y = 1},{x = 19, y = 1},{x = 19, y = 0},{x = -19, y = 2},{x = -19, y = 3},{x = 19, y = 3},{x = 19, y = 2},{x = -19, y = 4},{x = -18, y = 5},{x = 18, y = 5},{x = 19, y = 4},{x = -18, y = 7},{x = -18, y = 6},{x = 18, y = 7},{x = 18, y = 6},{x = -17, y = 9},{x = -17, y = 8},{x = 17, y = 9},{x = 17, y = 8},{x = -16, y = 10},{x = -16, y = 11},{x = -15, y = 11},{x = 15, y = 11},{x = 16, y = 11},{x = 16, y = 10},{x = -15, y = 12},{x = -14, y = 13},{x = 14, y = 13},{x = 15, y = 12},{x = -13, y = 14},{x = -12, y = 15},{x = -11, y = 15},{x = 11, y = 15},{x = 12, y = 15},{x = 13, y = 14},{x = -11, y = 16},{x = -10, y = 16},{x = -9, y = 17},{x = -8, y = 17},{x = 9, y = 17},{x = 8, y = 17},{x = 10, y = 16},{x = 11, y = 16},{x = -7, y = 18},{x = -5, y = 18},{x = -6, y = 18},{x = -4, y = 19},{x = -3, y = 19},{x = -2, y = 19},{x = -1, y = 19},{x = 0, y = 19},{x = 1, y = 19},{x = 2, y = 19},{x = 3, y = 19},{x = 4, y = 19},{x = 5, y = 18},{x = 7, y = 18},{x = 6, y = 18}},
	[21] = {{x = -7, y = -19},{x = -5, y = -19},{x = -6, y = -19},{x = -3, y = -20},{x = -4, y = -20},{x = -1, y = -20},{x = -2, y = -20},{x = 1, y = -20},{x = 0, y = -20},{x = 3, y = -20},{x = 2, y = -20},{x = 5, y = -19},{x = 4, y = -20},{x = 7, y = -19},{x = 6, y = -19},{x = -11, y = -17},{x = -10, y = -17},{x = -9, y = -18},{x = -8, y = -18},{x = 9, y = -18},{x = 8, y = -18},{x = 10, y = -17},{x = 11, y = -17},{x = -13, y = -15},{x = -14, y = -15},{x = -12, y = -16},{x = 13, y = -15},{x = 12, y = -16},{x = 14, y = -15},{x = -15, y = -14},{x = -15, y = -13},{x = -14, y = -14},{x = 15, y = -13},{x = 15, y = -14},{x = 14, y = -14},{x = -17, y = -11},{x = -16, y = -12},{x = 16, y = -12},{x = 17, y = -11},{x = -17, y = -10},{x = -18, y = -9},{x = 17, y = -10},{x = 18, y = -9},{x = -19, y = -7},{x = -18, y = -8},{x = 18, y = -8},{x = 19, y = -7},{x = -19, y = -6},{x = -19, y = -5},{x = 19, y = -6},{x = 19, y = -5},{x = -20, y = -4},{x = -20, y = -3},{x = 20, y = -3},{x = 20, y = -4},{x = -20, y = -2},{x = -20, y = -1},{x = 20, y = -1},{x = 20, y = -2},{x = -20, y = 0},{x = -20, y = 1},{x = 20, y = 1},{x = 20, y = 0},{x = -20, y = 2},{x = -20, y = 3},{x = 20, y = 3},{x = 20, y = 2},{x = -20, y = 4},{x = -19, y = 5},{x = 19, y = 5},{x = 20, y = 4},{x = -19, y = 7},{x = -19, y = 6},{x = 19, y = 7},{x = 19, y = 6},{x = -18, y = 9},{x = -18, y = 8},{x = 18, y = 9},{x = 18, y = 8},{x = -17, y = 11},{x = -17, y = 10},{x = 17, y = 11},{x = 17, y = 10},{x = -16, y = 12},{x = -15, y = 13},{x = 15, y = 13},{x = 16, y = 12},{x = -15, y = 14},{x = -14, y = 14},{x = -14, y = 15},{x = -13, y = 15},{x = 13, y = 15},{x = 14, y = 15},{x = 14, y = 14},{x = 15, y = 14},{x = -12, y = 16},{x = -11, y = 17},{x = -10, y = 17},{x = 11, y = 17},{x = 10, y = 17},{x = 12, y = 16},{x = -9, y = 18},{x = -8, y = 18},{x = -7, y = 19},{x = -5, y = 19},{x = -6, y = 19},{x = 5, y = 19},{x = 6, y = 19},{x = 7, y = 19},{x = 9, y = 18},{x = 8, y = 18},{x = -4, y = 20},{x = -3, y = 20},{x = -2, y = 20},{x = -1, y = 20},{x = 0, y = 20},{x = 1, y = 20},{x = 2, y = 20},{x = 3, y = 20},{x = 4, y = 20}},
	[22] = {{x = -3, y = -21},{x = -4, y = -21},{x = -1, y = -21},{x = -2, y = -21},{x = 1, y = -21},{x = 0, y = -21},{x = 3, y = -21},{x = 2, y = -21},{x = 4, y = -21},{x = -10, y = -19},{x = -9, y = -19},{x = -8, y = -19},{x = -7, y = -20},{x = -5, y = -20},{x = -6, y = -20},{x = 5, y = -20},{x = 7, y = -20},{x = 6, y = -20},{x = 9, y = -19},{x = 8, y = -19},{x = 10, y = -19},{x = -13, y = -17},{x = -12, y = -17},{x = -11, y = -18},{x = -10, y = -18},{x = 11, y = -18},{x = 10, y = -18},{x = 13, y = -17},{x = 12, y = -17},{x = -15, y = -15},{x = -13, y = -16},{x = -14, y = -16},{x = 13, y = -16},{x = 15, y = -15},{x = 14, y = -16},{x = -17, y = -13},{x = -16, y = -14},{x = -16, y = -13},{x = 17, y = -13},{x = 16, y = -13},{x = 16, y = -14},{x = -17, y = -12},{x = -18, y = -11},{x = 17, y = -12},{x = 18, y = -11},{x = -19, y = -10},{x = -19, y = -9},{x = -18, y = -10},{x = 18, y = -10},{x = 19, y = -10},{x = 19, y = -9},{x = -19, y = -8},{x = -20, y = -7},{x = 19, y = -8},{x = 20, y = -7},{x = -20, y = -6},{x = -20, y = -5},{x = 20, y = -6},{x = 20, y = -5},{x = -21, y = -4},{x = -21, y = -3},{x = 21, y = -3},{x = 21, y = -4},{x = -21, y = -2},{x = -21, y = -1},{x = 21, y = -1},{x = 21, y = -2},{x = -21, y = 0},{x = -21, y = 1},{x = 21, y = 1},{x = 21, y = 0},{x = -21, y = 2},{x = -21, y = 3},{x = 21, y = 3},{x = 21, y = 2},{x = -21, y = 4},{x = -20, y = 5},{x = 20, y = 5},{x = 21, y = 4},{x = -20, y = 7},{x = -20, y = 6},{x = 20, y = 7},{x = 20, y = 6},{x = -19, y = 9},{x = -19, y = 8},{x = 19, y = 9},{x = 19, y = 8},{x = -19, y = 10},{x = -18, y = 11},{x = -18, y = 10},{x = 18, y = 11},{x = 18, y = 10},{x = 19, y = 10},{x = -17, y = 13},{x = -17, y = 12},{x = -16, y = 13},{x = 16, y = 13},{x = 17, y = 13},{x = 17, y = 12},{x = -16, y = 14},{x = -15, y = 15},{x = 15, y = 15},{x = 16, y = 14},{x = -14, y = 16},{x = -13, y = 16},{x = -13, y = 17},{x = -12, y = 17},{x = 13, y = 16},{x = 13, y = 17},{x = 12, y = 17},{x = 14, y = 16},{x = -11, y = 18},{x = -10, y = 18},{x = -10, y = 19},{x = -9, y = 19},{x = -8, y = 19},{x = 9, y = 19},{x = 8, y = 19},{x = 11, y = 18},{x = 10, y = 18},{x = 10, y = 19},{x = -7, y = 20},{x = -6, y = 20},{x = -5, y = 20},{x = -3, y = 21},{x = -4, y = 21},{x = -1, y = 21},{x = -2, y = 21},{x = 1, y = 21},{x = 0, y = 21},{x = 3, y = 21},{x = 2, y = 21},{x = 4, y = 21},{x = 5, y = 20},{x = 7, y = 20},{x = 6, y = 20}},
	[23] = {{x = -8, y = -21},{x = -7, y = -21},{x = -6, y = -21},{x = -5, y = -21},{x = -3, y = -22},{x = -4, y = -22},{x = -1, y = -22},{x = -2, y = -22},{x = 1, y = -22},{x = 0, y = -22},{x = 3, y = -22},{x = 2, y = -22},{x = 5, y = -21},{x = 4, y = -22},{x = 7, y = -21},{x = 6, y = -21},{x = 8, y = -21},{x = -12, y = -19},{x = -11, y = -19},{x = -10, y = -20},{x = -9, y = -20},{x = -8, y = -20},{x = 9, y = -20},{x = 8, y = -20},{x = 11, y = -19},{x = 10, y = -20},{x = 12, y = -19},{x = -14, y = -17},{x = -13, y = -18},{x = -12, y = -18},{x = 13, y = -18},{x = 12, y = -18},{x = 14, y = -17},{x = -15, y = -16},{x = -16, y = -15},{x = 15, y = -16},{x = 16, y = -15},{x = -17, y = -14},{x = -18, y = -13},{x = 17, y = -14},{x = 18, y = -13},{x = -19, y = -12},{x = -19, y = -11},{x = -18, y = -12},{x = 18, y = -12},{x = 19, y = -12},{x = 19, y = -11},{x = -20, y = -10},{x = -20, y = -9},{x = 20, y = -10},{x = 20, y = -9},{x = -21, y = -8},{x = -21, y = -7},{x = -20, y = -8},{x = 20, y = -8},{x = 21, y = -8},{x = 21, y = -7},{x = -21, y = -6},{x = -21, y = -5},{x = 21, y = -6},{x = 21, y = -5},{x = -22, y = -4},{x = -22, y = -3},{x = 22, y = -3},{x = 22, y = -4},{x = -22, y = -2},{x = -22, y = -1},{x = 22, y = -1},{x = 22, y = -2},{x = -22, y = 0},{x = -22, y = 1},{x = 22, y = 1},{x = 22, y = 0},{x = -22, y = 2},{x = -22, y = 3},{x = 22, y = 3},{x = 22, y = 2},{x = -22, y = 4},{x = -21, y = 5},{x = 21, y = 5},{x = 22, y = 4},{x = -21, y = 7},{x = -21, y = 6},{x = 21, y = 7},{x = 21, y = 6},{x = -21, y = 8},{x = -20, y = 9},{x = -20, y = 8},{x = 20, y = 8},{x = 20, y = 9},{x = 21, y = 8},{x = -19, y = 11},{x = -20, y = 10},{x = 19, y = 11},{x = 20, y = 10},{x = -19, y = 12},{x = -18, y = 13},{x = -18, y = 12},{x = 18, y = 13},{x = 18, y = 12},{x = 19, y = 12},{x = -17, y = 14},{x = -16, y = 15},{x = 16, y = 15},{x = 17, y = 14},{x = -15, y = 16},{x = -14, y = 17},{x = 14, y = 17},{x = 15, y = 16},{x = -13, y = 18},{x = -12, y = 18},{x = -12, y = 19},{x = -11, y = 19},{x = 11, y = 19},{x = 13, y = 18},{x = 12, y = 18},{x = 12, y = 19},{x = -10, y = 20},{x = -9, y = 20},{x = -8, y = 20},{x = -8, y = 21},{x = -7, y = 21},{x = -6, y = 21},{x = -5, y = 21},{x = 5, y = 21},{x = 7, y = 21},{x = 6, y = 21},{x = 8, y = 20},{x = 9, y = 20},{x = 8, y = 21},{x = 10, y = 20},{x = -4, y = 22},{x = -3, y = 22},{x = -2, y = 22},{x = -1, y = 22},{x = 0, y = 22},{x = 1, y = 22},{x = 2, y = 22},{x = 3, y = 22},{x = 4, y = 22}}
	}
	
local function process_explosion_tile(pos, explosion_index, current_radius)
	local surface = game.surfaces[global.explosion_schedule[explosion_index].surface]					
	local target_entities = surface.find_entities_filtered({area={{pos.x - 0.5, pos.y - 0.5},{pos.x + 0.499, pos.y + 0.499}}}) 
	local explosion_animation = "explosion"
	
	local tile = surface.get_tile(pos)	
	if tile.name == "out-of-map" then						
		if global.explosion_schedule[explosion_index].damage_remaining >= out_of_map_tile_health then
			explosion_animation = "big-explosion"
			surface.set_tiles({{name = "dirt-5", position = pos}}, true)
		end
		global.explosion_schedule[explosion_index].damage_remaining = global.explosion_schedule[explosion_index].damage_remaining - out_of_map_tile_health
	else
		local decay_explosion = true
		for _, entity in pairs(target_entities) do
			if entity.health then
				decay_explosion = false
			end			
		end
		if decay_explosion then global.explosion_schedule[explosion_index].damage_remaining = global.explosion_schedule[explosion_index].damage_remaining - empty_tile_damage_decay end
	end	
	
	for _, entity in pairs(target_entities) do
		if entity.valid then
			if entity.health then						
				if entity.health < global.explosion_schedule[explosion_index].damage_remaining then
					explosion_animation = "big-explosion"
					if entity.health > 500 then explosion_animation = "big-artillery-explosion" end
					global.explosion_schedule[explosion_index].damage_remaining = global.explosion_schedule[explosion_index].damage_remaining - entity.health
					if entity.name ~= "character" then
						entity.damage(2097152, "player", "explosion")
					else
						entity.die("player")
					end
				else				
					entity.damage(global.explosion_schedule[explosion_index].damage_remaining, "player", "explosion")
					global.explosion_schedule[explosion_index].damage_remaining = global.explosion_schedule[explosion_index].damage_remaining - entity.health				
				end
			end
		end
	end
	
	if global.explosion_schedule[explosion_index].damage_remaining > 5000 and current_radius < 2 then
		if math.random(1,2) ==  1 then
			explosion_animation = "big-explosion"
		else
			explosion_animation = "big-artillery-explosion"
		end
	end
	
	surface.create_entity({name = explosion_animation, position = pos})
	
	if global.explosion_schedule[explosion_index].damage_remaining <= 0 then return false end
	
	return true		
end

local function create_explosion_schedule(entity)
	local inventory = defines.inventory.chest
	if entity.type == "car" then inventory = defines.inventory.car_trunk end
	local i = entity.get_inventory(inventory)
	local explosives_amount = i.get_item_count("explosives")
	if explosives_amount < 1 then return end		
	local center_position = entity.position
	
	if not global.explosion_schedule then global.explosion_schedule = {} end
	global.explosion_schedule[#global.explosion_schedule + 1] = {}
	global.explosion_schedule[#global.explosion_schedule].surface = entity.surface.name
	global.explosion_schedule[#global.explosion_schedule].damage_remaining = damage_per_explosive * explosives_amount
	
	for current_radius = 1, 23, 1 do
		
		global.explosion_schedule[#global.explosion_schedule][current_radius] = {}
		global.explosion_schedule[#global.explosion_schedule][current_radius].trigger_tick = game.tick + (current_radius * 8)
		
		local circle_coords = circle_coordinates[current_radius]
		
		for index, tile_position in pairs(circle_coords) do												
			local pos = {x = center_position.x + tile_position.x, y = center_position.y + tile_position.y} 											
			global.explosion_schedule[#global.explosion_schedule][current_radius][index] = {x = pos.x, y = pos.y}
		end	
		
	end
	entity.die("player")
end

function explosives_damaged_explosive(event)
	local entity = event.entity
	if not entity.valid then return end
	if not entity.health then return end
	if entity.health > entity.prototype.max_health * 0.75 then return end
	
	if entity.type == "container" or entity.type == "logistic-container" then
		if math.random(1,3) == 1 or entity.health <= 0 then create_explosion_schedule(event.entity) return end
	end
	if entity.type == "cargo-wagon" or entity.type == "car" then
		if entity.health <= 0 then create_explosion_schedule(entity) return end
		if entity.health < 150 and math.random(1,3) == 1 then create_explosion_schedule(entity) return end
	end
end

function explosives_tick_explosive(event)
	if global.explosion_schedule then		
		local tick = game.tick
		local explosion_schedule_is_alive = false
		for explosion_index = 1, #global.explosion_schedule, 1 do			
			if #global.explosion_schedule[explosion_index] > 0 then
				explosion_schedule_is_alive = true
				local surface = game.surfaces[global.explosion_schedule[explosion_index].surface]
				for radius = 1, #global.explosion_schedule[explosion_index], 1 do														
					if global.explosion_schedule[explosion_index][radius].trigger_tick == tick then	
						for tile_index = 1, #global.explosion_schedule[explosion_index][radius], 1 do							
							local continue_explosion = process_explosion_tile(global.explosion_schedule[explosion_index][radius][tile_index], explosion_index, radius)
							if not continue_explosion then
								global.explosion_schedule[explosion_index] = {}
								break
							end														
						end							
						if radius == #global.explosion_schedule[explosion_index] then global.explosion_schedule[explosion_index] = {} end
						break
					end																					
				end				
			end			
		end
		if not explosion_schedule_is_alive then global.explosion_schedule = nil end
	end
end

local print_color = {r = 120, g = 255, b = 0}

local function create_floaty_text(surface, position, name, count, height_offset)
	if global.autostash_floating_text_y_offsets[position.x .. "_" .. position.y] then
		global.autostash_floating_text_y_offsets[position.x .. "_" .. position.y] = global.autostash_floating_text_y_offsets[position.x .. "_" .. position.y] - 0.5
	else
		global.autostash_floating_text_y_offsets[position.x .. "_" .. position.y] = 0
	end
	surface.create_entity({
		name = "flying-text",
		position = {position.x, position.y + global.autostash_floating_text_y_offsets[position.x .. "_" .. position.y]},
		text = "-" .. count .. " " .. name,
		color = {r = 255, g = 255, b = 255},
	})
end

local function chest_is_valid(chest)
	for _, e in pairs(chest.surface.find_entities_filtered({type = {"inserter", "loader"}, area = {{chest.position.x - 1, chest.position.y - 1},{chest.position.x + 1, chest.position.y + 1}}})) do
		if e.name ~= "long-handed-inserter" then
			if e.position.x == chest.position.x then
				if e.direction == 0 or e.direction == 4 then
					return false
				end
			end
			if e.position.y == chest.position.y then
				if e.direction == 2 or e.direction == 6 then
					return false
				end
			end
		end
	end
	
	local inserter = chest.surface.find_entity("long-handed-inserter", {chest.position.x - 2, chest.position.y})
	if inserter then
		if inserter.direction == 2 or inserter.direction == 6 then
			return false
		end
	end
	local inserter = chest.surface.find_entity("long-handed-inserter", {chest.position.x + 2, chest.position.y})
	if inserter then
		if inserter.direction == 2 or inserter.direction == 6 then
			return false
		end
	end
	
	local inserter = chest.surface.find_entity("long-handed-inserter", {chest.position.x, chest.position.y - 2})
	if inserter then
		if inserter.direction == 0 or inserter.direction == 4 then
			return false
		end
	end
	local inserter = chest.surface.find_entity("long-handed-inserter", {chest.position.x, chest.position.y + 2})
	if inserter then
		if inserter.direction == 0 or inserter.direction == 4 then
			return false
		end
	end
	
	return true
end

local function get_nearby_chests(player)
	local r = player.force.character_reach_distance_bonus + 10
	local r_square = r * r
	local chests = {}
	local area = {{player.position.x - r, player.position.y - r}, {player.position.x + r, player.position.y + r}}
	for _, e in pairs(player.surface.find_entities_filtered({type = "container", area = area})) do
		if ((player.position.x - e.position.x) ^ 2 + (player.position.y - e.position.y) ^ 2) <= r_square then
			chests[#chests + 1] = e
		end
	end
	for _, e in pairs(player.surface.find_entities_filtered({name = "logistic-chest-storage", area = area})) do
		if ((player.position.x - e.position.x) ^ 2 + (player.position.y - e.position.y) ^ 2) <= r_square then
			chests[#chests + 1] = e
		end
	end
	for _, e in pairs(player.surface.find_entities_filtered({name = "logistic-chest-passive-provider", area = area})) do
		if ((player.position.x - e.position.x) ^ 2 + (player.position.y - e.position.y) ^ 2) <= r_square then
			chests[#chests + 1] = e
		end
	end
	return chests
end

local function does_inventory_contain_item_type(inventory, item_subgroup)
	for name, count in pairs(inventory.get_contents()) do
		if game.item_prototypes[name].subgroup.name == item_subgroup then return true end
	end
	return false
end

local function insert_item_into_chest(player_inventory, chests, filtered_chests, name, count)
	--Attempt to store in chests that already have the same item.
	for _, chest in pairs(chests) do
		local chest_inventory = chest.get_inventory(defines.inventory.chest)
		if chest_inventory.can_insert({name = name, count = count}) then
			if chest_inventory.find_item_stack(name) then
				local inserted_count = chest_inventory.insert({name = name, count = count})

				player_inventory.remove({name = name, count = inserted_count})				
				create_floaty_text(chest.surface, chest.position, name, inserted_count)
				count = count - inserted_count
				if count <= 0 then return end
			end
		end
	end	
	
	--Attempt to store in empty chests.
	for _, chest in pairs(filtered_chests) do
		local chest_inventory = chest.get_inventory(defines.inventory.chest)
		if chest_inventory.can_insert({name = name, count = count}) then
			if chest_inventory.is_empty() then
				local inserted_count = chest_inventory.insert({name = name, count = count})
				player_inventory.remove({name = name, count = inserted_count})				
				create_floaty_text(chest.surface, chest.position, name, inserted_count)
				count = count - inserted_count
				if count <= 0 then return end
			end
		end
	end	
	
	--Attempt to store in chests with same item subgroup.
	local item_subgroup = game.item_prototypes[name].subgroup.name
	if item_subgroup then
		for _, chest in pairs(filtered_chests) do
			local chest_inventory = chest.get_inventory(defines.inventory.chest)
			if chest_inventory.can_insert({name = name, count = count}) then
				if does_inventory_contain_item_type(chest_inventory, item_subgroup) then
					local inserted_count = chest_inventory.insert({name = name, count = count})
					player_inventory.remove({name = name, count = inserted_count})		
					create_floaty_text(chest.surface, chest.position, name, inserted_count)
					count = count - inserted_count
					if count <= 0 then return end
				end		
			end
		end
	end
	
	--Attempt to store in mixed chests.
	for _, chest in pairs(filtered_chests) do
		local chest_inventory = chest.get_inventory(defines.inventory.chest)
		if chest_inventory.can_insert({name = name, count = count}) then			
			local inserted_count = chest_inventory.insert({name = name, count = count})
			player_inventory.remove({name = name, count = inserted_count})		
			create_floaty_text(chest.surface, chest.position, name, inserted_count)
			count = count - inserted_count
			if count <= 0 then return end		
		end
	end
end

local function auto_stash(player, event)
	local button = event.button
	if not player.character then player.print("It seems that you are not in the realm of the living.", print_color) return end
	if not player.character.valid then player.print("It seems that you are not in the realm of the living.", print_color) return end
	local inventory = player.get_inventory(defines.inventory.character_main)
	if inventory.is_empty() then player.print("Inventory is empty.", print_color) return end
	local chests = get_nearby_chests(player)
	if not chests[1] then player.print("No valid nearby containers found.", print_color) return end
	
	local filtered_chests = {}
	for _, e in pairs(chests) do
		if chest_is_valid(e) then filtered_chests[#filtered_chests + 1] = e end
	end
	
	global.autostash_floating_text_y_offsets = {}
	
	local hotbar_items = {}
	for i = 1, 100, 1 do
		local prototype = player.get_quick_bar_slot(i)
		if prototype then
			hotbar_items[prototype.name] = true
		end
	end

	local ore_types = {
    ["coal"] = true,
    ["stone"] = true,
    ["iron-ore"] = true,
    ["copper-ore"] = true,
    ["uranium-ore"] = true
}

	for name, count in pairs(inventory.get_contents()) do
		if not inventory.find_item_stack(name).grid and not hotbar_items[name] then
			if button == defines.mouse_button_type.right then
				if ore_types[name] then
					insert_item_into_chest(inventory, chests, filtered_chests, name, count)
				end
			elseif button == defines.mouse_button_type.left then
				insert_item_into_chest(inventory, chests, filtered_chests, name, count)
			end
		end
	end

	global.autostash_floating_text_y_offsets = nil
end

local function create_gui_button(player)
	if player.gui.top.auto_stash then return end
	local b = player.gui.top.add({
		type = "sprite-button",
		sprite = "item/wooden-chest",
		name = "auto_stash",
		tooltip = "Sort your inventory into nearby chests.\nLMB: Everything, excluding quickbar items.\nRMB: Only ores."
	})
	b.style.font_color = {r=0.11, g=0.8, b=0.44}
	b.style.font = "heading-1"
	b.style.minimal_height = 38
	b.style.minimal_width = 38
	b.style.maximal_height = 38
	b.style.maximal_width = 38
	b.style.padding = 1
	b.style.margin = 0
end

function autostash_button(event)
	create_gui_button(game.players[event.player_index])
end

function AutostashGuiClick(event)
	if not event.element then return end
	if not event.element.valid then return end
	if event.element.name == "auto_stash" then
		auto_stash(game.players[event.player_index], event)
	end

end

function mixed_ores(event)
	local surface = event.surface
	local ores = surface.find_entities_filtered({area = event.area, name = {"iron-ore", "copper-ore", "coal", "stone"}})
	if #ores == 0 then return end
	local seed = game.surfaces[1].map_gen_settings.seed
	
	for _, ore in pairs(ores) do
		local pos = ore.position
		local noise = simplex_noise(pos.x * 0.005, pos.y * 0.005, seed) + simplex_noise(pos.x * 0.01, pos.y * 0.01, seed) * 0.3 + simplex_noise(pos.x * 0.05, pos.y * 0.05, seed) * 0.2
		
		local i = (math.floor(noise * 100) % 7) + 1
		surface.create_entity({name = ore_raffle_mixed[i], position = ore.position, amount = ore.amount})
		ore.destroy()
	end	
end
