-- Red Desert
-- by Hansi-TWZ
-- DE333-SERVER.EU
-- Credits to MewMew (Comfy)

local table_insert = table.insert
local math_random = math.random

local tile_replacements = {
	["grass-1"] = "red-desert-0",
	["grass-2"] = "red-desert-1",
	["grass-3"] = "red-desert-2",
	["grass-4"] = "red-desert-3"	,
	["dirt-1"] = "red-desert-0",
	["dirt-2"] = "red-desert-1",
	["dirt-3"] = "red-desert-2",
	["dirt-4"] = "red-desert-3",
	["dirt-5"] = "red-desert-2",
	["dirt-6"] = "sand-3",
	["dirt-7"] = "red-desert-3",
	["sand-1"] = "red-desert-1",
	["sand-2"] = "red-desert-2"
}

local entity_replacements = {
	["tree-01"] = "dry-hairy-tree",
	["tree-02"] = "dead-grey-trunk",
	["tree-03"] = "dead-grey-trunk",
	["tree-04"] = "dry-hairy-tree",	
	["tree-05"] = "dead-grey-trunk",	
	["tree-06"] = "dry-hairy-tree",	
	["tree-07"] = "dry-hairy-tree",	
	["tree-08"] = "dead-grey-trunk",	
	["tree-09"] = "tree-09-red",
	["tree-02-red"] = "tree-09-red",	
	["tree-08-brown"] = "tree-09-red",	
	["tree-09-brown"] = "tree-09-red"
}

local function process_entity(e)
	if not e.valid then return end
	if entity_replacements[e.name] then		
		if e.type == "tree" then
			if math_random(1,2) == 1 then
				e.surface.create_entity({name = entity_replacements[e.name], position = e.position})
			end
		else
			e.surface.create_entity({name = entity_replacements[e.name], position = e.position})
		end
		e.destroy()
		return
	end
end

function RedDesert(event)
	local surface = event.surface
	local left_top = event.area.left_top
	local tiles = {}
	local entities = {}		
	
	for x = 0, 31, 1 do
		for y = 0, 31, 1 do
			local tile_to_insert = false
			local pos = {x = left_top.x + x, y = left_top.y + y}
											
			local tile = surface.get_tile(pos)
			if tile_replacements[tile.name] then
				table_insert(tiles, {name = tile_replacements[tile.name], position = pos})
			end
		end
	end
	surface.set_tiles(tiles, true)
	for _, e in pairs(surface.find_entities_filtered({area = event.area})) do
		process_entity(e)		
	end
end

function RedDesert_chunk_charted(event)
	if not global.chunks_charted then global.chunks_charted = {} end
	local surface = game.surfaces[event.surface_index]
	local position = event.position
	if global.chunks_charted[tostring(position.x) .. tostring(position.y)] then return end
	global.chunks_charted[tostring(position.x) .. tostring(position.y)] = true
	
	local decorative_names = {}
	for k,v in pairs(game.decorative_prototypes) do
		if v.autoplace_specification then
			decorative_names[#decorative_names+1] = k
		end
	end
	surface.regenerate_decorative(decorative_names, {position})	
end