local function create_particles(surface, position, amount)	
	local math_random = math.random
	for i = 1, amount, 1 do 
		local m = math_random(6, 12)
		local m2 = m * 0.005
		
		surface.create_entity({
			name = "stone-particle",
			position = position,
			frame_speed = 0.1,
			vertical_speed = 0.1,
			height = 0.1,
			movement = {m2 - (math_random(0, m) * 0.01), m2 - (math_random(0, m) * 0.01)}
		})
	end	
end

local function spawn_biter_small(surface, position, evolution_index)	
	local biter_table_small = {
		[1] = {"small-biter"},
		[2] = {"small-biter"},
		[3] = {"small-biter"},
		[4] = {"small-biter","small-biter"},
		[5] = {"small-biter","small-biter"},
		[6] = {"small-biter","medium-biter"},
		[7] = {"small-biter","medium-biter","medium-biter"},
		[8] = {"small-biter","medium-biter","medium-biter"},
		[9] = {"small-biter","medium-biter","medium-biter"},
		[10] = {"small-biter","medium-biter","medium-biter"},
		[11] = {"small-biter","medium-biter","medium-biter"},
		[12] = {"small-biter","medium-biter","medium-biter"},
		[13] = {"small-biter","medium-biter","medium-biter"},
		[14] = {"small-biter","medium-biter","medium-biter"},
		[15] = {"small-biter","medium-biter","medium-biter"},
		[16] = {"small-biter","medium-biter","medium-biter"},
		[17] = {"small-biter","medium-biter","medium-biter"},
		[18] = {"small-biter","medium-biter","medium-biter"},
		[19] = {"small-biter","medium-biter","medium-biter"},
		[20] = {"small-biter","medium-biter","medium-biter"}
	}
	local raffle = biter_table_small[evolution_index]
	local biter_name = raffle[math.random(1,#raffle)]
	local p = surface.find_non_colliding_position(biter_name, position, 10, 0.5)
	if not p then return end
	surface.create_entity({name = biter_name, position = p, force = "enemy"})
end

local function unearthing_biters_small(surface, position, amount)
	if not surface then return end
	if not position then return end
	if not position.x then return end
	if not position.y then return end	
	
	local evolution_index = math.ceil(game.forces.enemy.evolution_factor * 20)
	if evolution_index < 1 then evolution_index = 1 end
	
	local ticks = amount * 30
	ticks = ticks + 90
	for t = 1, ticks, 1 do
		if not global.on_tick_schedule[game.tick + t] then global.on_tick_schedule[game.tick + t] = {} end
				
		global.on_tick_schedule[game.tick + t][#global.on_tick_schedule[game.tick + t] + 1] = {
			func = create_particles,
			args = {surface, {x = position.x, y = position.y}, 4}
		}										
		
		if t > 90 then
			if t % 30 == 29 then			
				global.on_tick_schedule[game.tick + t][#global.on_tick_schedule[game.tick + t] + 1] = {
					func = spawn_biter_small,
					args = {surface, {x = position.x, y = position.y}, evolution_index}
				}
			end
		end
	end
end

return unearthing_biters_small