-- game_opts.lua
-- Jan 2018
-- Display current game options, maybe have some admin controls here

-- Main Configuration File
require("config")
require("lib/oarc_utils")
require("lib/separate_spawns")

local function admin_only_message(str)
	for _, player in pairs(game.connected_players) do
		if player.admin == true then
			player.print("Admins-only-message: " .. str, {r=0.88, g=0.88, b=0.88})
		end
	end
end

function GameOptionsGuiClick(event, player) 
    if not (event and event.element and event.element.valid) then return end
    local player = game.players[event.element.player_index]
    local name = event.element.name

    if (name == "game_options") then
        ExpandGameOptionsGui(player)        
    end

    if (name == "ban_player") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local banPlayer = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[banPlayer]) then
                game.ban_player(banPlayer, "Banned from admin panel.")
                log("Banning " .. banPlayer)
            end
        end
    end
	
	if (name == "kick_player") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local kickPlayer = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[kickPlayer]) then
                game.kick_player(kickPlayer, "Kicked from admin panel.")
                log("Kick " .. kickPlayer)
            end
        end
    end

    if (name == "restart_player") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local resetPlayer = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[resetPlayer]) then
                SeparateSpawnsPlayerCreated(resetPlayer)
                log("Resetting " .. resetPlayer)
            end
        end
    end
	-- Advanced ADMIN controls WIP
	-- by Hansi-TWZ
	-- DE333-SERVER.EU
	if (name == "modular_armor_player") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local modularPlayer = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[modularPlayer]) then
                 player.insert{name="modular-armor", count = 1}
				if player and player.get_inventory(defines.inventory.character_armor) ~= nil and player.get_inventory(defines.inventory.character_armor)[1] ~= nil then
					local p_armor = player.get_inventory(defines.inventory.character_armor)[1].grid
						if p_armor ~= nil then
							p_armor.put({name = "personal-roboport-equipment"})  
							p_armor.put({name = "solar-panel-equipment"})
							p_armor.put({name = "solar-panel-equipment"})
							p_armor.put({name = "solar-panel-equipment"})
							p_armor.put({name = "solar-panel-equipment"})
							p_armor.put({name = "solar-panel-equipment"})
							p_armor.put({name = "solar-panel-equipment"})
							p_armor.put({name = "solar-panel-equipment"})
							p_armor.put({name = "solar-panel-equipment"})
							p_armor.put({name = "solar-panel-equipment"})
							p_armor.put({name = "solar-panel-equipment"})
							p_armor.put({name = "solar-panel-equipment"})
							p_armor.put({name = "battery-equipment"})
							p_armor.put({name = "battery-equipment"})
							p_armor.put({name = "battery-equipment"})
							p_armor.put({name = "solar-panel-equipment"})
							p_armor.put({name = "solar-panel-equipment"})
							p_armor.put({name = "solar-panel-equipment"})
							p_armor.put({name = "solar-panel-equipment"})
						end
						player.insert{name="construction-robot", count = 10}
						player.insert{name="belt-immunity-equipment", count = 1}
					end
                log("Give Modular armor to " .. modularPlayer)
            end
        end
    end
	if (name == "power_armor_player") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local powerPlayer = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[powerPlayer]) then
                 player.insert{name="power-armor", count = 1}
				if player and player.get_inventory(defines.inventory.character_armor) ~= nil and player.get_inventory(defines.inventory.character_armor)[1] ~= nil then
					local p_armor = player.get_inventory(defines.inventory.character_armor)[1].grid
						if p_armor ~= nil then
							p_armor.put({name = "fusion-reactor-equipment"})
							p_armor.put({name = "exoskeleton-equipment"})
							p_armor.put({name = "battery-mk2-equipment"})
							p_armor.put({name = "battery-mk2-equipment"})
							p_armor.put({name = "personal-roboport-mk2-equipment"})  
							p_armor.put({name = "personal-roboport-mk2-equipment"})
							p_armor.put({name = "personal-roboport-mk2-equipment"})
							p_armor.put({name = "battery-mk2-equipment"})
							p_armor.put({name = "solar-panel-equipment"})
							p_armor.put({name = "solar-panel-equipment"})
							p_armor.put({name = "solar-panel-equipment"})
							p_armor.put({name = "solar-panel-equipment"})
							p_armor.put({name = "solar-panel-equipment"})
							p_armor.put({name = "solar-panel-equipment"})
							p_armor.put({name = "solar-panel-equipment"})
						end
						player.insert{name="construction-robot", count = 100}
						player.insert{name="belt-immunity-equipment", count = 1}
					end
                log("Give Power armor to " .. powerPlayer)
            end
        end
    end
	if (name == "coins_100") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local coinsPlayer100 = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[coinsPlayer100]) then
				player.insert{name="coin", count = 100}
                log("Give 100 coins to " .. coinsPlayer100)
            end
        end
    end
	if (name == "coins_1k") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local coinsPlayer1000 = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[coinsPlayer1000]) then
				player.insert{name="coin", count = 1000}
                log("Give 1000 coins to " .. coinsPlayer1000)
            end
        end
    end
	if (name == "coins_10k") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local coinsPlayer10000 = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[coinsPlayer10000]) then
				player.insert{name="coin", count = 10000}
                log("Give 10 000 coins to " .. coinsPlayer10000)
            end
        end
    end
	if (name == "items_1") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local itemsPlayer1 = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[itemsPlayer1]) then
				player.insert{name="iron-plate", count = 1000}
				player.insert{name="copper-plate", count = 1000}
				player.insert{name="steel-plate", count = 1000}
                log("Give goodies #1 to " .. itemsPlayer1)
            end
        end
    end
	if (name == "items_2") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local itemsPlayer2 = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[itemsPlayer2]) then
				player.insert{name="solid-fuel", count = 1000}
				player.insert{name="sulfur", count = 1000}
				player.insert{name="engine-unit", count = 1000}
                log("Give goodies #2 to " .. itemsPlayer2)
            end
        end
    end
	if (name == "items_3") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local itemsPlayer3 = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[itemsPlayer3]) then
				player.insert{name="concrete", count = 1000}
				player.insert{name="rail", count = 1000}
				player.insert{name="battery", count = 1000}
                log("Give goodies #3 to " .. itemsPlayer3)
            end
        end
    end
	if (name == "items_4") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local itemsPlayer4 = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[itemsPlayer4]) then
				player.insert{name="pipe", count = 1000}
				player.insert{name="pipe-to-ground", count = 1000}
				player.insert{name="landfill", count = 1000}
                log("Give goodies #4 to " .. itemsPlayer4)
            end
        end
    end
	if (name == "items_5") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local itemsPlayer5 = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[itemsPlayer5]) then
				player.insert{name="cliff-explosives", count = 1000}
				player.insert{name="explosives", count = 1000}
                log("Give goodies #5 to " .. itemsPlayer5)
            end
        end
    end
	if (name == "items_6") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local itemsPlayer6 = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[itemsPlayer6]) then
				player.insert{name="electric-engine-unit", count = 1000}
				player.insert{name="flying-robot-frame", count = 1000}
                log("Give goodies #6 to " .. itemsPlayer6)
            end
        end
    end
	if (name == "solar_kit") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local solarKit = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[solarKit]) then
				player.insert{name="solar-panel", count = 160}
				player.insert{name="accumulator", count = 40}
				player.insert{name="substation", count = 5}
                log("Give Solar Kit to " .. solarKit)
            end
        end
    end
	if (name == "construction_kit") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local constructionKit = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[constructionKit]) then
				player.insert{name="assembling-machine-2", count = 50}
				player.insert{name="fast-inserter", count = 100}
				player.insert{name="medium-electric-pole", count = 100}
                log("Give Construction Kit to " .. constructionKit)
            end
        end
    end
	if (name == "construction_kit2") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local constructionKit2 = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[constructionKit2]) then
				player.insert{name="assembling-machine-3", count = 50}
				player.insert{name="stack-inserter", count = 100}
				player.insert{name="medium-electric-pole", count = 100}
                log("Give Construction Kit 2 to " .. constructionKit2)
            end
        end
    end
	if (name == "smelting_kit") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local smeltingKit = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[smeltingKit]) then
				player.insert{name="stone-furnace", count = 50}
				player.insert{name="inserter", count = 100}
                log("Give Smelting Kit to " .. smeltingKit)
            end
        end
    end
	if (name == "smelting_kit2") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local smeltingKit2 = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[smeltingKit2]) then
				player.insert{name="steel-furnace", count = 50}
				player.insert{name="fast-inserter", count = 100}
                log("Give Smelting Kit to " .. smeltingKit2)
            end
        end
    end
	if (name == "smelting_kit3") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local smeltingKit3 = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[smeltingKit3]) then
				player.insert{name="electric-furnace", count = 50}
				player.insert{name="stack-inserter", count = 100}
                log("Give Smelting Kit to " .. smeltingKit3)
            end
        end
    end
	if (name == "slot_10") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local slot10 = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[slot10]) then
				if player ~= nil then
					player.character.character_inventory_slots_bonus = player.character.character_inventory_slots_bonus +10
					log("Give Inventory +10 to " .. slot10)
				end
            end
        end
    end
	if (name == "move_10") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local move10 = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[move10]) then
				if player ~= nil then
					player.character.character_running_speed_modifier = player.character.character_running_speed_modifier +0.10
					log("Give Movement 10% to " .. move10)
				end
            end
        end
    end
	if (name == "crafting_10") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local crafting10 = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[crafting10]) then
				if player ~= nil then
					player.force.manual_crafting_speed_modifier = player.force.manual_crafting_speed_modifier +0.10
					log("Give Crafting 10% to " .. crafting10)
				end
            end
        end
    end
	if (name == "cheat_modeON") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local cheatON = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[cheatON]) then
				if player ~= nil then
					player.character.cheat_mode=true
					log("Give cheat mode to " .. cheatON)
				end
            end
        end
    end
	if (name == "all_technologiesON") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local technologiesON = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[technologiesON]) then
				if player ~= nil then
					player.character.force.research_all_technologies()
					log("Give all technologies to " .. technologiesON)
				end
            end
        end
    end
	if (name == "all_recipesON") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local recipesON = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[recipesON]) then
				if player ~= nil then
					for name, recipe in pairs(player.character.force.recipes) do recipe.enabled = true end
					log("Give all recipes to " .. recipesON)
				end
            end
        end
    end
	if (name == "cheat_modeOFF") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local cheatOFF = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[cheatOFF]) then
				if player ~= nil then
					player.character.cheat_mode=false
					log("Remove cheat mode from " .. cheatOFF)
				end
            end
        end
    end
	if (name == "all_technologiesOFF") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local technologiesOFF = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[technologiesOFF]) then
				if player ~= nil then
					for _, tech in pairs(player.character.force.technologies) do 
						tech.researched=false
						player.character.force.set_saved_technology_progress(tech, 0)
					end
					log("Remove all technologies from " .. technologiesOFF)
				end
            end
        end
    end
	if (name == "all_recipesOFF") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index
		
        if (pIndex ~= 0) then
            local recipesOFF = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[recipesOFF]) then
				if player ~= nil then
					for name, recipe in pairs(player.character.force.recipes) do recipe.enabled = false end
					player.character.force.recipes["wooden-chest"].enabled=true
					player.character.force.recipes["iron-chest"].enabled=true
					player.character.force.recipes["transport-belt"].enabled=true
					player.character.force.recipes["burner-inserter"].enabled=true
					player.character.force.recipes["inserter"].enabled=true
					player.character.force.recipes["small-electric-pole"].enabled=true
					player.character.force.recipes["pipe"].enabled=true
					player.character.force.recipes["pipe-to-ground"].enabled=true
					player.character.force.recipes["stone-brick"].enabled=true
					player.character.force.recipes["repair-pack"].enabled=true
					player.character.force.recipes["boiler"].enabled=true
					player.character.force.recipes["steam-engine"].enabled=true
					player.character.force.recipes["burner-mining-drill"].enabled=true
					player.character.force.recipes["electric-mining-drill"].enabled=true
					player.character.force.recipes["stone-furnace"].enabled=true
					player.character.force.recipes["lab"].enabled=true
					player.character.force.recipes["iron-plate"].enabled=true
					player.character.force.recipes["copper-plate"].enabled=true
					player.character.force.recipes["copper-cable"].enabled=true
					player.character.force.recipes["iron-stick"].enabled=true
					player.character.force.recipes["iron-gear-wheel"].enabled=true
					player.character.force.recipes["electronic-circuit"].enabled=true
					player.character.force.recipes["automation-science-pack"].enabled=true
					player.character.force.recipes["pistol"].enabled=true
					player.character.force.recipes["firearm-magazine"].enabled=true
					player.character.force.recipes["light-armor"].enabled=true
					player.character.force.recipes["radar"].enabled=true
					log("Remove all recipes from " .. recipesOFF)
				end
            end
        end
    end
	if (name == "add_oreIRON") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local add_IRON = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[add_IRON]) then
				if player ~= nil then
					local surface=player.character.surface
					local ore=nil
					local size=5
					local density=10
						for y=-size, size do
							for x=-size, size do
								a=(size+1-math.abs(x))*10 + math.random(6, 24)
								b=(size+1-math.abs(y))*10 + math.random(6, 24)
								if a<b then
									ore=math.random(a*density-a*(density-8), a*density+a*(density-8))
								end
								if b<a then
									ore=math.random(b*density-b*(density-8), b*density+b*(density-8))
								end
								if surface.get_tile(player.position.x+x, player.position.y+y).collides_with("ground-tile") then
									surface.create_entity({name="iron-ore", amount=ore, position={player.position.x+x, player.position.y+y}})
								end
							end
						end
					log("Add iron patches around " .. add_IRON)
				end
            end
        end
    end
	if (name == "add_oreCOPPER") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local add_COPPER = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[add_COPPER]) then
				if player ~= nil then
					local surface=player.character.surface
					local ore=nil
					local density=10
							for y=-math.random(6, 24), math.random(6, 24) do
							for x=-math.random(6, 24), math.random(6, 24) do
								a=math.random(24, 60)
								b=math.random(24, 60)
								if a<b then
									ore=math.random(a*density-a*(density-8), a*density+a*(density-8))
								end
								if b<a then
									ore=math.random(b*density-b*(density-8), b*density+b*(density-8))
								end
								if surface.get_tile(player.character.position.x+x, player.character.position.y+y).collides_with("ground-tile") then
									surface.create_entity({name="copper-ore", amount=ore, position={player.character.position.x+x, player.character.position.y+y}})
								end
							end
						end
					log("Add copper patches around " .. add_COPPER)
				end
            end
        end
    end
	if (name == "add_oreSTONE") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local add_STONE = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[add_STONE]) then
				if player ~= nil then
					local surface=player.character.surface
					local ore=nil
					local density=10
							for y=-math.random(6, 24), math.random(6, 24) do
							for x=-math.random(6, 24), math.random(6, 24) do
								a=math.random(24, 60)
								b=math.random(24, 60)
								if a<b then
									ore=math.random(a*density-a*(density-8), a*density+a*(density-8))
								end
								if b<a then
									ore=math.random(b*density-b*(density-8), b*density+b*(density-8))
								end
								if surface.get_tile(player.character.position.x+x, player.character.position.y+y).collides_with("ground-tile") then
									surface.create_entity({name="stone", amount=ore, position={player.character.position.x+x, player.character.position.y+y}})
								end
							end
						end
					log("Add stone patches around " .. add_STONE)
				end
            end
        end
    end
	if (name == "add_oreCOAL") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local add_COAL = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[add_COAL]) then
				if player ~= nil then
					local surface=player.character.surface
					local ore=nil
					local density=10
							for y=-math.random(6, 24), math.random(6, 24) do
							for x=-math.random(6, 24), math.random(6, 24) do
								a=math.random(24, 60)
								b=math.random(24, 60)
								if a<b then
									ore=math.random(a*density-a*(density-8), a*density+a*(density-8))
								end
								if b<a then
									ore=math.random(b*density-b*(density-8), b*density+b*(density-8))
								end
								if surface.get_tile(player.character.position.x+x, player.character.position.y+y).collides_with("ground-tile") then
									surface.create_entity({name="coal", amount=ore, position={player.character.position.x+x, player.character.position.y+y}})
								end
							end
						end
					log("Add coal patches around " .. add_COAL)
				end
            end
        end
    end
	if (name == "add_oreURANIUM") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local add_URANIUM = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[add_URANIUM]) then
				if player ~= nil then
					local surface=player.character.surface
					local ore=nil
					local density=10
							for y=-math.random(6, 24), math.random(6, 24) do
							for x=-math.random(6, 24), math.random(6, 24) do
								a=math.random(24, 60)
								b=math.random(24, 60)
								if a<b then
									ore=math.random(a*density-a*(density-8), a*density+a*(density-8))
								end
								if b<a then
									ore=math.random(b*density-b*(density-8), b*density+b*(density-8))
								end
								if surface.get_tile(player.character.position.x+x, player.character.position.y+y).collides_with("ground-tile") then
									surface.create_entity({name="uranium-ore", amount=ore, position={player.character.position.x+x, player.character.position.y+y}})
								end
							end
						end
					log("Add uranium patches around " .. add_URANIUM)
				end
            end
        end
    end
	if (name == "add_OIL") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local add_OIL = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[add_OIL]) then
				if player ~= nil then
					for y=0,2 do
					for x=0,2 do
							player.character.surface.create_entity({name="crude-oil", amount=100000, position={player.character.position.x+x*7-7, player.character.position.y+y*7-7}})
						end
					end
					log("Add oil patches around " .. add_OIL)
				end
            end
        end
    end
	if (name == "remove_oreIRON") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local remove_IRON = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[remove_IRON]) then
				if player ~= nil then
					local surface=player.character.surface
					local size=2
					local pos=player.character.position

						for _, e in pairs(surface.find_entities_filtered{area={{pos.x-size, pos.y-size},{pos.x+size, pos.y+size}}, name="iron-ore"}) 
							do e.destroy() 
						end
					log("Remove iron patches around " .. remove_IRON)
				end
            end
        end
    end
	if (name == "remove_oreCOPPER") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local remove_COPPER = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[remove_COPPER]) then
				if player ~= nil then
					local surface=player.character.surface
					local size=2
					local pos=player.character.position

						for _, e in pairs(surface.find_entities_filtered{area={{pos.x-size, pos.y-size},{pos.x+size, pos.y+size}}, name="copper-ore"}) 
							do e.destroy() 
						end
					log("Remove copper patches around " .. remove_COPPER)
				end
            end
        end
    end
	if (name == "remove_oreSTONE") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local remove_STONE = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[remove_STONE]) then
				if player ~= nil then
					local surface=player.character.surface
					local size=2
					local pos=player.character.position

						for _, e in pairs(surface.find_entities_filtered{area={{pos.x-size, pos.y-size},{pos.x+size, pos.y+size}}, name="stone"}) 
							do e.destroy() 
						end
					log("Remove stone patches around " .. remove_STONE)
				end
            end
        end
    end
	if (name == "remove_oreCOAL") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local remove_COAL = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[remove_COAL]) then
				if player ~= nil then
					local surface=player.character.surface
					local size=2
					local pos=player.character.position

						for _, e in pairs(surface.find_entities_filtered{area={{pos.x-size, pos.y-size},{pos.x+size, pos.y+size}}, name="coal"}) 
							do e.destroy() 
						end
					log("Remove coal patches around " .. remove_COAL)
				end
            end
        end
    end
	if (name == "remove_oreURANIUM") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local remove_URANIUM = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[remove_URANIUM]) then
				if player ~= nil then
					local surface=player.character.surface
					local size=2
					local pos=player.character.position

						for _, e in pairs(surface.find_entities_filtered{area={{pos.x-size, pos.y-size},{pos.x+size, pos.y+size}}, name="uranium-ore"}) 
							do e.destroy() 
						end
					log("Remove uranium patches around " .. remove_URANIUM)
				end
            end
        end
    end
	if (name == "remove_OIL") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local remove_OIL = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[remove_OIL]) then
				if player ~= nil then
					local surface=player.character.surface
					local size=2
					local pos=player.character.position

						for _, e in pairs(surface.find_entities_filtered{area={{pos.x-size, pos.y-size},{pos.x+size, pos.y+size}}, name="crude-oil"}) 
							do e.destroy() 
						end
					log("Remove oil patches around " .. remove_OIL)
				end
            end
        end
    end
	if (name == "remove_CLIFF") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local remove_CLIFF = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[remove_CLIFF]) then
				if player ~= nil then
					local surface=player.character.surface
					local size=4
					local pos=player.character.position

						for _, e in pairs(surface.find_entities_filtered{area={{pos.x-size, pos.y-size},{pos.x+size, pos.y+size}}, type="cliff"}) 
							do e.destroy() 
						end
					log("Remove cliff around " .. remove_CLIFF)
				end
            end
        end
    end
	if (name == "remove_TREE") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local remove_TREE = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[remove_TREE]) then
				if player ~= nil then
					local surface=player.character.surface
					local size=4
					local pos=player.character.position

						for _, e in pairs(surface.find_entities_filtered{area={{pos.x-size, pos.y-size},{pos.x+size, pos.y+size}}, type="tree"}) 
							do e.destroy() 
						end
					log("Remove tree around " .. remove_TREE)
				end
            end
        end
    end
	if (name == "remove_SCRAP") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local remove_SCRAP = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[remove_SCRAP]) then
				if player ~= nil then
					local surface=player.character.surface
					local size=4
					local pos=player.character.position

						for _, e in pairs(surface.find_entities_filtered{area={{pos.x-size, pos.y-size},{pos.x+size, pos.y+size}}, name="mineable-wreckage"}) 
							do e.destroy() 
						end
					log("Remove scrap around " .. remove_SCRAP)
				end
            end
        end
    end
	if (name == "remove_WORM") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local remove_WORM = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[remove_WORM]) then
				if player ~= nil then
					local surface=player.character.surface
					local size=100
					local pos=player.character.position

						for _, e in pairs(surface.find_entities_filtered{area={{pos.x-size, pos.y-size},{pos.x+size, pos.y+size}}, type="turret"}) 
							do e.destroy() 
						end
					log("Remove worm around " .. remove_WORM)
				end
            end
        end
    end
	if (name == "remove_UNIT") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local remove_UNIT = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[remove_UNIT]) then
				if player ~= nil then
					local surface=player.character.surface
					local size=100
					local pos=player.character.position

						for _, e in pairs(surface.find_entities_filtered{area={{pos.x-size, pos.y-size},{pos.x+size, pos.y+size}}, type="unit"}) 
							do e.destroy() 
						end
					log("Remove biter and spitter around " .. remove_UNIT)
				end
            end
        end
    end
	if (name == "remove_NEST") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local remove_NEST = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[remove_NEST]) then
				if player ~= nil then
					local surface=player.character.surface
					local size=100
					local pos=player.character.position

						for _, e in pairs(surface.find_entities_filtered{area={{pos.x-size, pos.y-size},{pos.x+size, pos.y+size}}, type="unit-spawner"}) 
							do e.destroy() 
						end
					log("Remove biter and spitter nest around " .. remove_NEST)
				end
            end
        end
    end
	if (name == "tp_player_to_me") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index
		local bring_player_messages = {"Come here my friend!","Papers, please.","What are you up to?"}

        if (pIndex ~= 0) then
            local tp_to_me = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[tp_to_me]) then
				if player ~= nil then
					if player.driving == true then
						player.print("Target player is in a vehicle, teleport not available.", { r=0.88, g=0.88, b=0.88})
					return
					end	
				local pos = player.character.surface.find_non_colliding_position("character", player.character.position, 50, 1)
				if pos then
					player.teleport(pos, player.character.surface)
					game.print(player.name .. " has been teleported to " .. player.name .. ". " .. bring_player_messages[math.random(1, #bring_player_messages)], { r=0.98, g=0.66, b=0.22})
				end
					log("Teleport player to your location " .. tp_to_me)
				end
            end
        end
    end
	if (name == "tp_me_to_player") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index
		local go_to_player_messages = {"Papers, please.","What are you up to?"}

        if (pIndex ~= 0) then
            local tp_to_player = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[tp_to_player]) then
				if player ~= nil then
					local pos = player.surface.find_non_colliding_position("character", player.position, 50, 1)
						if pos then
							player.teleport(pos, player.surface)
							game.print(player.name .. " is visiting " .. player.name .. ". " .. go_to_player_messages[math.random(1, #go_to_player_messages)], { r=0.98, g=0.66, b=0.22})
						end
					log("Teleport you to player " .. tp_to_player)
				end
            end
        end
    end
	if (name == "spank_player") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index

        if (pIndex ~= 0) then
            local Spank_player = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[Spank_player]) then
				if player ~= nil then
					if player.character.health > 1 then player.character.damage(1, "player") end
					player.character.health = player.character.health - 5
					player.surface.create_entity({name = "water-splash", position = player.position})
					game.print(player.name .. " spanked " .. player.name, { r=0.98, g=0.66, b=0.22})
				end
				log("Spank player " .. Spank_player)
			end
        end
    end
	if (name == "damage_player") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index
		local damage_messages = {" recieved a love letter from "," recieved a strange package from "}

        if (pIndex ~= 0) then
            local Damage_player = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[Damage_player]) then
				if player ~= nil then
					if player.character.health > 1 then player.character.damage(1, "player") end
					if player.character.health > 1 then player.character.damage(1, "player") end
					player.character.health = player.character.health - 125
					player.surface.create_entity({name = "big-explosion", position = player.position})
					game.print(player.name .. damage_messages[math.random(1, #damage_messages)] .. player.name, { r=0.98, g=0.66, b=0.22})
				end
				log("Damage player " .. Damage_player)
			end
        end
    end
	if (name == "kill_player") then
        local pIndex = event.element.parent.ban_players_dropdown.selected_index
		local kill_messages = {" did not obey the law."," should not have triggered the admins."," did not respect authority."," had a strange accident."," was struck by lightning."}

        if (pIndex ~= 0) then
            local kill_PLAYER = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[kill_PLAYER]) then
				if player ~= nil then
					player.character.die("player")
					game.print(player.name .. kill_messages[math.random(1, #kill_messages)], { r=0.98, g=0.66, b=0.22})
					admin_only_message(player.name .. " killed " .. player.name)
				end
				log("Kill player " .. kill_PLAYER)
			end
        end
    end
	if (name == "remove_SPEAKER") then
        	local speakers = player.surface.find_entities_filtered({name = "programmable-speaker"})
			local counter = 0
			for i, speaker in pairs(speakers) do
				if speaker.parameters.playback_globally == true then
				speaker.surface.create_entity({name = "massive-explosion", position = speaker.position})
				speaker.die("player")
				counter = counter + 1
			end
		end
		if counter == 0 then return end
		if counter == 1 then
			game.print(player.name .. " has nuked " .. counter .. " global speaker.", { r=0.98, g=0.66, b=0.22})
		else
			game.print(player.name .. " has nuked " .. counter .. " global speakers.", { r=0.98, g=0.66, b=0.22})
		end
		log("Remove all global speaker")
    end
	if (name == "kill_ENEMY") then
        local surface=player.surface
			for key, entity in pairs(surface.find_entities_filtered({force="enemy"})) do
			entity.destroy()
			log("Kill all enemy")
		end
    end
	if (name == "remove_POLLUTION") then
		local pIndex = event.element.parent.ban_players_dropdown.selected_index
		
		if (pIndex ~= 0) then
            local Remove_pollution = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[Remove_pollution]) then
				if player ~= nil then
					player.surface.clear_pollution()
				end
				log("Remove pollution ".. Remove_pollution)
			end
		end
    end
	if (name == "add_POLLUTION") then
		local pIndex = event.element.parent.ban_players_dropdown.selected_index
		
		if (pIndex ~= 0) then
            local Add_pollution = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[Add_pollution]) then
				if player ~= nil then
					player.surface.pollute(player.position, 1000000)
				end
				log("Add a lot pollution to ".. Add_pollution)
			end
		end
    end
	if (name == "add_EVOLUTION1") then
        game.forces["enemy"].evolution_factor=0.1
		log("Set evolution to 0.1 ")
	end
	if (name == "add_EVOLUTION2") then
        game.forces["enemy"].evolution_factor=0.5
		log("Set evolution to 0.5 ")
	end
	if (name == "add_EVOLUTION3") then
        game.forces["enemy"].evolution_factor=1.0
		log("Set evolution to 1.0 ")
	end
	if (name == "add_EVOLUTION4") then
        game.forces["enemy"].evolution_factor = game.forces["enemy"].evolution_factor + 8
		log("Evolution + 8 ")
	end
	if (name == "peaceful_MODE_ON") then
		local pIndex = event.element.parent.ban_players_dropdown.selected_index
		
		if (pIndex ~= 0) then
            local peaceful_modeON = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[peaceful_modeON]) then
				if player ~= nil then
					player.surface.peaceful_mode = true
				end
				log("Give peaceful mode to ".. peaceful_modeON)
			end
		end
    end
	if (name == "peaceful_MODE_OFF") then
		local pIndex = event.element.parent.ban_players_dropdown.selected_index
		
		if (pIndex ~= 0) then
            local peaceful_modeOFF = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[peaceful_modeOFF]) then
				if player ~= nil then
					player.surface.peaceful_mode = false
				end
				log("Remove peaceful mode from ".. peaceful_modeOFF)
			end
		end
    end
	if (name == "biter_exp_ON") then
        game.map_settings.enemy_expansion.enabled = true
		log("Biter expansion ON ")
	end
	if (name == "biter_exp_OFF") then
        game.map_settings.enemy_expansion.enabled = false
		log("Biter expansion OFF ")
	end
	if (name == "god_ON") then
		local pIndex = event.element.parent.ban_players_dropdown.selected_index
		
		if (pIndex ~= 0) then
            local god_on = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[god_on]) then
				if player ~= nil then
					player.character.destroy()
					player.character=nil
					god = true
				end
				log("Give god mode to ".. god_on)
			end
		end
    end
	if (name == "god_OFF") then
		local pIndex = event.element.parent.ban_players_dropdown.selected_index
		
		if (pIndex ~= 0) then
            local god_off = event.element.parent.ban_players_dropdown.get_item(pIndex)
            if (game.players[god_off]) then
				if player ~= nil then
					if (god) then 
						player.create_character()
						god = false
					end
				end
				log("Remove god from ".. god_off)
			end
		end
    end
	
	--**SERVER**--
	
	--BITER
	if (name == "spawner_contains_biter_ON") then
        SPAWNERS_CONTAIN_BITERS = true
		log("Spawner contains biter ON")
	end
	if (name == "unearthing_biter_wreckage_ON") then
        UNEARTHING_BITERS_WRECKAGE = true
		log("Unearthing biter WRECKAGE ON")
	end
	if (name == "unearthing_biter_night_ON") then
        UNEARTHING_BITERS_NIGHT = true
		log("Unearthing biter NIGHT ON")
	end
	if (name == "spawner_contains_biter_OFF") then
        SPAWNERS_CONTAIN_BITERS = false
		log("Spawner contains biter OFF")
	end
	if (name == "unearthing_biter_wreckage_OFF") then
        UNEARTHING_BITERS_WRECKAGE = false
		log("Unearthing biter WRECKAGE OFF")
	end
	if (name == "unearthing_biter_night_OFF") then
        UNEARTHING_BITERS_NIGHT = false
		log("Unearthing biter NIGHT OFF")
	end
	if (name == "biter_double_HP_ON") then
        BITERS_DOUBLE_HP = true
		log("Biter double HP ON")
	end
	if (name == "biter_double_DMG_ON") then
        BITERS_DOUBLE_DAMAGE = true
		log("Biter double DMG ON")
	end
	if (name == "spawner_double_HP_ON") then
		SPAWNERS_DOUBLE_HP = true
		log("Spawner double HP ON")
	end
	if (name == "biter_double_HP_OFF") then
        BITERS_DOUBLE_HP = false
		log("Biter double HP OFF")
	end
	if (name == "biter_double_DMG_OFF") then
        BITERS_DOUBLE_DAMAGE = false
		log("Biter double DMG OFF")
	end
	if (name == "spawner_double_HP_OFF") then
		SPAWNERS_DOUBLE_HP = false
		log("Spawner double HP OFF")
	end
	if (name == "biter_splice_ON") then
		SPLICE = true
		log("Biter splice ON")
	end
	if (name == "biter_splice_OFF") then
		SPLICE = false
		log("Biter splice OFF")
	end
	if (name == "biter_splice_OFF") then
		SPLICE = false
		log("Biter splice OFF")
	end
	--COIN
	if (name == "markets_ON") then
		ENABLE_MARKETS = true
		log("Market ON")
	end
	if (name == "coin_bank_ON") then
		COIN_BANK_ENABLE = true
		log("Coin bank ON")
	end
	if (name == "coin_boost_ON") then
		COIN_BANK_ENABLE = true
		COIN_BOOST_ENABLE = true
		log("Coin boost ON")
	end
	if (name == "markets_OFF") then
		ENABLE_MARKETS = false
		log("Market OFF")
	end
	if (name == "coin_bank_OFF") then
		COIN_BANK_ENABLE = false
		COIN_BOOST_ENABLE = false
		log("Coin bank OFF")
	end
	if (name == "coin_boost_OFF") then
		COIN_BOOST_ENABLE = false
		log("Coin boost OFF")
	end
	if (name == "biter_yield_coins_ON") then
		BITERS_YIELD_COINS = true
		log("Biter yield coins ON")
	end
	if (name == "rock_yield_coins_ON") then
		ROCKS_YIELD_COINS_ENABLE = true
		log("Biter yield coins ON")
	end
	if (name == "wreckage_yield_coins_ON") then
		WRECKAGE_YIELD_COINS_ENABLE = true
		log("Wreckage yield coins ON")
	end
	if (name == "biter_yield_coins_OFF") then
		BITERS_YIELD_COINS = false
		log("Biter yield coins OFF")
	end
	if (name == "rock_yield_coins_Off") then
		ROCKS_YIELD_COINS_ENABLE = false
		log("Biter yield coins OFF")
	end
	if (name == "wreckage_yield_coins_OFF") then
		WRECKAGE_YIELD_COINS_ENABLE = false
		log("Wreckage yield coins OFF")
	end
	--TECH&SPAWNER
	if (name == "loader_tech_ON") then
		LOADERS_ENABLED = true
		log("Loader ON")
	end
	if (name == "railgun_tech_ON") then
		RAILGUN_ENABLED = true
		log("Railgun ON")
	end
	if (name == "loader_tech_OFF") then
		LOADERS_ENABLED = false
		log("Loader OFF")
	end
	if (name == "railgun_tech_OFF") then
		RAILGUN_ENABLED = false
		log("Railgun OFF")
	end
	if (name == "wreckage_spawner_ON") then
		ENABLE_WRECKAGE_SPAWNER = true
		log("Wreckage spwaner ON")
	end
	if (name == "crashsite_spawner_ON") then
		ENABLE_CRASHSITES = true
		log("Crashsite spwaner ON")
	end
	if (name == "wreckage_spawner_OFF") then
		ENABLE_WRECKAGE_SPAWNER = false
		log("Wreckage spwaner OFf")
	end
	if (name == "crashsite_spawner_OFF") then
		ENABLE_CRASHSITES = false
		log("Crashsite spwaner OFF")
	end
	--JUNK
	if (name == "mineable_wreckage_yield_scrap_ON") then
		MINEABLE_WRECKAGE_YIELDS_SCRAP = true
		log("Mineable wreckage yield scrap ON")
	end
	if (name == "junk_yield_ore_veins_ON") then
		JUNK_YIELD_ORE_VEINS_ENABLED = true
		log("Junk yield ore veins ON")
	end
	if (name == "mineable_wreckage_yield_scrap_OFF") then
		MINEABLE_WRECKAGE_YIELDS_SCRAP = false
		log("Mineable wreckage yield scrap OFF")
	end
	if (name == "junk_yield_ore_veins_OFF") then
		JUNK_YIELD_ORE_VEINS_ENABLED = false
		log("Junk yield ore veins OFF")
	end
	--HUNGER&FISH
	--NOT INCLUDED NOW!
	if (name == "hunger_ON") then
		ENABLE_HUNGER = true
		log("Hunger system ON")
	end
	if (name == "fish_respawner_ON") then
		ENABLE_FISH_RESPAWNER = true
		log("Fish respawner ON")
	end
	if (name == "piranha_ON") then
		ENABLE_PIRANHA = true
		log("Piranha ON")
	end
	if (name == "hunger_OFF") then
		ENABLE_HUNGER = false
		log("Hunger system OFF")
	end
	if (name == "fish_respawner_OFF") then
		ENABLE_FISH_RESPAWNER = false
		log("Fish respawner OFF")
	end
	if (name == "piranha_OFF") then
		ENABLE_PIRANHA = false
		log("Piranha OFF")
	end
	-- Advanced ADMIN controls WIP
	-- by Hansi-TWZ
	-- DE333-SERVER.EU
end

-- Used by AddOarcGuiTab
function CreateGameOptionsTab(tab_container, player)

    -- General Server Info:
    AddLabel(tab_container, "info_1", global.ocfg.welcome_msg, my_longer_label_style)
    AddLabel(tab_container, "info_2", global.ocfg.server_rules, my_longer_label_style)
    AddLabel(tab_container, "info_3", global.ocfg.server_contact, my_longer_label_style)
    AddSpacerLine(tab_container)

    -- Enemy Settings:
    local enemy_expansion_txt = "disabled"
    if game.map_settings.enemy_expansion.enabled then enemy_expansion_txt = "enabled" end

    local enemy_text="Server Run Time: " .. formattime_hours_mins(game.tick) .. "\n" ..
    "Current Evolution: " .. string.format("%.4f", game.forces["enemy"].evolution_factor) .. "\n" ..
    --"Enemy evolution time factor: " .. game.map_settings.enemy_evolution.time_factor .. "\n" ..
    --"Enemy evolution pollution factor: " .. game.map_settings.enemy_evolution.pollution_factor .. "\n" ..
    --"Enemy evolution destroy factor: " .. game.map_settings.enemy_evolution.destroy_factor .. "\n" ..
    "Enemy expansion is " .. enemy_expansion_txt

    AddLabel(tab_container, "enemy_info", enemy_text, my_longer_label_style)
    AddSpacerLine(tab_container)
	-- DE333 maps
	if (MAP_NORMAL) then AddLabel(tab_container, "map_normal", "[font=default-dropdown][color=0.9,0.7,0]MAP loaded:[/color] Normal[/font]", my_longer_label_style)end
	if (MAP_TOXIPLANET) then AddLabel(tab_container, "map_toxiplanet", "[font=default-dropdown][color=0.9,0.7,0]MAP loaded:[/color] Toxiplanet[/font]", my_longer_label_style)end
	if (MAP_REDDESERT) then AddLabel(tab_container, "map_reddessert", "[font=default-dropdown][color=0.9,0.7,0]MAP loaded:[/color] Red dessert[/font]", my_longer_label_style)end
	if (MAP_WOODY) then AddLabel(tab_container, "map_woody", "[font=default-dropdown][color=0.9,0.7,0]MAP:[/color] Woody[/font]", my_longer_label_style)end
	if (MAP_JUNKYARD) then AddLabel(tab_container, "map_junkyard", "[font=default-dropdown][color=0.9,0.7,0]MAP loaded:[/color] Junkyard[/font]", my_longer_label_style)end
	if (MAP_JUNKYARD_V2) then AddLabel(tab_container, "map_junkyardV2", "[font=default-dropdown][color=0.9,0.7,0]MAP loaded:[/color] Junkyard V2[/font]", my_longer_label_style)end
	if (MAP_SALTLAKE) then AddLabel(tab_container, "map_saltlake", "[font=default-dropdown][color=0.9,0.7,0]MAP loaded:[/color] Saltlake[/font]", my_longer_label_style)end
	AddLabel(tab_container, "map_spacer", "[font=default-dropdown][/font]", my_longer_label_style)
    -- Game Mode:
    AddLabel(tab_container, "core_mod_en", "[font=default-dropdown]Core game mode (separate spawns) is enabled.[/font]", my_longer_label_style)

    -- Soft Mods:
    local soft_mods_string = "[font=default-dropdown]Oarc Core[/font]"
    if (global.ocfg.enable_undecorator) then
        soft_mods_string = soft_mods_string .. "[font=default-dropdown], Undecorator[/font]"
    end
    if (global.ocfg.enable_tags) then
        soft_mods_string = soft_mods_string .. "[font=default-dropdown], Tags[/font]"
    end
    if (global.ocfg.enable_long_reach) then
        soft_mods_string = soft_mods_string .. "[font=default-dropdown], Long Reach[/font]"
    end
    if (global.ocfg.enable_autofill) then
        soft_mods_string = soft_mods_string .. "[font=default-dropdown], Auto Fill[/font]"
    end
    if (global.ocfg.enable_player_list) then
        soft_mods_string = soft_mods_string .. "[font=default-dropdown], Player List[/font]"
    end
    if (global.ocfg.enable_regrowth) then
        soft_mods_string = soft_mods_string .. "[font=default-dropdown], Regrowth[/font]"
    end
	
	if (LOADERS_ENABLED) then
        soft_mods_string = soft_mods_string .. "[font=default-dropdown], Loaders[/font]"
    end
	if (RAILGUN_ENABLED) then
        soft_mods_string = soft_mods_string .. "[font=default-dropdown], Railgun[/font]"
    end
	if (ENABLE_MARKETS) then
        soft_mods_string = soft_mods_string .. "[font=default-dropdown], Market[/font]"
    end
	if (COIN_BANK_ENABLE) then
        soft_mods_string = soft_mods_string .. "[font=default-dropdown], Bank[/font]"
    end
	if (COIN_BOOST_ENABLE) then
        soft_mods_string = soft_mods_string .. "[font=default-dropdown], Coin BOOST[/font]"
    end
	if (ENABLE_CRASHSITES) then
        soft_mods_string = soft_mods_string .. "[font=default-dropdown], Crashsites[/font]"
    end

    local game_info_str = "[font=default-dropdown]Soft Mods Enabled: [/font]" .. soft_mods_string

    -- Spawn options:
    if (global.ocfg.enable_separate_teams) then
        game_info_str = game_info_str.."\n".."[font=default-dropdown]You are allowed to spawn on your own team (have your own research tree). All teams are friendly![/font]"
    end
    if (global.ocfg.enable_vanilla_spawns) then
        game_info_str = game_info_str.."\n".."[font=default-dropdown]You are spawned in a default style starting area.[/font]"
    else
        game_info_str = game_info_str.."\n".."[font=default-dropdown]You are spawned with a fix set of starting resources.[/font]"
        if (global.ocfg.enable_buddy_spawn) then
            game_info_str = game_info_str.."\n".."[font=default-dropdown]You can chose to spawn alongside a buddy if you spawn together at the same time.[/font]"
        end
    end
    if (global.ocfg.enable_shared_spawns) then
        game_info_str = game_info_str.."\n".."[font=default-dropdown]Spawn hosts may choose to share their spawn and allow other players to join them.[/font]"
    end
    if (global.ocfg.enable_separate_teams and global.ocfg.enable_shared_team_vision) then
        game_info_str = game_info_str.."\n".."[font=default-dropdown]Everyone (all teams) have shared vision.[/font]"
    end
    if (global.ocfg.frontier_rocket_silo) then
        game_info_str = game_info_str.."\n".."[font=default-dropdown]Silos are only placeable in certain areas on the map![/font]"
    end
	if (LOADERS_ENABLED) then
        game_info_str = game_info_str.."\n".."[font=default-dropdown]Loader´s available with logistic research[/font]"
    end
	if (RAILGUN_ENABLED) then
        game_info_str = game_info_str.."\n".."[font=default-dropdown]Railgun available with laser turret research[/font]"
    end
	if (ENABLE_MARKETS) then
        game_info_str = game_info_str.."\n".."[font=default-dropdown]Market´s with random location on MAP. Mostly near biter´s[/font]"
    end
	if (COIN_BANK_ENABLE) then
        game_info_str = game_info_str.."\n".."[font=default-dropdown]Coin bank, your coin´s now save[/font]"
    end
	if (ENABLE_CRASHSITES) then
        game_info_str = game_info_str.."\n".."[font=default-dropdown]Crashsites with random loot spawns now on map[/font]"
    end
	if (COIN_BOOST_ENABLE) then
        game_info_str = game_info_str.."\n".."[font=default-dropdown]Coin BOOST.Inventory +5 and crafting +5% now on Markets[/font]"
    end
	if (UNEARTHING_BITERS_NIGHT) then
        game_info_str = game_info_str.."\n".."[font=default-dropdown]Unearthing biter´s at night. Stay near your lamps at night time![/font]"
    end
	if (DE333_SERVER_4) or (DE333_SERVER_2) or (DE333_SERVER_7) then
        game_info_str = game_info_str.."\n".."[font=default-dropdown]Hardcore biter´s make DOUBLE damage and have DOUBLE hp, biter spawner contain´s a many biter´s after death[/font]"
    end
	if (SPAWNERS_CONTAIN_ACID_ENABLED) then
        game_info_str = game_info_str.."\n".."[font=default-dropdown][color=1,0.1,0.1] !!NEW!! [/color]Biter nest´s spawn a lot of ACID after death[/font]"
    end
	if (SPITTER_CONTAIN_ACID_ENABLED) then
        game_info_str = game_info_str.."\n".."[font=default-dropdown][color=1,0.1,0.1] !!NEW!! [/color]Spitter spawn a lot of ACID after death[/font]"
    end
    if (global.ocfg.enable_regrowth) then
        game_info_str = game_info_str.."\n".."[font=default-dropdown][color=1,0.1,0.1]Old parts of the map will slowly be deleted over time (chunks without any player buildings).[/color][/font]"
    end
    if (ENABLE_POWER_ARMOR_QUICK_START) then
        game_info_str = game_info_str.."\n".."[font=default-dropdown]Power armor quick start enabled.[/font]"
    end
    if (global.ocfg.lock_goodies_rocket_launch) then
        game_info_str = game_info_str.."\n".."[font=default-dropdown]Artillery/Nukes/ArmorMK2 tech and Prod/Speed 3 module recipes are locked until you launch a rocket![/font]"
    end
	
	if (ENABLE_CREDITS) then
		game_info_str = game_info_str.."\n"..""
        game_info_str = game_info_str.."\n".."[font=default-dropdown][color=1,0.1,0.1]CREDITS:[/color][/font]"
		game_info_str = game_info_str.."\n".."[font=default-dropdown]Oarc[/font]"
		game_info_str = game_info_str.."\n".."[font=default-dropdown]MewMew (Comfy)[/font]"
    end



    AddLabel(tab_container, "game_info_label", game_info_str, my_longer_label_style)

    if (global.ocfg.enable_abandoned_base_removal) then
        AddLabel(tab_container, "leave_warning_msg", "If you leave within " .. global.ocfg.minimum_online_time .. " minutes of joining, your base and character will be deleted.", my_longer_label_style)
        tab_container.leave_warning_msg.style.font_color=my_color_red
    end

    -- Ending Spacer
    AddSpacerLine(tab_container)

    -- ADMIN CONTROLS
    if game.players["Hansi-TWZ"] or game.players["Etefix"] then
			local a = tab_container.add({type = "table", column_count = 3})

            player_list = {}
            for _,player in pairs(game.connected_players) do
                table.insert(player_list, player.name)
            end
			
			a.add{name="x_dummy", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][img=technology/atomic-bomb] Admin [img=technology/atomic-bomb][/font][/color]", tooltip = "Advanced ADMIN CONTROLS [color=0.7,0.0,0.0]!!!WIP!!![/color] use your POWER wisely.\n".."by Hansi-TWZ\n".."DE333-SERVER.EU"}
			a.add{name="x_dummy2", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="x_dummy3", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name ="ban_players_dropdown", type="drop-down", items = player_list}
			a.add{name="a_dummy", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="a_dummy2", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="player_dummy", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold] Player MENU [/font][/color]"}
			a.add{name="player_dummy2", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="player_dummy3", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="tp_player_to_me", type="button", caption="TP player ", tooltip = "Teleport selected player to your position."}
			a.add{name="tp_me_to_player", type="button", caption="TP me", tooltip = "Teleport you to selected player position."}
			a.add{name="player_dummy4", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="spank_player", type="button", caption="Spank player", tooltip = "Spank selected player. Can not kill him!"}
			a.add{name="damage_player", type="button", caption="DMG player", tooltip = "Damage selected player. Can not kill him!"}
			a.add{name="kill_player", type="button", caption="Kill player", tooltip = "Kill selected player."}
            a.add{name="ban_player", type="button", caption="Ban Player", tooltip = "Ban selected player."}
			a.add{name="kick_player", type="button", caption="Kick Player", tooltip = "Kick selected player."}
			a.add{name="restart_player", type="button", caption="Restart Player", tooltip = "Restart selected player."}
			a.add{name="peaceful_MODE_ON", type="button", caption="Peace [color=0.0,0.5,0.1]ON[/color]", tooltip = "Enabling peaceful mode on selected player, prevents biter attacks until provoked."}
			a.add{name="peaceful_MODE_OFF", type="button", caption="Peace [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Disable peaceful mode on selected player."}
			a.add{name="player_dummy5", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}	
			
			a.add{name="item_dummy", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold] Items MENU [/font][/color]"}
			a.add{name="item_dummy2", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="item_dummy3", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="modular_armor_player", type="button", caption="Modular Armor", tooltip = "Give Modular Armor to selected player."}    
			a.add{name="power_armor_player", type="button", caption="Power Armor", tooltip = "Give Power Armor to selected player."}
			a.add{name="item_dummy4", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="coins_100", type="button", caption="Give $ 100", tooltip = "Give 100 Coin´s to selected player."}
			a.add{name="coins_1k", type="button", caption="Give $ 1000", tooltip = "Give 1k Coin´s to selected player."}
			a.add{name="coins_10k", type="button", caption="Give $ 10 000", tooltip = "Give 10k Coin´s to selected player."}
			a.add{name="items_1", type="button", caption="Items #1", tooltip = "Give 1k Iron, Copper and Steel to selected player."}
			a.add{name="items_2", type="button", caption="Items #2", tooltip = "Give 1k Solid fuel, Sulfur and Engine´s to selected player."}
			a.add{name="items_3", type="button", caption="Items #3", tooltip = "Give 1k Concrete, Rail`s and Battery`s to selected player."}
			a.add{name="items_4", type="button", caption="Items #4", tooltip = "Give 1k Pipe, Underground pipe and Landfill to selected player."}
			a.add{name="items_5", type="button", caption="Items #5", tooltip = "Give 1k Cliff explosives and Explosives to selected player."}
			a.add{name="items_6", type="button", caption="Items #6", tooltip = "Give 1k Electric engines and Robot frame to selected player."}
			a.add{name="solar_kit", type="button", caption="Solar Kit", tooltip = "Give 160 Solar, 40 Akku´s and 5 Substation´s to selected player."}
			a.add{name="construction_kit", type="button", caption="Const. Kit", tooltip = "Give 50 Assembler Maschine`s 2, 100 Fast Inserter and 100 Medium electric pole´s to selected player."}
			a.add{name="construction_kit2", type="button", caption="Const. Kit 2", tooltip = "Give 50 Assembler Maschine`s 3, 100 Stack Inserter and 100 Medium electric pole´s to selected player."}
			a.add{name="smelting_kit", type="button", caption="Smelting Kit", tooltip = "Give 50 Stone furnaceand 100 Inserter to selected player."}
			a.add{name="smelting_kit2", type="button", caption="Smelting Kit 2", tooltip = "Give 50 Steel furnace and 100 fast Inserter to selected player."}
			a.add{name="smelting_kit3", type="button", caption="Smelting Kit 3", tooltip = "Give 50 Electric furnace and 100 stack Inserter to selected player."}
			
			a.add{name="boost_dummy", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold] Boost MENU [/font][/color]"}
			a.add{name="boost_dummy2", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="boost_dummy3", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="slot_10", type="button", caption="Inv. +10", tooltip = "Give +10 Inventory space."}
			a.add{name="move_10", type="button", caption="Move. +10%", tooltip = "Give +10% Movement speed."}
			a.add{name="crafting_10", type="button", caption="Crafting +10%", tooltip = "Give +10% Crafting speed."}
			
			a.add{name="cheat_dummy", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold] Cheat MENU [/font][/color]"}
			a.add{name="cheat_dummy2", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="cheat_dummy3", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="cheat_modeON", type="button", caption="Cheat Mode [color=0.0,0.5,0.1]ON[/color]", tooltip = "Allows for infinite free crafting."}
			a.add{name="all_technologiesON", type="button", caption="All Techs [color=0.0,0.5,0.1]ON[/color]", tooltip = "Unlock and research all technologies."}
			a.add{name="all_recipesON", type="button", caption="All Recipes [color=0.0,0.5,0.1]ON[/color]", tooltip = "Unlock all recipes."}
			a.add{name="cheat_modeOFF", type="button", caption="Cheat Mode [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Remove infinite free crafting."}
			a.add{name="all_technologiesOFF", type="button", caption="All Techs [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Remove all research and all technologies."}
			a.add{name="all_recipesOFF", type="button", caption="All Recipes [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Remove all recipes"}
			
			a.add{name="res_dummy", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold] Res. MENU [/font][/color]"}
			a.add{name="res_dummy2", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="res_dummy3", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="add_oreIRON", type="button", caption="[color=0.0,0.5,0.1]Add [/color][img=item.iron-ore]", tooltip = "Add iron around the selected player."}
			a.add{name="add_oreCOPPER", type="button", caption="[color=0.0,0.5,0.1]Add [/color][img=item.copper-ore]", tooltip = "Add copper around the selected player."}
			a.add{name="add_oreSTONE", type="button", caption="[color=0.0,0.5,0.1]Add [/color][img=item.stone]", tooltip = "Add stone around the selected player."}
			a.add{name="add_oreCOAL", type="button", caption="[color=0.0,0.5,0.1]Add [/color][img=item.coal]", tooltip = "Add coal around the selected player."}
			a.add{name="add_oreURANIUM", type="button", caption="[color=0.0,0.5,0.1]Add [/color][img=item.uranium-ore]", tooltip = "Add uranium around the selected player."}
			a.add{name="add_OIL", type="button", caption="[color=0.0,0.5,0.1]Add [/color][img=fluid.crude-oil]", tooltip = "Add oil around the selected player."}
			a.add{name="remove_oreIRON", type="button", caption="[color=0.7,0.0,0.0]Remove [/color][img=item.iron-ore]", tooltip = "Remove iron around the selected player Size 2x2."}
			a.add{name="remove_oreCOPPER", type="button", caption="[color=0.7,0.0,0.0]Remove [/color][img=item.copper-ore]", tooltip = "Remove copper around the selected player Size 2x2."}
			a.add{name="remove_oreSTONE", type="button", caption="[color=0.7,0.0,0.0]Remove [/color][img=item.stone]", tooltip = "Remove stone around the selected player Size 2x2."}
			a.add{name="remove_oreCOAL", type="button", caption="[color=0.7,0.0,0.0]Remove [/color][img=item.coal]", tooltip = "Remove coal around the selected player Size 2x2."}
			a.add{name="remove_oreURANIUM", type="button", caption="[color=0.7,0.0,0.0]Remove [/color][img=item.uranium-ore]", tooltip = "Remove uranium around the selected player Size 2x2."}
			a.add{name="remove_OIL", type="button", caption="[color=0.7,0.0,0.0]Remove [/color][img=fluid.crude-oil]", tooltip = "Remove oil around the selected player Size 2x2."}
			
			a.add{name="del_dummy", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold] Remove MENU [/font][/color]"}
			a.add{name="del_dummy2", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="del_dummy3", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="remove_CLIFF", type="button", caption="[color=0.7,0.0,0.0]Remove [/color][img=entity.cliff]", tooltip = "Remove cilff around the selected player. Size 4x4."}
			a.add{name="remove_TREE", type="button", caption="[color=0.7,0.0,0.0]Remove [/color][img=entity.tree-03]", tooltip = "Remove tree around the selected player. Size 4x4."}
			a.add{name="remove_SCRAP", type="button", caption="[color=0.7,0.0,0.0]Remove [/color][img=entity.mineable-wreckage]", tooltip = "Remove scrap around the selected player. Size 4x4."}
			a.add{name="remove_WORM", type="button", caption="[color=0.7,0.0,0.0]Remove [/color][img=entity.behemoth-worm-turret]", tooltip = "Remove worm around the selected player. Size 100x100."}
			a.add{name="remove_UNIT", type="button", caption="[color=0.7,0.0,0.0]Remove [/color][img=entity.behemoth-biter]", tooltip = "Remove biter and spitter around the selected player. Size 100x100."}
			a.add{name="remove_NEST", type="button", caption="[color=0.7,0.0,0.0]Remove [/color][img=entity.biter-spawner]", tooltip = "Remove biter and spitter nest around the selected player. Size 100x100."}
			
			a.add{name="biter_dummy", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold] Biter MENU [/font][/color]"}
			a.add{name="biter_dummy2", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="biter_dummy3", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="kill_ENEMY", type="button", caption="Kill all [img=entity.behemoth-spitter]", tooltip = "Kill all biter, nest and worm´s."}
			a.add{name="remove_POLLUTION", type="button", caption="Poll. -", tooltip = "Remove all pollution."}
			a.add{name="add_POLLUTION", type="button", caption="Poll. +", tooltip = "Add a lot pollution."}
			a.add{name="add_EVOLUTION1", type="button", caption="Evo. +", tooltip = "Set evolution to 0.1."}
			a.add{name="add_EVOLUTION2", type="button", caption="Evo. ++", tooltip = "Set evolution to 0.5."}
			a.add{name="add_EVOLUTION3", type="button", caption="Evo. +++", tooltip = "Set evolution to 1.0."}
			
			a.add{name="misc_dummy", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold] Misc MENU [/font][/color]"}
			a.add{name="misc_dummy2", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="misc_dummy3", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="remove_SPEAKER", type="button", caption="Remove [img=entity.programmable-speaker]", tooltip = "Remove global speaker."}
			a.add{name="misc_dummy4", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="misc_dummy5", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="biter_exp_ON", type="button", caption="Exp. [color=0.0,0.5,0.1]ON[/color]", tooltip = "Biter expansion ON."}
			a.add{name="biter_exp_OFF", type="button", caption="Exp. [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Biter expansion OFF."}
			a.add{name="misc_dummy6", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="god_ON", type="button", caption="God [color=0.0,0.5,0.1]ON[/color]", tooltip = "God mode removes your player character allowing you to fly over obstacles and take no damage."}
			a.add{name="god_OFF", type="button", caption="God [color=0.7,0.0,0.0]OFF[/color]", tooltip = "God mode OFF."}
			a.add{name="misc_dummy7", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}

			a.add{name="server_dummy", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="server_dummy2", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="server_dummy3", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="server_dummy4", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][img=technology/atomic-bomb] Server [img=technology/atomic-bomb][/font][/color]", tooltip = "All server confings here."}
			a.add{name="server_dummy5", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="server_dummy6", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="server_dummy7", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="server_dummy8", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="server_dummy9", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			
			a.add{name="biters_dummy", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][img=entity.behemoth-spitter] Biter[/font][/color]"}
			a.add{name="biters_dummy2", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="biters_dummy3", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="spawner_contains_biter_ON", type="button", caption="SCB [color=0.0,0.5,0.1]ON[/color]", tooltip = "Spawner contains biter ON."}
			a.add{name="unearthing_biter_wreckage_ON", type="button", caption="UB - W [color=0.0,0.5,0.1]ON[/color]", tooltip = "Unearthing biter on wreckage mined ON."}
			a.add{name="unearthing_biter_night_ON", type="button", caption="UB - N [color=0.0,0.5,0.1]ON[/color]", tooltip = "Unearthing biter at nighttime ON."}
			a.add{name="spawner_contains_biter_OFF", type="button", caption="SCB [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Spawner contains biter OFF."}
			a.add{name="unearthing_biter_wreckage_OFF", type="button", caption="UB - W [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Unearthing biter on wreckage mined OFF."}
			a.add{name="unearthing_biter_night_OFF", type="button", caption="UB - N [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Unearthing biter at nighttime OFF."}
			a.add{name="biter_double_HP_ON", type="button", caption="BDH [color=0.0,0.5,0.1]ON[/color]", tooltip = "Biter double HP ON."}
			a.add{name="biter_double_DMG_ON", type="button", caption="BDD [color=0.0,0.5,0.1]ON[/color]", tooltip = "Biter double DMG ON."}
			a.add{name="spawner_double_HP_ON", type="button", caption="SDH [color=0.0,0.5,0.1]ON[/color]", tooltip = "Spawner double HP ON."}
			a.add{name="biter_double_HP_OFF", type="button", caption="BDH [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Biter double HP OFF."}
			a.add{name="biter_double_DMG_OFF", type="button", caption="BDD [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Biter double DMG OFF."}
			a.add{name="spawner_double_HP_OFF", type="button", caption="SDH [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Spawner double HP OFF."}
			a.add{name="biter_splice_ON", type="button", caption="BS [color=0.0,0.5,0.1]ON[/color]", tooltip = "Biter splice ON."}
			a.add{name="biters_dummy4", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="biters_dummy5", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="biter_splice_OFF", type="button", caption="BS [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Biter splice OFF."}
			a.add{name="biters_dummy6", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="biters_dummy7", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			
			a.add{name="coins_dummy", type="label", caption="[color=1.0,0.8,0.2][img=item.coin][font=default-large-semibold] Coin [/font][/color]"}
			a.add{name="coins_dummy2", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="coins_dummy3", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="markets_ON", type="button", caption="M [color=0.0,0.5,0.1]ON[/color]", tooltip = "Markets ON."}
			a.add{name="coin_bank_ON", type="button", caption="CB [color=0.0,0.5,0.1]ON[/color]", tooltip = "Coin bank ON."}
			a.add{name="coin_boost_ON", type="button", caption="CBOO [color=0.0,0.5,0.1]ON[/color]", tooltip = "Coin boost ON."}
			a.add{name="markets_OFF", type="button", caption="M [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Markets OFF."}
			a.add{name="coin_bank_OFF", type="button", caption="CB [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Coin bank OFF."}
			a.add{name="coin_boost_OFF", type="button", caption="CBOO [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Coin boost OFF."}
			a.add{name="biter_yield_coins_ON", type="button", caption="BYC [color=0.0,0.5,0.1]ON[/color]", tooltip = "Biter yield coin´s ON."}
			a.add{name="rock_yield_coins_ON", type="button", caption="RYC [color=0.0,0.5,0.1]ON[/color]", tooltip = "Rock yield coin´s ON."}
			a.add{name="wreckage_yield_coins_ON", type="button", caption="WYC [color=0.0,0.5,0.1]ON[/color]", tooltip = "Wreckage yield coin´s ON."}
			a.add{name="biter_yield_coins_OFF", type="button", caption="BYC [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Biter yield coin´s OFF."}
			a.add{name="rock_yield_coins_OFF", type="button", caption="RYC [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Rock yield coin´s OFF."}
			a.add{name="wreckage_yield_coins_OFF", type="button", caption="WYC [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Wreckage yield coin´s OFF."}
			
			a.add{name="techspawner_dummy", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold] Tech & Spawner [/font][/color]"}
			a.add{name="techspawner_dummy2", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="techspawner_dummy3", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="loader_tech_ON", type="button", caption="Loader [color=0.0,0.5,0.1]ON[/color]", tooltip = "Loader ON."}
			a.add{name="railgun_tech_ON", type="button", caption="Railgun [color=0.0,0.5,0.1]ON[/color]", tooltip = "Railgun ON."}
			a.add{name="techspawner_dummy4", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="loader_tech_OFF", type="button", caption="Loader [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Loader OFF."}
			a.add{name="railgun_tech_OFF", type="button", caption="Railgun [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Railgun OFF."}
			a.add{name="techspawner_dummy5", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="wreckage_spawner_ON", type="button", caption="[img=entity.mineable-wreckage] Junk [color=0.0,0.5,0.1]ON[/color]", tooltip = "Wreckage spawner ON."}
			a.add{name="Crashsite_spawner_ON", type="button", caption="[img=entity.big-ship-wreck-1] Crash [color=0.0,0.5,0.1]ON[/color]", tooltip = "Crashsite spawner ON."}
			a.add{name="techspawner_dummy6", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="wreckage_spawner_OFF", type="button", caption="[img=entity.mineable-wreckage] Junk [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Wreckage spawner OFF."}
			a.add{name="Crashsite_spawner_OFF", type="button", caption="[img=entity.big-ship-wreck-1] Crash [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Crashsite spawner OFF."}
			a.add{name="techspawner_dummy7", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			
			a.add{name="junk_dummy", type="label", caption="[img=entity.mineable-wreckage][color=1.0,0.8,0.2][font=default-large-semibold] Junk [/font][/color]"}
			a.add{name="junk_dummy2", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="junk_dummy3", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="mineable_wreckage_yield_scrap_ON", type="button", caption="MWYS [color=0.0,0.5,0.1]ON[/color]", tooltip = "Mineable wreckage yield scrap ON."}
			a.add{name="junk_yield_ore_veins_ON", type="button", caption="JYOV [color=0.0,0.5,0.1]ON[/color]", tooltip = "Junk yield ore veins ON."}
			a.add{name="junk_dummy4", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			a.add{name="mineable_wreckage_yield_scrap_OFF", type="button", caption="MWYS [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Mineable wreckage yield scrap OFF."}
			a.add{name="junk_yield_ore_veins_OFF", type="button", caption="JYOV [color=0.7,0.0,0.0]OFF[/color]", tooltip = "Junk yield ore veins OFF."}
			a.add{name="junk_dummy5", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			-- a.add{name="hungerfish_dummy", type="label", caption="[img=entity.fish][color=1.0,0.8,0.2][font=default-large-semibold] Hunger&Fish [/font][/color]"}
			-- a.add{name="hungerfish_dummy2", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			-- a.add{name="hungerfish_dummy3", type="label", caption="[color=1.0,0.8,0.2][font=default-large-semibold][/font][/color]"}
			-- a.add{name="hunger_ON", type="button", caption="Hunger [color=0.0,0.5,0.1]ON[/color]", tooltip = "Hunger system ON."}
			-- a.add{name="fish_respawner_ON", type="button", caption="Fish [color=0.0,0.5,0.1]ON[/color]", tooltip = "Fish respawner ON."}
			-- a.add{name="piranha_ON", type="button", caption="Piranha [color=0.0,0.5,0.1]ON[/color]", tooltip = "Piranha ON."}
			-- a.add{name="hunger_OFF", type="button", caption="Hunger [color=0.0,0.5,0.1]OFF[/color]", tooltip = "Hunger system OFF."}
			-- a.add{name="fish_respawner_OFF", type="button", caption="Fish [color=0.0,0.5,0.1]OFF[/color]", tooltip = "Fish respawner OFF."}
			-- a.add{name="piranha_OFF", type="button", caption="Piranha [color=0.0,0.5,0.1]OFF[/color]", tooltip = "Piranha OFF."}
    elseif (player.admin) then
        player_list = {}
        for _,player in pairs(game.connected_players) do
            table.insert(player_list, player.name)
        end
        tab_container.add{name = "ban_players_dropdown",
                        type = "drop-down",
                        items = player_list}
        tab_container.add{name="ban_player", type="button", caption="Ban Player"}
		tab_container.add{name="kick_player", type="button", caption="Kick Player"}
        tab_container.add{name="restart_player", type="button", caption="Restart Player"}
    end
end