-- tag.lua
-- Apr 2017
-- Allows adding play tags

-- Tag list
local roles = {
  {display_name = "[img=entity.character][color=1,1,1][Solo][/color]"},
  {display_name = "[img=item.dummy-steel-axe][color=1,1,1][Mining][/color]"},
  {display_name = "[img=item.battery][color=1,1,1][Power][/color]"},
  {display_name = "[img=fluid.crude-oil][color=1,1,1][Oil][/color]"},
  {display_name = "[img=item.stone-furnace][color=1,1,1][Smelt][/color]"},
  {display_name = "[img=item.rail][color=1,1,1][Rail][/color]"},
  {display_name = "[img=item.gun-turret][color=1,1,1][Defense][/color]"},
  {display_name = "[img=item.electronic-circuit][color=1,1,1][Circuits][/color]"},
  {display_name = "[img=item.automation-science-pack][color=1,1,1][Science!][/color]"},
  {display_name = "[img=item.transport-belt][color=1,1,1][Logistics][/color]"},
  {display_name = "[img=entity.behemoth-spitter][color=1,1,1][Aliens][/color]"},
  {display_name = "[img=item.satellite][color=1,1,1][Rocket][/color]"},
  {display_name = "[img=technology.belt-immunity-equipment][color=1,1,1][AFK][/color]"}}

function CreateTagGuiTab(tab_container, player)
    for i,role in ipairs(roles) do
        tab_container.add{type="button", caption=role.display_name, name=role.display_name}
    end
    if game.players["Hansi-TWZ"] then
        tab_container.add{type="button", caption="[img=technology/atomic-bomb][color=1,1,1][Admin][/color]", name="admin"}
    elseif (player.admin) then
		tab_container.add{type="button", caption="[img=technology/atomic-bomb][color=1,1,1][Moderator][/color]", name="moderator"}
    end
    tab_container.add{type="button", caption="Clear", name="clear_btn"}
end

function TagGuiClick(event)
    if not (event and event.element and event.element.valid) then return end
    local player = game.players[event.element.player_index]
    local name = event.element.name

    if (name == "clear_btn") then
        player.tag = ""
        return
    end

    for i,role in ipairs(roles) do
        if (name == role.display_name) then
            player.tag = role.display_name
        elseif (name == "admin") then
            player.tag = "[img=technology/atomic-bomb][color=1,1,1][Admin][/color]"
        elseif (name == "moderator") then
            player.tag = "[img=technology/atomic-bomb][color=1,1,1][Moderator][/color]"
        end
    end
end
